<?php
if ( !class_exists( "PluginBuddyEmailBuddy_admin" ) ) {
    class PluginBuddyEmailBuddy_admin {
	
		function PluginBuddyEmailBuddy_admin(&$parent) {
			$this->_parent = &$parent;
			$this->_var = &$parent->_var;
			$this->_name = &$parent->_name;
			$this->_options = &$parent->_options;
			$this->_pluginPath = &$parent->_pluginPath;
			$this->_pluginURL = &$parent->_pluginURL;
			$this->_selfLink = &$parent->_selfLink;

			add_action( 'admin_menu', array( &$this, 'admin_menu' ) ); // Add menu in admin.
			add_action('wp_ajax_emailbuddy_export_emails', array(&$this, 'ajax_export_emails') );
			add_action('wp_ajax_emailbuddy_import_emails', array(&$this, 'ajax_import_emails') );
			
			// Button on post page related stuff...
			add_action( 'media_buttons_context', array( &$this, 'add_post_button' ) );
			if( in_array( basename( $_SERVER['PHP_SELF'] ), array( 'post.php', 'page.php', 'page-new.php', 'post-new.php' ) ) ) {
				add_action('admin_footer',  array( &$this, 'add_post_popup'));
			}
		}
		function alert( $arg1, $arg2 = false ) {
			$this->_parent->alert( $arg1, $arg2 );
		}
		function tip( $message, $title = '', $echo_tip = true ) {
			if ( $echo_tip === true ) {
				$this->_parent->tip( $message, $title = '', $echo_tip = true );
			} else {
				return $this->_parent->tip( $title = '', $message, $echo_tip = true );
			}
		}
		function nonce() {
			wp_nonce_field( $this->_parent->_var . '-nonce' );
		}
		function savesettings() {
			check_admin_referer( $this->_parent->_var . '-nonce' );
			
			foreach( $_POST as $index => $item ) {
				if ( substr( $index, 0, 1 ) == '#' ) {
					$savepoint = '$this->_options' . stripslashes( $_POST['savepoint'] );
					eval( $savepoint . '[\'' . substr( $index, 1 ) . '\'] = \'' . $item . '\';' );
				}
			}
			
			$this->_parent->save();
			$this->alert( 'Settings saved...' );
		}

		
		
		function admin_scripts() {
			//wp_enqueue_script( 'jquery' );
			wp_enqueue_script( 'pluginbuddy-tooltip-js', $this->_parent->_pluginURL . '/js/tooltip.js' );
			wp_print_scripts( 'pluginbuddy-tooltip-js' );
			wp_enqueue_script( 'pluginbuddy-swiftpopup-js', $this->_parent->_pluginURL . '/js/swiftpopup.js' );
			wp_print_scripts( 'pluginbuddy-swiftpopup-js' );
			wp_enqueue_script( 'pluginbuddy-'.$this->_var.'-admin-js', $this->_parent->_pluginURL . '/js/admin.js' );
			wp_print_scripts( 'pluginbuddy-'.$this->_var.'-admin-js' );
			echo '<link rel="stylesheet" href="'.$this->_pluginURL . '/css/admin.css" type="text/css" media="all" />';
		}

		/**
		 *	get_feed()
		 *
		 *	Gets an RSS or other feed and inserts it as a list of links...
		 *
		 *	$feed		string		URL to the feed.
		 *	$limit		integer		Number of items to retrieve.
		 *	$append		string		HTML to include in the list. Should usually be <li> items including the <li> code.
		 *	$replace	string		String to replace in every title returned. ie twitter includes your own username at the beginning of each line.
		 */
		function get_feed( $feed, $limit, $append = '', $replace = '' ) {
			require_once(ABSPATH.WPINC.'/feed.php');
			$rss = fetch_feed( $feed );
			if (!is_wp_error( $rss ) ) {
				$maxitems = $rss->get_item_quantity( $limit ); // Limit 
				$rss_items = $rss->get_items(0, $maxitems); 
				
				echo '<ul class="pluginbuddy-nodecor">';

				$feed_html = get_transient( md5( $feed ) );
				if ( $feed_html == '' ) {
					foreach ( (array) $rss_items as $item ) {
						$feed_html .= '<li>- <a href="' . $item->get_permalink() . '">';
						$title =  $item->get_title(); //, ENT_NOQUOTES, 'UTF-8');
						if ( $replace != '' ) {
							$title = str_replace( $replace, '', $title );
						}
						if ( strlen( $title ) < 30 ) {
							$feed_html .= $title;
						} else {
							$feed_html .= substr( $title, 0, 32 ) . ' ...';
						}
						$feed_html .= '</a></li>';
					}
					set_transient( md5( $feed ), $feed_html, 300 ); // expires in 300secs aka 5min
				}
				echo $feed_html;
				
				echo $append;
				echo '</ul>';
			} else {
				echo 'Temporarily unable to load feed...';
			}
		}

		function view_gettingstarted() {
			if ( isset( $_GET['go'] ) ) {
				if ( file_exists( $this->_pluginPath . '/classes/view_' . $_GET['go'] . '.php' ) ) {
					require_once( $this->_pluginPath . '/classes/view_' . $_GET['go'] . '.php' );
				} else {
					echo 'Invalid page for this PluginBuddy plugin.';
				}
			} else {
				require_once( $this->_pluginPath . '/classes/view_gettingstarted.php' );
			}
		}
		
		function view_settings() {
			require_once( $this->_pluginPath . '/classes/view_settings.php' );
		}
		
		function view_events() {
			require_once( $this->_pluginPath . '/classes/view_events.php' );
		}
		
		function view_series() {
			require_once( $this->_pluginPath . '/classes/view_series.php' );
		}
		
		
		function view_groups() {
			require_once( $this->_pluginPath . '/classes/view_groups.php' );
		}
		
		function view_messages() {
			require_once( $this->_pluginPath . '/classes/view_messages.php' );
		}
		
		function view_tools() {
			require_once( $this->_pluginPath . '/classes/view_tools.php' );
		}
		
		/** admin_menu()
		 *
		 * Initialize menu for admin section.
		 *
		 */		
		function admin_menu() {
			// Add main menu (default when clicking top of menu)
			add_menu_page($this->_parent->_name.' Getting Started', $this->_parent->_name, 'administrator', $this->_parent->_var, array(&$this, 'view_gettingstarted'), $this->_parent->_pluginURL.'/images/emailbuddy.png');
			// Add sub-menu items (first should match default page above)
			add_submenu_page( $this->_parent->_var, $this->_parent->_name.' Getting Started', 'Getting Started', 'administrator', $this->_parent->_var, array(&$this, 'view_gettingstarted'));

			
			add_submenu_page( $this->_parent->_var, $this->_parent->_name.' Messages', 'Messages', 'administrator', $this->_parent->_var.'-messages', array(&$this, 'view_messages'));			
			add_submenu_page( $this->_parent->_var, $this->_parent->_name.' Groups', 'Groups', 'administrator', $this->_parent->_var.'-groups', array(&$this, 'view_groups'));
			add_submenu_page( $this->_parent->_var, $this->_parent->_name.' Events', 'Events', 'administrator', $this->_parent->_var.'-events', array(&$this, 'view_events'));
			//add_submenu_page( $this->_parent->_var, $this->_parent->_name.' Series', 'Series', 'administrator', $this->_parent->_var.'-series', array(&$this, 'view_series'));

			add_submenu_page( $this->_parent->_var, $this->_parent->_name.' Tools', 'Tools', 'administrator', $this->_parent->_var.'-tools', array(&$this, 'view_tools'));			
			add_submenu_page( $this->_parent->_var, $this->_parent->_name.' Settings', 'Settings', 'administrator', $this->_parent->_var.'-settings', array(&$this, 'view_settings'));
		}

		function print_autoadd( $this_type = '', $autoadd_event, $autoadd_group, $autoadd_series ) {
			global $wpdb;
			
			echo '<table>';
			
			if ( $this_type != '0' ) {
				echo '<tr><td>Event:</td><td>';
				echo '<select name="autoadd_event">';
				echo '<option value="">Select event ... </option>';
				$results = $wpdb->get_results( "SELECT id, title FROM " . $wpdb->prefix . "ebud_events ORDER BY title ASC" );
				foreach ( (array) $results as $id => $item ) {
					echo '<option value="' . $item->id . '"';
					if ( $autoadd_event == $item->id ) { echo ' selected'; }
					echo '>' . $item->title . '</option>';
				}
				echo '</select>';
				echo '</td></tr>';
			}
			
			if ( $this_type != '1' ) {
				echo '<tr><td>Group:</td><td>';
				echo '<select name="autoadd_group">';
				echo '<option value="">Select group ... </option>';
				$results = $wpdb->get_results( "SELECT id, title FROM " . $wpdb->prefix . "ebud_groups ORDER BY title ASC" );
				foreach ( (array) $results as $id => $item ) {
					echo '<option value="' . $item->id . '"';
					if ( $autoadd_group == $item->id ) { echo ' selected'; }
					echo '>' . $item->title . '</option>';
				}
				echo '</select>';
				echo '</td></tr>';
			}
			
			/*
			if ( $this_type != '2' ) {
				echo '<tr><td>Series:</td><td>';
				echo '<select name="autoadd_series">';
				echo '<option value="">Select series ... </option>';
				$results = $wpdb->get_results( "SELECT id, title FROM " . $wpdb->prefix . "ebud_series ORDER BY title ASC" );
				foreach ( (array) $results as $id => $item ) {
					echo '<option value="' . $item->id . '"';
					if ( $autoadd_series == $item->id ) { echo ' selected'; }
					echo '>' . $item->title . '</option>';
				}
				echo '</select>';
				echo '</td></tr>';
			}
			*/
			
			echo '</table>';
		}
		
		
		function add_post_button( $content ){
			return $content . '<a href="post.php#TB_inline?inlineId=emailbuddy_post_form" class="thickbox" title="Add EmailBuddy Subscribe Form"><img src="' . $this->_pluginURL . '/images/media_email.gif" alt="Add EmailBuddy Subscribe Form" /></a>';
		}
		function add_post_popup(){
			?>
			<script>
				function eb_add_post() {
					
					var eb_list_arr = jQuery( '#eb_list' ).val();
					
					eb_list_arr = eb_list_arr.split( '-' );
					if ( eb_list_arr[0] == '0' ) {
						var eb_type = 'event';
					} else if ( eb_list_arr[0] == '1' ) {
						var eb_type = 'group';
					} else if ( eb_list_arr[0] == '2' ) {
						var eb_type = 'series';
					}
					var eb_list = eb_list_arr[1];
					
					var eb_button = jQuery( '#eb_button' ).val();
					if ( eb_button == '' ){
						alert( 'Please enter text for the submit button.' );
						return;
					}
					
					var eb_confirmation = jQuery( '#eb_confirmation' ).val();
					if( eb_confirmation == '' ){
						alert( 'Please enter text or a redirection URL for subscription confirmation.' );
						return;
					}
					
					var eb_text = jQuery( '#eb_text' ).val();
					if( eb_text != '' ){
						eb_text = ' text="' + eb_text + '"';
					}
					
					if( jQuery( '#custom_inputs_name' ).attr('checked') ){
						eb_custom = ' custom_inputs="name"';
					} else {
						eb_custom = '';
					}
					
					
					
					
					var win = window.dialogArguments || opener || parent || top;
					win.send_to_editor( '[emailbuddy type="' + eb_type + '" list="' + eb_list + '" button="' + eb_button + '" confirmation="' + eb_confirmation + '"' + eb_text + eb_custom + ']' );
				}
			</script>

			<div id="emailbuddy_post_form" style="display:none;">
				<div class="wrap">
					<h3 class="media-title">Add EmailBuddy Subscribe Form</h3>
					
					
					
					
					
					<style type="text/css">
						optgroup option {
							margin-left: 10px;
						}
						.widefat {
							style="width: 100%; padding: 4px;"
						}
					</style>

					<table style="width: 100%;">
						<tr>
							<td>
								<label for="eb_list">List to subscribe to</label>
							</td>
							<td>
								<select class="widefat" id="eb_list" name="eb_list">
									
									<?php
									global $wpdb;

									
									echo '<optgroup label="Events">';
									$results = $wpdb->get_results( "SELECT id,title FROM " . $wpdb->prefix . "ebud_events ORDER BY title ASC" );
									foreach ( (array) $results as $id => $item ) {
										echo '<option value="0-' . $item->id . '"';
										echo '>' . stripslashes( $item->title ) . ' (' . $item->id . ')</option>';
									}
									unset( $results );
									echo '</optgroup>';
									
									echo '<optgroup label="Groups">';
									$results = $wpdb->get_results( "SELECT id,title FROM " . $wpdb->prefix . "ebud_groups ORDER BY title ASC" );
									foreach ( (array) $results as $id => $item ) {
										echo '<option value="1-' . $item->id . '"';
										echo '>' . stripslashes( $item->title ) . ' (' . $item->id . ')</option>';
									}
									unset( $results );
									echo '</optgroup>';
									

									?>

								</select>
							</td>
						</tr>
						<tr>
							<td>
								<label for="eb_button">Submit button text</label>
							</td>
							<td>
								<input class="widefat" id="eb_button" name="eb_button" type="text" value="Subscribe" />
							</td>
						</tr>
						<tr>
							<td>
								<label for="eb_confirmation">Confirmation text <i>or</i> redirect URL</label>
							</td>
							<td>
								<input style="width: 100%; padding: 4px;" id="eb_confirmation" name="eb_confirmation" type="text" value="Thank you for subscribing!" />
							</td>
						</tr>
						<tr>
							<td>
								<label for="eb_text">Input form text (optional)</label>
							</td>
							<td>
								<input style="width: 100%; padding: 4px;" id="eb_text" name="eb_text" type="text" value="" />
							</td>
						</tr>
						<tr>
							<td>
								<label for="eb_custom_inputs">Custom form inputs</label>
							</td>
							<td>
								<?php
								$this->_parent->load();
								foreach( $this->_options['custom_inputs'] as $custom_inputs_name => $custom_inputs ) {
									echo '<label for="custom_inputs_' . $custom_inputs_name . '"><input type="checkbox" name="custom_inputs_' . $custom_inputs_name . '" id="custom_inputs_' . $custom_inputs_name . '" /> ' . $custom_inputs[0] . '</label>';
								}
								?>
							</td>
						</tr>
					</table>
					
					<p>
						<input type="button" class="button-primary" value="Insert Subscription Form" onclick="eb_add_post();"/>
						<a class="button" href="#" onclick="tb_remove(); return false;">Cancel</a>
					</p>
				</div>
			</div>
			
			<?php
		}
		
		
		function ajax_export_emails() {
			global $wpdb;
			$output = '';
			
			$results = $wpdb->get_results( "SELECT email FROM " . $wpdb->prefix . "ebud_subscribers" );
				foreach ( (array) $results as $id => $item ) {
					$output .= $item->email . "\r\n";
				}
			unset( $results );

			header( 'Content-Description: File Transfer' );
			header( 'Content-Type: text/plain; name=emailbuddy.txt' );
			header( 'Content-Disposition: attachment; filename=emailbuddy.txt' );
			header( 'Expires: 0' );
			header( 'Content-Length: ' . strlen( $output ) );

			flush();

			echo $output;
			
			die();
		}
		
		// Imports email into each event
		function ajax_import_this_line( $email ) {
			$lists = array();
			if ( isset( $_POST['lists'] ) ) {
				$lists = $_POST['lists'];
			} else {
				echo 'ERROR: You must select a list to import into!';
			}
			foreach( $lists as $id => $item ) {
				$event = split( '-', $item );
				
				if ( $event[0] == '0' ) {
					if ( $this->_parent->subscribe_event( $email, $event[1], true ) ) {
						$this->success_count++;
					} else {
						$this->fail_count++;
					}
				} elseif ( $event[0] == '1' ) {
					if ( $this->_parent->subscribe_group( $email, $event[1], true ) ) {
						$this->success_count++;
					} else {
						$this->fail_count++;
					}
				} elseif ( $event[0] == '2' ) {
					if ( $this->_parent->subscribe_series( $email, $event[1], true ) ) {
						$this->success_count++;
					} else {
						$this->fail_count++;
					}
				}
			}
		}
		
		function ajax_import_emails() {
			$this->success_count = 0;
			$this->fail_count = 0;
			
			// Loop through file
			$handle = @fopen( $_FILES['uploadedfile']['tmp_name'], 'r' );
			if ($handle) {
				while (!feof($handle)) {
					$email = trim( fgets($handle, 4096) );
					$this->ajax_import_this_line( $email );
				}
				fclose($handle);
			}
			
			// Loop through textarea
			$emails = split( "\r", $_POST['emails'] );
			foreach( $emails as $id => $email ) {
				$this->ajax_import_this_line( trim( $email ) );
			}
			
			echo '<h3>Importing emails into EmailBuddy ...</h3>';
			echo 'Emails Imported: ' . $this->success_count;
			echo '<br />';
			echo 'Emails Skipped: ' . $this->fail_count;
			echo '<br /><br /><br />';
			echo '<a href="' . htmlentities( $_POST['return_url'] ) . '">Click here to return to the EmailBuddy Tools page.</a>';
			die();
		}
		
		
    } // End class
	
	$PluginBuddyEmailBuddy_admin = new PluginBuddyEmailBuddy_admin($this); // Create instance
}
