<?php


$this->_parent->load();
$this->admin_scripts();

wp_enqueue_script( 'ithemes-custom-ui-js', $this->_pluginURL . '/js/jquery.custom-ui.js' );
wp_print_scripts( 'ithemes-custom-ui-js' );
wp_enqueue_script( 'ithemes-timepicker-js', $this->_pluginURL . '/js/timepicker.js' );
wp_print_scripts( 'ithemes-timepicker-js' );
echo '<link rel="stylesheet" href="'.$this->_pluginURL . '/css/ui-smoothness/jquery-ui-1.8.2.custom.css" type="text/css" media="all" />';

global $wpdb;

if ( isset( $_POST['delete_events'] ) ) {
	foreach ( (array) $_POST['items'] as $id => $item ) {
		// Remove cronjobs
		$this->_parent->cron_recur_event( $wpdb->escape( $item ), true );
		
		$wpdb->query( "DELETE FROM " . $wpdb->prefix . "ebud_events WHERE id='" . $wpdb->escape( $item ) . "' LIMIT 1" );
		// Clean up anything that auto-added this event.
		$wpdb->query( "UPDATE " . $wpdb->prefix . "ebud_groups SET autoadd_event='' WHERE autoadd_event='" . $wpdb->escape( $item ) . "'" );
		// Remove subscriptions to this list.
		$wpdb->query( "DELETE FROM " . $wpdb->prefix . "ebud_subscriptions WHERE sub_type='0' AND subscribed_id='" . $wpdb->escape( $item ) . "'" );
	}
	$this->alert( 'Deleted ' . count( $_POST['items'] ) . ' events. All associated subscriptions have been removed.');
}

$welcome_message = '';
$reminder1_message = '';
$reminder2_message = '';
$reminder3_message = '';

if ( !empty( $_POST['save'] ) ) {
	if ( ( $_POST['title'] == 'Enter event name here' ) || ( $_POST['title'] == '' ) ) {
		$this->alert( 'Please enter an event name.' );
	} else {
		$title = $wpdb->escape( $_POST['title'] );
		$autoadd_group = '';
		$autoadd_series = '';
		if ( isset( $_POST['autoadd_group'] ) ) {
			$autoadd_group = $wpdb->escape( $_POST['autoadd_group'] );
		}
		if ( isset( $_POST['autoadd_series'] ) ) {
			$autoadd_series = $wpdb->escape( $_POST['autoadd_series'] );
		}
		$recur_amount = $wpdb->escape( $_POST['recur_amount'] );
		$recur_unit = $wpdb->escape( $_POST['recur_unit'] );
		$initial_date = strtotime( $_POST['initial_date'] );
		// Adjust for any timezone offsets we used for display (subtract):
		$initial_date = $initial_date - ( get_option( 'gmt_offset' ) * 3600 );
		
		$reminder1_amount = $wpdb->escape( $_POST['reminder1_amount'] );
		if ( isset( $reminder1_amount ) ) { $reminder1_unit = $wpdb->escape( $_POST['reminder1_unit'] ); }
		$reminder2_amount = $wpdb->escape( $_POST['reminder2_amount'] );
		if ( isset( $reminder2_amount ) ) { $reminder2_unit = $wpdb->escape( $_POST['reminder2_unit'] ); }
		$reminder3_amount = $wpdb->escape( $_POST['reminder3_amount'] );
		if ( isset( $reminder3_amount ) ) { $reminder3_unit = $wpdb->escape( $_POST['reminder3_unit'] ); }
		
		$reminder1_message = $wpdb->escape( $_POST['reminder1_message'] );
		$reminder2_message = $wpdb->escape( $_POST['reminder2_message'] );
		$reminder3_message = $wpdb->escape( $_POST['reminder3_message'] );
		
		//$welcome_message = $wpdb->escape( $_POST['welcome_message'] );
		$welcome_message = '';
		
		$results = $wpdb->get_var( "SELECT count(id) FROM " . $wpdb->prefix . "ebud_events WHERE title='" . $title . "'" );
		if ( $results > 0 ) {
			$this->alert( 'Error: This event title already exists.', true );
		} else {
			if ( ( $title == '' ) ) {
				$this->alert( 'Error: Event name is required.', true );
			} else {
				$wpdb->query( "INSERT INTO " . $wpdb->prefix . "ebud_events ( title, created, autoadd_group, autoadd_series, reminder1_amount, reminder1_unit, reminder2_amount, reminder2_unit, reminder3_amount, reminder3_unit, recur_amount, recur_unit, initial_date, reminder1_message, reminder2_message, reminder3_message, welcome_message ) VALUES( '" . $title . "', NOW(), '" . $autoadd_group . "', '" . $autoadd_series . "', '" . $reminder1_amount . "', '" . $reminder1_unit . "', '" . $reminder2_amount . "', '" . $reminder2_unit . "', '" . $reminder3_amount . "', '" . $reminder3_unit . "', '" . $recur_amount . "', '" . $recur_unit . "', from_unixtime(" . $initial_date . "), '" . $reminder1_message . "', '" . $reminder2_message . "', '" . $reminder3_message . "', '" . $welcome_message . "' )" );
				$event_id = $wpdb->get_var( "SELECT id FROM " . $wpdb->prefix . "ebud_events WHERE title='" . $title . "'" );
				
				// Set up cron stuff...
				$this->_parent->cron_recur_event( $event_id );
				
				$this->alert( 'New event successfully saved.' );
			}
		}
	}
}
if ( !empty( $_POST['edit'] ) ) {
	$title = $wpdb->escape( $_POST['title'] );
	$autoadd_group = '';
	$autoadd_series = '';
	if ( isset( $_POST['autoadd_group'] ) ) {
		$autoadd_group = $wpdb->escape( $_POST['autoadd_group'] );
	}
	if ( isset( $_POST['autoadd_series'] ) ) {
		$autoadd_series = $wpdb->escape( $_POST['autoadd_series'] );
	}
	$recur_amount = $wpdb->escape( $_POST['recur_amount'] );
	$recur_unit = $wpdb->escape( $_POST['recur_unit'] );
	$initial_date = strtotime( $_POST['initial_date'] ) + ( get_option( 'gmt_offset' ) * 3600 ); // added end stuff handles timezone
	
	$reminder1_message = $wpdb->escape( $_POST['reminder1_message'] );
	$reminder2_message = $wpdb->escape( $_POST['reminder2_message'] );
	$reminder3_message = $wpdb->escape( $_POST['reminder3_message'] );
	
	// ToDo: set for adding and auto response after validating
	// $welcome_message = $wpdb->escape( $_POST['welcome_message'] );
	$welcome_message = '';
	
	$reminder1_amount = $wpdb->escape( $_POST['reminder1_amount'] );
	if ( isset( $reminder1_amount ) ) { $reminder1_unit = $wpdb->escape( $_POST['reminder1_unit'] ); }
	$reminder2_amount = $wpdb->escape( $_POST['reminder2_amount'] );
	if ( isset( $reminder2_amount ) ) { $reminder2_unit = $wpdb->escape( $_POST['reminder2_unit'] ); }
	$reminder3_amount = $wpdb->escape( $_POST['reminder3_amount'] );
	if ( isset( $reminder3_amount ) ) { $reminder3_unit = $wpdb->escape( $_POST['reminder3_unit'] ); }
	
	
	if ( ( $title == '' ) ) {
		$this->alert( 'Error: Event name is required.', true );
	} else {
		$wpdb->query( "UPDATE " . $wpdb->prefix . "ebud_events SET title='" . $title . "', autoadd_group='" . $autoadd_group . "', autoadd_series='" . $autoadd_series . "', reminder1_amount='" . $reminder1_amount . "', reminder1_unit='" . $reminder1_unit . "', reminder2_amount='" . $reminder2_amount . "', reminder2_unit='" . $reminder2_unit . "', reminder3_amount='" . $reminder3_amount . "', reminder3_unit='" . $reminder3_unit . "', reminder1_message='" . $reminder1_message . "', reminder2_message='" . $reminder2_message . "', reminder3_message='" . $reminder3_message . "', welcome_message='" . $welcome_message . "', initial_date=from_unixtime(" . $initial_date . ") WHERE id='" . $wpdb->escape( $_GET['edit'] ) . "' LIMIT 1" );
		
		// Update cron stuff.
		$this->_parent->cron_recur_event( $wpdb->escape( $_GET['edit'] ) );
		
		$this->alert( 'Event changes successfully saved.' );
	}
}
?>

<div class="wrap">
	
	
	<?php if ( !isset( $_GET['edit'] ) ) { ?>
		<h2><?php echo $this->_name; ?> Events</h2>
		

		<form id="posts-filter" enctype="multipart/form-data" method="post" action="<?php echo $this->_selfLink; ?>-events">
			<div class="tablenav">
				<div class="alignleft actions">
					<input type="submit" name="delete_events" value="Delete" class="button-secondary delete" />
				</div>
			</div>
			<table class="widefat">
				<thead>
					<tr class="thead">
						<th scope="col" class="check-column"><input type="checkbox" class="check-all-entries" /></th>
						<th>Event</th>
						<th>Members</th>
						<th>Reminders</th>
						<th>Event Date</th>
						<th>Created</th>
					</tr>
				</thead>
				<tfoot>
					<tr class="thead">
						<th scope="col" class="check-column"><input type="checkbox" class="check-all-entries" /></th>
						<th>Event</th>
						<th>Members</th>
						<th>Reminders</th>
						<th>Event Date</th>
						<th>Created</th>
					</tr>
				</tfoot>
				<tbody>
					<?php
					$results = $wpdb->get_results( "SELECT id,title,UNIX_TIMESTAMP(created) as created,reminder1_amount,reminder1_unit,reminder2_amount,reminder2_unit,reminder3_amount,reminder3_unit,UNIX_TIMESTAMP(initial_date) as initial_date,recur_amount,recur_unit FROM " . $wpdb->prefix . "ebud_events ORDER BY created ASC" );
					
					if ( empty( $results ) ) {
						echo '<tr class="entry-row alternate"><td colspan="6" align="center" style="font-style: italic;">You have not created any events. You may add new events below.</td></tr>';
					}
					
					foreach ( (array) $results as $id => $item ) {
						?>
						<tr class="entry-row alternate" id="entry-<?php echo $item->id; ?>">
							<th scope="row" class="check-column"><input type="checkbox" name="items[]" class="entries" value="<?php echo $item->id; ?>" /></th>
							<td>
								<?php echo stripslashes( $item->title ); ?>
								<div class="row-actions" style="margin:0; padding:0;">
									<a href="<?php echo $this->_selfLink; ?>-events&edit=<?php echo $item->id; ?>">Edit Event</a>
									|
									<a href="<?php echo $this->_selfLink; ?>&go=broadcast&type=0&id=<?php echo $item->id; ?>&title=<?php echo urlencode( $item->title ); ?>">Broadcast</a>
								</div>
							</td>
							<td>
								<?php
								// TODO: Use transient to store this number since this query could become large...
								echo $wpdb->get_var( "SELECT count(id) FROM " . $wpdb->prefix . "ebud_subscriptions WHERE sub_type='0' AND subscribed_id='" . $item->id . "'" );
								?>
								<div class="row-actions" style="margin:0; padding:0;">
									<a href="<?php echo $this->_selfLink; ?>&go=subscribers&type=0&id=<?php echo $item->id; ?>">Manage</a>
								</div>
							</td>
							<td style="white-space: nowrap;">
							<?php
							if ( $item->reminder1_amount != '' ) {
								echo $item->reminder1_amount . ' ' . $item->reminder1_unit;
							}
							if ( $item->reminder2_amount != '' ) {
								echo ', ' . $item->reminder2_amount . ' ' . $item->reminder2_unit;
							}
							if ( $item->reminder3_amount != '' ) {
								echo ', ' . $item->reminder3_amount . ' ' . $item->reminder3_unit;
							}
							?>
							</td>
							<td style="white-space: nowrap;"><?php
							echo date( $this->_parent->_timestamp . ' ' . get_option( 'gmt_offset' ), $item->initial_date + ( get_option( 'gmt_offset' ) * 3600 ) );
							if ( ( $item->recur_amount != '' ) && ( $item->recur_amount != '0' ) ) {
									//echo '<br />Repeats ' . $item->recur_amount . ' ' . $item->recur_unit;
									echo '<br />';
									if ( $item->recur_unit != '' ) {
										echo 'Repeats ' . $item->recur_unit;
									} else { // doesnt recur
										echo 'Non-repeating';
									}
							}
							?></td>
							<td style="white-space: nowrap;"><?php echo date( $this->_parent->_timestamp . ' ' . get_option( 'gmt_offset' ), $item->created + ( get_option( 'gmt_offset' ) * 3600 ) ); ?></td>
						</tr>
						<?php
					}
					?>
				</tbody>
			</table>
			<div class="tablenav">
				<div class="alignleft actions">
					<input type="submit" name="delete_events" value="Delete" class="button-secondary delete" />
				</div>
			</div>
			<?php $this->nonce(); ?>
		</form>
		
	<?php
		echo '<h3>Add New Event</h3>';
		$subject = '';
		$body = '';
		//$initial_date = date('m/d/Y h:i a',(time()+86400));
		$initial_date = date('m/d/Y h:i a',(time() + ( get_option( 'gmt_offset' ) * 3600) ) );
	} else {
		echo '<h2>' . $this->_name . ' Events (<a href="' . $this->_selfLink . '-events">events home</a>)</h2>';
		echo '<h3>Edit Event</h3>';
		$results = $wpdb->get_row( "SELECT *,UNIX_TIMESTAMP(initial_date) AS initial_date FROM " . $wpdb->prefix . "ebud_events WHERE id='" . $wpdb->escape( $_GET['edit'] ) . "' LIMIT 1", ARRAY_A );
		if ( empty( $results ) ) {
			$this->alert( 'Unable to find this event to edit.', true );
		} else {
			/*
			$title = $results->title;
			$initial_date = $results->initial_date;
			$recur_amount = $results->recur_amount;
			$recur_unit
			*/
			extract( $results );
			
			$initial_date = date('m/d/Y h:i a',($initial_date - ( get_option( 'gmt_offset' ) * 3600) ) );
			//echo 'yo'.$title;
		}
	}
	
	if ( !empty( $title ) ) {
		$title = stripslashes( $title );
	}
	?>
	<form method="post" action="<?php echo $this->_selfLink; ?>-events<?php if ( isset( $_GET['edit'] ) ) { echo '&edit=' . $_GET['edit']; } ?>">
		<div class="fullwidth">
			<input class="prompt biginput" style="width: 50%;" type="text" name="title" maxlength="45" value="<?php if ( isset( $title ) ) { echo stripslashes( $title ); } ?>" alt="Enter event name here" /><br /><br />
		</div>
		
		Event Date:
		<span>
			<input type="text" name="initial_date" id="ithemes_datetime" value="<?php echo $initial_date; ?>">
			<small>mm/dd/yyyy hh:mm [am/pm] &middot; Currently <code><?php echo date( 'm/d/Y h:i a ' . get_option( 'gmt_offset' ), time() + ( get_option( 'gmt_offset' ) * 3600 ) ); ?> UTC</code> based on <a href="<?php echo admin_url( 'options-general.php' ); ?>">WordPress settings</a>.</small>
		</span>
		<br /><br />
		
		This event should automatically repeat 
		<!--
		<input type="text" name="recur_amount" value="<?php if ( isset( $recur_amount ) ) { echo $recur_amount; } ?>" size="4" maxlength="4" />
		-->
		<input type="hidden" name="recur_amount" value="1" />
		<select name="recur_unit">
		<?php if ( !isset( $recur_unit ) ) { $recur_unit = ''; } ?>
			<option value="" <?php if ( $recur_unit == '' ) { echo 'selected'; } ?>>never</option>
			<option value="hourly" <?php if ( $recur_unit == 'hourly' ) { echo 'selected'; } ?>>hourly</option>
			<option value="daily" <?php if ( $recur_unit == 'daily' ) { echo 'selected'; } ?>>daily</option>
			<option value="weekly" <?php if ( $recur_unit == 'weekly' ) { echo 'selected'; } ?>>weekly</option>
			<option value="monthly" <?php if ( $recur_unit == 'monthly' ) { echo 'selected'; } ?>>monthly</option>
			<option value="yearly" <?php if ( $recur_unit == 'yearly' ) { echo 'selected'; } ?>>yearly</option>
		</select>.<br />

		<?php
		$message_list = '';
		$message_list_1 = '';
		$message_list_2 = '';
		$message_list_3 = '';
		$message_list .= '<option value="">Select message ... </option>';
		$results = $wpdb->get_results( "SELECT id, title FROM " . $wpdb->prefix . "ebud_messages ORDER BY title ASC" );
		foreach ( (array) $results as $id => $item ) {
			$message_list .= '<option value="' . $item->id . '">' . $item->title . '</option>';
			
			// Set the currently selected items...
			if ( $item->id == $welcome_message ) {
				$message_list_welcome = '<option value="' . $item->id . '" selected>' . $item->title . '</option>';
			}
			if ( $item->id == $reminder1_message ) {
				$message_list_1 = '<option value="' . $item->id . '" selected>' . $item->title . '</option>';
			}
			if ( $item->id == $reminder2_message ) {
				$message_list_2 = '<option value="' . $item->id . '" selected>' . $item->title . '</option>';
			}
			if ( $item->id == $reminder3_message ) {
				$message_list_3 = '<option value="' . $item->id . '" selected>' . $item->title . '</option>';
			}
		}
		
		/*
		echo '<p>';
		echo 'Welcome email <a class="pluginbuddy_tip" title=" - If double opt-in is enabled then this welcome message will be sent after the user has completed the opt-in process.">(?)</a>(optional): ';
		echo '<select name="welcome_message">';
		echo $message_list_welcome;
		echo $message_list;
		echo '</select>';
		echo '</p>';
		*/
		
		?>
		
		<p>
		Send reminder emails at the following times <i>before</i> the event ...
		</p>
		
		
		
		
		<input class="reminder" id="reminder1" type="text" name="reminder1_amount" value="<?php if ( isset( $reminder1_amount ) ) { echo $reminder1_amount; } ?>" size="4" maxlength="4" />
		<select name="reminder1_unit">
			<?php if ( !isset( $reminder1_unit ) ) { $reminder1_unit = ''; } ?>
			<option value="hourly" <?php if ( $reminder1_unit == 'hourly' ) { echo 'selected'; } ?>>hours</option>
			<option value="daily" <?php if ( $reminder1_unit == 'daily' ) { echo 'selected'; } ?>>days</option>
			<option value="weekly" <?php if ( $reminder1_unit == 'weekly' ) { echo 'selected'; } ?>>weeks</option>
			<option value="monthly" <?php if ( $reminder1_unit == 'monthly' ) { echo 'selected'; } ?>>months</option>
			<option value="yearly" <?php if ( $reminder1_unit == 'yearly' ) { echo 'selected'; } ?>>years</option>
		</select>
		<?php
		echo '<span id="reminder1_hidden">';
		echo '<select name="reminder1_message">';
		echo $message_list_1;
		echo $message_list;
		echo '</select>';
		echo '</span>';
		?>
		<br />
		
		<input class="reminder" id="reminder2" type="text" name="reminder2_amount" value="<?php if ( isset( $reminder2_amount ) ) { echo $reminder2_amount; } ?>" size="4" maxlength="4" />
		<select name="reminder2_unit">
			<?php if ( !isset( $reminder2_unit ) ) { $reminder2_unit = ''; } ?>
			<option value="hourly" <?php if ( $reminder2_unit == 'hourly' ) { echo 'selected'; } ?>>hours</option>
			<option value="daily" <?php if ( $reminder2_unit == 'daily' ) { echo 'selected'; } ?>>days</option>
			<option value="weekly" <?php if ( $reminder2_unit == 'weekly' ) { echo 'selected'; } ?>>weeks</option>
			<option value="monthly" <?php if ( $reminder2_unit == 'monthly' ) { echo 'selected'; } ?>>months</option>
			<option value="yearly" <?php if ( $reminder2_unit == 'yearly' ) { echo 'selected'; } ?>>years</option>
		</select>
		<?php
		echo '<span id="reminder2_hidden">';
		echo '<select name="reminder2_message">';
		echo $message_list_2;
		echo $message_list;
		echo '</select>';
		echo '</span>';
		?>
		<br />
		
		<input class="reminder" id="reminder3" type="text" name="reminder3_amount" value="<?php if ( isset( $reminder3_amount ) ) { echo $reminder3_amount; } ?>" size="4" maxlength="4" />
		<select name="reminder3_unit">
			<?php if ( !isset( $reminder3_unit ) ) { $reminder3_unit = ''; } ?>
			<option value="hourly" <?php if ( $reminder3_unit == 'hourly' ) { echo 'selected'; } ?>>hours</option>
			<option value="daily" <?php if ( $reminder3_unit == 'daily' ) { echo 'selected'; } ?>>days</option>
			<option value="weekly" <?php if ( $reminder3_unit == 'weekly' ) { echo 'selected'; } ?>>weeks</option>
			<option value="monthly" <?php if ( $reminder3_unit == 'monthly' ) { echo 'selected'; } ?>>months</option>
			<option value="yearly" <?php if ( $reminder3_unit == 'yearly' ) { echo 'selected'; } ?>>years</option>
		</select>
		<?php
		echo '<span id="reminder3_hidden">';
		echo '<select name="reminder3_message">';
		echo $message_list_3;
		echo $message_list;
		echo '</select>';
		echo '</span>';
		?>
		<br />
		
		<br />
		Automatically add subscribers of this event to the following ...
		<p>
		<?php
		if ( !isset( $autoadd_event ) ) { $autoadd_event = ''; }
		if ( !isset( $autoadd_group ) ) { $autoadd_group = ''; }
		if ( !isset( $autoadd_series ) ) { $autoadd_series = ''; }
		$this->print_autoadd( 0, $autoadd_event, $autoadd_group, $autoadd_series ); ?>
		</p>
		
		<p class="submit">
		<?php if ( !isset( $_GET['edit'] ) ) { ?>
			<input type="submit" name="save" value="Add Event" class="button-primary" id="save" />
		<?php } else { ?>
			<input type="submit" name="edit" value="Edit Event" class="button-primary" id="save" />
		<?php } ?>
		</p>

		
		<?php $this->nonce(); ?>
	</form>
	
</div>
