<?php
// Needed for fancy boxes...
wp_enqueue_style('dashboard');
wp_print_styles('dashboard');
wp_enqueue_script('dashboard');
wp_print_scripts('dashboard');
// Load scripts and CSS used on this page.
$this->admin_scripts();

// If they clicked the button to reset plugin defaults...
if (!empty($_POST['reset_defaults'])) {
	$this->_options = $this->_parent->_defaults;
	$this->_parent->save();
	$this->_parent->alert( 'Plugin settings have been reset to defaults.' );
}

if (!empty($_POST['reset_database'])) {
	$message = '';
	
	global $wpdb;
	
	$wpdb->query( "DELETE from " . $wpdb->prefix . "ebud_events" );
	$message .= 'Deleted events... ';
	$wpdb->query( "DELETE from " . $wpdb->prefix . "ebud_groups" );
	$message .= 'Deleted groups... ';
	$wpdb->query( "DELETE from " . $wpdb->prefix . "ebud_messages" );
	$message .= 'Deleted messages... ';
	$wpdb->query( "DELETE from " . $wpdb->prefix . "ebud_queue" );
	$message .= 'Deleted queue... ';
	//$wpdb->query( "DELETE from " . $wpdb->prefix . "ebud_series" );
	//$message .= 'Deleted series... ';
	$wpdb->query( "DELETE from " . $wpdb->prefix . "ebud_subscribers" );
	$message .= 'Deleted subscribers... ';
	$wpdb->query( "DELETE from " . $wpdb->prefix . "ebud_subscriptions" );
	$message .= 'Deleted subscriptions... ';
	
	$this->_parent->alert( 'Plugin database has been reset. ' . $message );
}
?>

<div class="wrap">
	<div class="postbox-container" style="width:70%;">
		<h2>Getting Started with <?php echo $this->_parent->_name; ?> v<?php echo $this->_parent->_version; ?></h2>
		
		<?php
			if ( $this->_options['return_name'] == 'Matt Danger' ) {
				$this->_parent->alert( 'Currently using default settings. Please <a href="' . $this->_selfLink . '-settings">configure EmailBuddy settings</a>.' );
			}
		?>
		
		
		
		<p>
			<h3>Messages</h3>
			<div style="padding-left: 15px;">
				Messages are the email messages that you will be sending to users.  Set up your messages before creating events. Messages may contain variables
				that will be updated by EmailBuddy upon sending.
			</div>
			
			<h3>Groups</h3>
			<div style="padding-left: 15px;">
				Groups function as containers for organizing subscribers.  Users may subscribe to a group directly or be automatically subscribed when subscribing to an Event.
				Additionally you can send newsletter broadcasts on a per group basis.
				An example of group usage would be to have all subscribers of a baseball event be automatically subscribers to a Sports group.
			</div>
			
			<h3>Events</h3>
			<div style="padding-left: 15px;">
				Events allows you to schedule reminder emails for one-time or recurring events. Up to three email reminders may be sent per scheduled event.
			</div>
			
			<h3>Subscription Forms</h3>
			<div style="padding-left: 15px;">
				You may include subscription forms in Widgets and Shortcodes.  To insert a subscription form in a post, click the EmailBuddy icon above your post editor.
			</div>
			
			<h3>Manually Subscribing/Unsubscribing Users</h3>
			<div style="padding-left: 15px;">
				<b>Unsubscribe</b><br />
				While viewing a group or event hover your mouse over a row to reveal a "Manage" link under the number of members for that list. Clicking this will allow you to select members to unsubscribe from this list.
				<br /><br />
				<b>Subscribe</b><br />
				Navigate to the Tools page and select the Import Emails tab. You may then upload a text file of emails or enter them in the text box. You may also manually validate emails here when double opt-in is used..
			</div>
			
			<!--
			<h3>Series</h3>
			Series function as auto-responders, sending a series or emails at scheduled intervals to subscribers.
			-->
			
			<br /><br />
			<a href="http://www.ftc.gov/bcp/edu/pubs/business/ecommerce/bus61.shtm" style="text-decoration: none;" target="_new"><small>(!) United States organizations should verify CAN-SPAM Compliance with this guide for legal protection.</small></a>
			
			<br /><br />
		</p>
		
		
		
		
		
		
		<h3>Version History</h3>
		<textarea rows="7" cols="65"><?php readfile( $this->_parent->_pluginPath . '/history.txt' ); ?></textarea>
		<br /><br />
		<script type="text/javascript">
			jQuery(document).ready(function() {
				jQuery("#pluginbuddy_debugtoggle").click(function() {
					jQuery("#pluginbuddy_debugtoggle_div").slideToggle();
				});
			});
		</script>
		
		<a id="pluginbuddy_debugtoggle" class="button secondary-button">Debugging Information</a>
		<div id="pluginbuddy_debugtoggle_div" style="display: none;">
			
			<h3>Debugging Information</h3>
			<b>Logs:</b><br />
			<textarea rows="7" cols="65"><?php
			if ( file_exists( WP_CONTENT_DIR . '/uploads/emailbuddy.txt' ) ) {
				readfile( WP_CONTENT_DIR . '/uploads/emailbuddy.txt' );
			} else {
				echo 'Nothing logged yet...';
			}
			?></textarea>
			<br />
			<b>Debugging:</b><br />
			<?php
			echo '<textarea rows="7" cols="65">';
			echo 'Plugin Version = '.$this->_name.' '.$this->_parent->_version.' ('.$this->_parent->_var.')'."\n";
			echo 'WordPress Version = '.get_bloginfo("version")."\n";
			echo 'PHP Version = '.phpversion()."\n";
			global $wpdb;
			echo 'DB Version = '.$wpdb->db_version()."\n";
			echo "\n".serialize($this->_options);
			echo '</textarea>';
			?>
			<p>
			<form method="post" action="<?php echo $this->_selfLink; ?>">
				<input type="hidden" name="reset_defaults" value="true" />
				<input type="submit" name="submit" value="Reset Plugin Settings & Defaults" id="reset_defaults" class="button secondary-button" onclick="if ( !confirm('WARNING: This will reset all settings associated with this plugin to their defaults. Are you sure you want to do this?') ) { return false; }" />
			</form>
			
			<form method="post" action="<?php echo $this->_selfLink; ?>">
				<input type="hidden" name="reset_database" value="true" />
				<input type="submit" name="submit" value="Delete all Database Data" id="reset_database" class="button secondary-button" onclick="
					if ( !confirm('WARNING: This will DELETE ALL DATA including emails, groups, events, subscriptions, etc. Are you sure you want to do this? This CANNOT be undone!') ) {
						return false;
					}
					if ( !confirm('Are you absolutely positive you want to do this? Make sure you have backed up all data before continuing or you may regret this. This is permanent.') ) {
						return false;
					}
				" />
			</form>
			
			</p>
		</div>
		<br /><br /><br />
		<a href="http://pluginbuddy.com" style="text-decoration: none;"><img src="<?php echo $this->_pluginURL; ?>/images/pluginbuddy.png" style="vertical-align: -3px;" /> PluginBuddy.com</a><br /><br />
	</div>
	<div class="postbox-container" style="width:20%; margin-top: 35px; margin-left: 15px;">
		<div class="metabox-holder">	
			<div class="meta-box-sortables">
				
				<div id="breadcrumbslike" class="postbox">
					<div class="handlediv" title="Click to toggle"><br /></div>
					<h3 class="hndle"><span>Things to do...</span></h3>
					<div class="inside">
						<ul class="pluginbuddy-nodecor">
							<li>- <a href="http://twitter.com/home?status=<?php echo urlencode('Check out this awesome plugin, ' . $this->_parent->_name . '! ' . $this->_parent->_url . ' @pluginbuddy'); ?>" title="Share on Twitter" onClick="window.open(jQuery(this).attr('href'),'ithemes_popup','toolbar=0,status=0,width=820,height=500,scrollbars=1'); return false;">Tweet about this plugin.</a></li>
							<li>- <a href="http://pluginbuddy.com/purchase/">Check out PluginBuddy plugins.</a></li>
							<li>- <a href="http://ithemes.com/purchase/">Check out iThemes themes.</a></li>
							<li>- <a href="http://secure.hostgator.com/cgi-bin/affiliates/clickthru.cgi?id=ithemes">Get HostGator web hosting.</a></li>
						</ul>
					</div>
				</div>

				<div id="breadcrumsnews" class="postbox">
					<div class="handlediv" title="Click to toggle"><br /></div>
					<h3 class="hndle"><span>Latest news from PluginBuddy</span></h3>
					<div class="inside">
						<p style="font-weight: bold;">PluginBuddy.com</p>
						<?php $this->get_feed( 'http://pluginbuddy.com/feed/', 5 );  ?>
						<p style="font-weight: bold;">Twitter @pluginbuddy</p>
						<?php
						$twit_append = '<li>&nbsp;</li>';
						$twit_append .= '<li><img src="'.$this->_pluginURL.'/images/twitter.png" style="vertical-align: -3px;" /> <a href="http://twitter.com/pluginbuddy/">Follow @pluginbuddy on Twitter.</a></li>';
						$twit_append .= '<li><img src="'.$this->_pluginURL.'/images/feed.png" style="vertical-align: -3px;" /> <a href="http://pluginbuddy.com/feed/">Subscribe to RSS news feed.</a></li>';
						$twit_append .= '<li><img src="'.$this->_pluginURL.'/images/email.png" style="vertical-align: -3px;" /> <a href="http://pluginbuddy.com/subscribe/">Subscribe to Email Newsletter.</a></li>';
						$this->get_feed( 'http://twitter.com/statuses/user_timeline/108700480.rss', 5, $twit_append, 'pluginbuddy: ' );
						?>
					</div>
				</div>
				
				<div id="breadcrumbssupport" class="postbox">
					<div class="handlediv" title="Click to toggle"><br /></div>
					<h3 class="hndle"><span>Need support?</span></h3>
					<div class="inside">
						<p>See our <a href="http://pluginbuddy.com/tutorials/">tutorials & videos</a> or visit our <a href="http://pluginbuddy.com/support/">support forum</a> for additional information and help.</p>
					</div>
				</div>
				
			</div>
		</div>
	</div>
</div>