<?php
$this->_parent->load();
$this->admin_scripts();

global $wpdb;

if ( isset( $_POST['delete_groups'] ) ) {
	foreach ( (array) $_POST['items'] as $id => $item ) {
		$wpdb->query( "DELETE FROM " . $wpdb->prefix . "ebud_groups WHERE id='" . $wpdb->escape( $item ) . "' LIMIT 1" );
		// Clean up anything that auto-added this group.
		//$wpdb->query( "UPDATE " . $wpdb->prefix . "ebud_groups SET autoadd_group='' WHERE autoadd_group='" . $wpdb->escape( $item ) . "'" );
	}
	$this->alert( 'Deleted ' . count( $_POST['items'] ) . ' groups.');
}

if ( !empty( $_POST['save'] ) ) {
	if ( ( $_POST['title'] == 'Enter group name here' ) || ( $_POST['title'] == '' ) ) {
		$this->alert( 'Please enter a group name.' );
	} else {
		$title = $wpdb->escape( $_POST['title'] );
		
		//$encoded_title = $this->encode($title);

		$autoadd_event = '';
		$autoadd_series = '';
		if ( isset( $_POST['autoadd_event'] ) ) {
			$autoadd_event = $wpdb->escape( $_POST['autoadd_event'] );
			echo $autoadd_event;
		}
		if ( isset( $_POST['autoadd_series'] ) ) {
			$autoadd_series = $wpdb->escape( $_POST['autoadd_series'] );
		}
		
		$results = $wpdb->get_var( "SELECT count(id) FROM " . $wpdb->prefix . "ebud_groups WHERE title='" . $title . "'" );
		if ( $results > 0 ) {
			$this->alert( 'Error: This group title already exists.', true );
		} else {
			if ( ( $title == '' ) ) {
				$this->alert( 'Error: Group name is required.', true );
			} else {
				$wpdb->query( "INSERT INTO " . $wpdb->prefix . "ebud_groups ( title, created, autoadd_event, autoadd_series ) VALUES('" . $title . "', NOW(), '" . $autoadd_event . "', '" . $autoadd_series . "' )" );
				$this->alert( 'New group successfully saved.' );
			}
		}
	}
}
if ( !empty( $_POST['edit'] ) ) {
	$title = $wpdb->escape( $_POST['title'] );
	$autoadd_event = $wpdb->escape( $_POST['autoadd_event'] );
	//$autoadd_series = $wpdb->escape( $_POST['autoadd_series'] );
	
	if ( ( $title == '' ) ) {
		$this->alert( 'Error: Group name is required.', true );
	} else {
		$wpdb->query( "UPDATE " . $wpdb->prefix . "ebud_groups SET title='" . $title . "', autoadd_event='" . $autoadd_event . "' WHERE id='" . $wpdb->escape( $_GET['edit'] ) . "' LIMIT 1" );
		$this->alert( 'Group changes successfully saved.' );
	}
}
?>

<div class="wrap">
	
	
	<?php if ( !isset( $_GET['edit'] ) ) { ?>
		<h2><?php echo $this->_name; ?> Groups</h2>
		

		<form id="posts-filter" enctype="multipart/form-data" method="post" action="<?php echo $this->_selfLink; ?>-groups">
			<div class="tablenav">
				<div class="alignleft actions">
					<input type="submit" name="delete_groups" value="Delete" class="button-secondary delete" />
				</div>
			</div>
			<table class="widefat">
				<thead>
					<tr class="thead">
						<th scope="col" class="check-column"><input type="checkbox" class="check-all-entries" /></th>
						<th>Group</th>
						<th>Members</th>
						<th>Created</th>
					</tr>
				</thead>
				<tfoot>
					<tr class="thead">
						<th scope="col" class="check-column"><input type="checkbox" class="check-all-entries" /></th>
						<th>Group</th>
						<th>Members</th>
						<th>Created</th>
					</tr>
				</tfoot>
				<tbody>
					<?php
					$results = $wpdb->get_results( "SELECT id, title, UNIX_TIMESTAMP(created) as created FROM " . $wpdb->prefix . "ebud_groups ORDER BY created ASC" );
					
					if ( empty( $results ) ) {
						echo '<tr class="entry-row alternate"><td colspan="4" align="center" style="font-style: italic;">You have not created any groups. You may add new groups below.</td></tr>';
					}
					
					foreach ( (array) $results as $id => $item ) {
						?>
						<tr class="entry-row alternate" id="entry-<?php echo $item->id; ?>">
							<th scope="row" class="check-column"><input type="checkbox" name="items[]" class="entries" value="<?php echo $item->id; ?>" /></th>
							<td>
								<?php echo stripslashes( $item->title ); ?>
								<div class="row-actions" style="margin:0; padding:0;">
									<a href="<?php echo $this->_selfLink; ?>-groups&edit=<?php echo $item->id; ?>">Edit Group</a>
									|
									<a href="<?php echo $this->_selfLink; ?>&go=broadcast&type=1&id=<?php echo $item->id; ?>&title=<?php echo urlencode( $item->title ); ?>">Broadcast</a> <a class="pluginbuddy_tip" title=" - Send an email message to all users in this list.">(?)</a>
								</div>
							</td>
							<td>
								<?php
								// TODO: Use transient to store this number since this query could become large...
								echo $wpdb->get_var( "SELECT count(id) FROM " . $wpdb->prefix . "ebud_subscriptions WHERE sub_type='1' AND subscribed_id='" . $item->id . "'" );
								?>
								<div class="row-actions" style="margin:0; padding:0;">
									<a href="<?php echo $this->_selfLink; ?>&go=subscribers&type=1&id=<?php echo $item->id; ?>">Manage</a>
								</div>
							</td>
							<td><?php echo date( $this->_parent->_timestamp . ' ' . get_option( 'gmt_offset' ), $item->created + ( get_option( 'gmt_offset' ) * 3600 ) ); ?></td>
						</tr>
						<?php
					}
					?>
				</tbody>
			</table>
			<div class="tablenav">
				<div class="alignleft actions">
					<input type="submit" name="delete_groups" value="Delete" class="button-secondary delete" />
				</div>
			</div>
			<?php $this->nonce(); ?>
		</form>
		
	<?php
		echo '<h3>Add New Group</h3>';
		$subject = '';
		$body = '';
	} else {
		echo '<h2>' . $this->_name . ' Groups (<a href="' . $this->_selfLink . '-groups">groups home</a>)</h2>';
		echo '<h3>Edit Group</h3>';
		$results = $wpdb->get_row( "SELECT title,created,autoadd_event FROM " . $wpdb->prefix . "ebud_groups WHERE id='" . $wpdb->escape( $_GET['edit'] ) . "' LIMIT 1" );
		if ( empty( $results ) ) {
			$this->alert( 'Unable to find this group to edit.', true );
		} else {
			$title = stripslashes( $results->title );
			$autoadd_event = $results->autoadd_event;
		}
	}
	?>
	<form method="post" action="<?php echo $this->_selfLink; ?>-groups<?php if ( isset( $_GET['edit'] ) ) { echo '&edit=' . $_GET['edit']; } ?>">
		<div class="fullwidth">
			<input class="prompt biginput" style="width: 50%;" type="text" name="title" maxlength="45" value="<?php if ( isset( $_GET['edit'] ) && isset( $title ) ) { echo $title; } ?>" alt="Enter group name here" /><br /><br />
			
			Automatically add subscribers of this group to the following ...
			<p>
			<?php
			if ( !isset( $autoadd_event ) ) { $autoadd_event = ''; }
			if ( !isset( $autoadd_group ) ) { $autoadd_group = ''; }
			if ( !isset( $autoadd_series ) ) { $autoadd_series = ''; }
			$this->print_autoadd( 1, $autoadd_event, $autoadd_group, $autoadd_series ); ?>
			</p>
		</div>
		<p class="submit">
		<?php if ( !isset( $_GET['edit'] ) ) { ?>
			<input type="submit" name="save" value="Add Group" class="button-primary" id="save" />
		<?php } else { ?>
			<input type="submit" name="edit" value="Edit Group" class="button-primary" id="save" />
		<?php } ?>
		</p>
		
		
		<?php $this->nonce(); ?>
	</form>
	
</div>
