<?php
$this->_parent->load();
$this->admin_scripts();

global $wpdb;

if ( isset( $_POST['delete_groups'] ) ) {
	foreach ( (array) $_POST['items'] as $id => $item ) {
		$wpdb->query( "DELETE FROM " . $wpdb->prefix . "ebud_messages WHERE id='" . $wpdb->escape( $item ) . "' LIMIT 1" );
	}
	$this->alert( 'Deleted ' . count( $_POST['items'] ) . ' messages.');
}

if ( !empty( $_POST['save'] ) ) {
	if ( ( $_POST['title'] == 'Enter message title here' ) || ( $_POST['title'] == '' ) ) {
		$this->alert( 'Please enter a message title.' );
	} else {
		$title = $wpdb->escape( $_POST['title'] );
		$body = $wpdb->escape( $_POST['body'] );
		
		if ( ( $title == '' ) || ( $body == '' ) ) {
			$this->alert( 'Error: Both title and message body are required.', true );
		} else {
			$wpdb->query( "INSERT INTO " . $wpdb->prefix . "ebud_messages ( title, body, created ) VALUES( '" . $title . "','" . $body . "', NOW() )" );
			$this->alert( 'New message "' . htmlentities( $_POST['title'] ) . '" successfully saved.' );
		}
	}
}
if ( !empty( $_POST['edit'] ) ) {
	$title = $wpdb->escape( $_POST['title'] );
	$body = $wpdb->escape( $_POST['body'] );
	
	if ( ( $title == '' ) || ( $body == '' ) ) {
		$this->alert( 'Error: Both title and message body are required.', true );
	} else {
		$wpdb->query( "UPDATE " . $wpdb->prefix . "ebud_messages SET title='" . $title . "', body='" . $body . "' WHERE id='" . $wpdb->escape( $_GET['edit'] ) . "' LIMIT 1" );
		$this->alert( 'Message changes successfully saved.' );
	}
}
?>

<div class="wrap">
	
	
	<?php if ( !isset( $_GET['edit'] ) ) { ?>
		<h2><?php echo $this->_name; ?> Email Messages</h2>
		

		<form id="posts-filter" enctype="multipart/form-data" method="post" action="<?php echo $this->_selfLink; ?>-messages">
			<div class="tablenav">
				<div class="alignleft actions">
					<input type="submit" name="delete_groups" value="Delete" class="button-secondary delete" />
				</div>
			</div>
			<table class="widefat">
				<thead>
					<tr class="thead">
						<th scope="col" class="check-column"><input type="checkbox" class="check-all-entries" /></th>
						<th>Title</th>
						<th>Date Created</th>
					</tr>
				</thead>
				<tfoot>
					<tr class="thead">
						<th scope="col" class="check-column"><input type="checkbox" class="check-all-entries" /></th>
						<th>Title</th>
						<th>Date Created</th>
					</tr>
				</tfoot>
				<tbody>
					<?php
					$results = $wpdb->get_results( "SELECT id, title, UNIX_TIMESTAMP( created ) as created FROM " . $wpdb->prefix . "ebud_messages ORDER BY created ASC" );
					
					if ( empty( $results ) ) {
						echo '<tr class="entry-row alternate"><td colspan="3" align="center" style="font-style: italic;">You have not created any messages. You may add new messages below.</td></tr>';
					}
					
					foreach ( (array) $results as $id => $item ) {
						?>
						<tr class="entry-row alternate" id="entry-<?php echo $item->id; ?>">
							<th scope="row" class="check-column"><input type="checkbox" name="items[]" class="entries" value="<?php echo $item->id; ?>" /></th>
							<td>
								<?php echo stripslashes( $item->title ); ?>
								<div class="row-actions" style="margin:0; padding:0;">
									<a href="<?php echo $this->_selfLink; ?>-messages&edit=<?php echo $item->id; ?>">Edit Message</a>
								</div>
							</td>
							<td><?php echo date( $this->_parent->_timestamp . ' ' . get_option( 'gmt_offset' ), $item->created + ( get_option( 'gmt_offset' ) * 3600 ) ); ?></td>
						</tr>
						<?php
					}
					?>
				</tbody>
			</table>
			<div class="tablenav">
				<div class="alignleft actions">
					<input type="submit" name="delete_groups" value="Delete" class="button-secondary delete" />
				</div>
			</div>
			<?php $this->nonce(); ?>
		</form>
		
	<?php
		echo '<h3>Add New Email Message</h3>';
		$title = '';
		$body = '';
	} else {
		echo '<h2>' . $this->_name . ' Email Messages (<a href="' . $this->_selfLink . '-messages">messages home</a>)</h2>';
		echo '<h3>Edit Email Message</h3>';
		$results = $wpdb->get_row( "SELECT title,body,created FROM " . $wpdb->prefix . "ebud_messages WHERE id='" . $wpdb->escape( $_GET['edit'] ) . "' LIMIT 1" );
		if ( empty( $results ) ) {
			$this->alert( 'Unable to find this message to edit.', true );
		} else {
			$title = stripslashes( $results->title );
			$body = stripslashes( $results->body );
		}
	}
	?>
	<form method="post" action="<?php echo $this->_selfLink; ?>-messages<?php if ( isset( $_GET['edit'] ) ) { echo '&edit=' . $_GET['edit']; } ?>">
		<div class="fullwidth">
			<input class="prompt biginput" type="text" name="title" id="email_title" maxlength="45" value="<?php echo $title; ?>" alt="Enter message title here" /><br /><br />
			<textarea id="message_body" name="body" rows="10" cols="70" style="background: #FBFBFB url('<?php echo $this->_pluginURL; ?>/images/email_bg.png') repeat-y; padding: 6px;"><?php echo $body; ?></textarea>
			
			<span style="float: left;">
				<br />
				<select name="variables" id="variables">
					<option value="">Insert Variable ... </option>
					<option value="{email_address}">User's email address. {email_address}</option>
					<option value="{datetime}">Date & time when message is sent. {datetime}</option>
					<option value="{siteurl}">URL to this site. {siteurl}</option>
					<option value="{unsubscribe}">Unsubscribe link. {unsubscribe}</option>
					<option value="{blogname}">Name of blog. {blogname}</option>
					<!--
					<option value="{event_title}">Title of event that sent email. {event_title}</option>
					<option value="{group_title}">Title of group email sent to. {group_title}</option>
					<option value="{series_title}">Title of series that sent email. {series_title}</option>
					-->
					<option value="{subject}">Subject of email. {title}</option>
					<option value="{custom_name}">Custom field*: Name. {custom_name}</option>
				</select>
				<?php $this->tip( 'Use message variables to create customized messages.  Variables are processed on a per-message and per-recipient basis.  Variables will be replaced by their respective values upon sending the message.' ); ?>
			</span>
			
			<p style="float: left; clear: both;" class="submit">
			<?php if ( !isset( $_GET['edit'] ) ) { ?>
				<input type="submit" name="save" value="Add Message" class="button-primary" id="save" />
			<?php } else { ?>
				<input type="submit" name="edit" value="Save Message Changes" class="button-primary" id="save" />
			<?php } ?>
			</p>
			
			<div style="margin-left: 602px; color: #BBBBBB; border-left: 1px dotted #E6E6E6; padding-left: 5px;"><br />&larr; Keep text left of line for maximum email compatibility. <a class="pluginbuddy_tip" title=" - Some email clients do not auto-wrap messages properly or at all.  By keeping all text to the left of this line you will help insure that all text content stays visible for your readers."><small>(?)</small></a><br /><br /></div>
			
			<div style="clear: both;">
				<small>* Note: A default value of 'Sir/Madam' will be assigned to the custom name if none is set.</small>
			</div>
		</div>
		
		<?php $this->nonce(); ?>
	</form>
	
</div>