<?php
$this->_parent->load();
$this->admin_scripts();

wp_enqueue_script( 'ithemes-custom-ui-js', $this->_pluginURL . '/js/jquery.custom-ui.js' );
wp_print_scripts( 'ithemes-custom-ui-js' );
wp_enqueue_script( 'ithemes-timepicker-js', $this->_pluginURL . '/js/timepicker.js' );
wp_print_scripts( 'ithemes-timepicker-js' );
echo '<link rel="stylesheet" href="'.$this->_pluginURL . '/css/ui-smoothness/jquery-ui-1.8.2.custom.css" type="text/css" media="all" />';

global $wpdb;

if ( isset( $_POST['delete_events'] ) ) {
	foreach ( (array) $_POST['items'] as $id => $item ) {
		$wpdb->query( "DELETE FROM " . $wpdb->prefix . "ebud_events WHERE id='" . $wpdb->escape( $item ) . "' LIMIT 1" );
	}
	$this->alert( 'Deleted ' . count( $_POST['items'] ) . ' events.');
}

if ( !empty( $_POST['save'] ) ) {
	$title = $wpdb->escape( $_POST['title'] );
	$autoadd_group = $wpdb->escape( $_POST['autoadd_group'] );
	$autoadd_series = $wpdb->escape( $_POST['autoadd_series'] );
	$recur_amount = $wpdb->escape( $_POST['recur_amount'] );
	$recur_unit = $wpdb->escape( $_POST['recur_unit'] );
	$initial_date = strtotime( $_POST['initial_date'] );
	
	$reminder1_amount = $wpdb->escape( $_POST['reminder1_amount'] );
	if ( isset( $reminder1_amount ) ) { $reminder1_unit = $wpdb->escape( $_POST['reminder1_unit'] ); }
	$reminder2_amount = $wpdb->escape( $_POST['reminder2_amount'] );
	if ( isset( $reminder2_amount ) ) { $reminder2_unit = $wpdb->escape( $_POST['reminder2_unit'] ); }
	$reminder3_amount = $wpdb->escape( $_POST['reminder3_amount'] );
	if ( isset( $reminder3_amount ) ) { $reminder3_unit = $wpdb->escape( $_POST['reminder3_unit'] ); }
	
	
	// TODO: Check for duplicate name!
	if ( ( $title == '' ) ) {
		$this->alert( 'Error: Event name is required.', true );
	} else {
		$wpdb->query( "INSERT INTO " . $wpdb->prefix . "ebud_events ( title, created, autoadd_group, autoadd_series, reminder1_amount, reminder1_unit, reminder2_amount, reminder2_unit, reminder3_amount, reminder3_unit, recur_amount, recur_unit, initial_date ) VALUES( '" . $title . "', NOW(), '" . $autoadd_group . "', '" . $autoadd_series . "', '" . $reminder1_amount . "', '" . $reminder1_unit . "', '" . $reminder2_amount . "', '" . $reminder2_unit . "', '" . $reminder3_amount . "', '" . $reminder3_unit . "', '" . $recur_amount . "', '" . $recur_unit . "', from_unixtime(" . $initial_date . ") )" );
		$this->alert( 'New event successfully saved.' );
	}
}
if ( !empty( $_POST['edit'] ) ) {
	$title = $wpdb->escape( $_POST['title'] );
	$autoadd_event = $wpdb->escape( $_POST['autoadd_event'] );
	$autoadd_series = $wpdb->escape( $_POST['autoadd_series'] );
	$recur_amount = $wpdb->escape( $_POST['recur_amount'] );
	$recur_unit = $wpdb->escape( $_POST['recur_unit'] );
	$initial_date = strtotime( $_POST['initial_date'] );
	
	$reminder1_amount = $wpdb->escape( $_POST['reminder1_amount'] );
	if ( isset( $reminder1_amount ) ) { $reminder1_unit = $wpdb->escape( $_POST['reminder1_unit'] ); }
	$reminder2_amount = $wpdb->escape( $_POST['reminder2_amount'] );
	if ( isset( $reminder2_amount ) ) { $reminder2_unit = $wpdb->escape( $_POST['reminder2_unit'] ); }
	$reminder3_amount = $wpdb->escape( $_POST['reminder3_amount'] );
	if ( isset( $reminder3_amount ) ) { $reminder3_unit = $wpdb->escape( $_POST['reminder3_unit'] ); }
	
	
	if ( ( $title == '' ) ) {
		$this->alert( 'Error: Event name is required.', true );
	} else {
		$wpdb->query( "UPDATE " . $wpdb->prefix . "ebud_events SET title='" . $title . "', autoadd_group='" . $autoadd_group . "', autoadd_series='" . $autoadd_series . "', reminder1_amount='" . $reminder1_amount . "', reminder1_unit='" . $reminder1_unit . "', reminder2_amount='" . $reminder2_amount . "', reminder2_unit='" . $reminder2_unit . "', reminder3_amount='" . $reminder3_amount . "', reminder3_unit='" . $reminder3_unit . "', initial_date='" . $initial_date . "' WHERE id='" . $wpdb->escape( $_GET['edit'] ) . "' LIMIT 1" );
		$this->alert( 'Event changes successfully saved.' );
	}
}
?>

<div class="wrap">
	
	
	<?php if ( $_GET['edit'] == '' ) { ?>
		<h2><?php echo $this->_name; ?> Events</h2>
		

		<form id="posts-filter" enctype="multipart/form-data" method="post" action="<?php echo $this->_selfLink; ?>-events">
			<div class="tablenav">
				<div class="alignleft actions">
					<input type="submit" name="delete_events" value="Delete" class="button-secondary delete" />
				</div>
			</div>
			<table class="widefat">
				<thead>
					<tr class="thead">
						<th scope="col" class="check-column"><input type="checkbox" class="check-all-entries" /></th>
						<th>Event</th>
						<th>Members</th>
						<th>Reminders</th>
						<th>Event Date</th>
						<th>Created</th>
					</tr>
				</thead>
				<tfoot>
					<tr class="thead">
						<th scope="col" class="check-column"><input type="checkbox" class="check-all-entries" /></th>
						<th>Event</th>
						<th>Members</th>
						<th>Reminders</th>
						<th>Event Date</th>
						<th>Created</th>
					</tr>
				</tfoot>
				<tbody>
					<?php
					$results = $wpdb->get_results( "SELECT id,title,created,reminder1_amount,reminder1_unit,reminder2_amount,reminder2_unit,reminder3_amount,reminder3_unit,initial_date,recur_amount,recur_unit FROM " . $wpdb->prefix . "ebud_events ORDER BY created ASC" );
					
					if ( empty( $results ) ) {
						echo '<tr class="entry-row alternate"><td colspan="2" align="center" style="font-style: italic;">You have not created any events. You may add new events below.</td></tr>';
					}
					
					foreach ( (array) $results as $id => $item ) {
						?>
						<tr class="entry-row alternate" id="entry-<?php echo $item->id; ?>">
							<th scope="row" class="check-column"><input type="checkbox" name="items[]" class="entries" value="<?php echo $item->id; ?>" /></th>
							<td>
								<?php echo $item->title; ?>
								<div class="row-actions" style="margin:0; padding:0;">
									<a href="<?php echo $this->_selfLink; ?>-events&edit=<?php echo $item->id; ?>">Edit Event</a>
								</div>
							</td>
							<td>
								<?php
								// TODO: Use transient to store this number since this query could become large...
								echo $wpdb->get_var( "SELECT count(id) FROM " . $wpdb->prefix . "ebud_subscriptions WHERE sub_type='0' AND subscribed_id='" . $item->id . "'" );
								?>
								<div class="row-actions" style="margin:0; padding:0;">
									<a href="<?php echo $this->_selfLink; ?>&go=subscribers&type=0&id=<?php echo $item->id; ?>">Manage</a>
								</div>
							</td>
							<td>
							<?php
							if ( $item->reminder1_amount != '' ) {
								echo $item->reminder1_amount . ' ' . $item->reminder1_unit;
							}
							if ( $item->reminder2_amount != '' ) {
								echo ', ' . $item->reminder2_amount . ' ' . $item->reminder2_unit;
							}
							if ( $item->reminder3_amount != '' ) {
								echo ', ' . $item->reminder3_amount . ' ' . $item->reminder3_unit;
							}
							?>
							</td>
							<td><?php
							echo $item->initial_date;
							if ( $item->recur_amount != '' ) {
								echo '<br />Repeats every ' . $item->recur_amount . ' ' . $item->recur_unit;
							}
							?></td>
							<td><?php echo $item->created; ?></td>
						</tr>
						<?php
					}
					?>
				</tbody>
			</table>
			<div class="tablenav">
				<div class="alignleft actions">
					<input type="submit" name="delete_events" value="Delete" class="button-secondary delete" />
				</div>
			</div>
			<?php $this->nonce(); ?>
		</form>
		
	<?php
		echo '<h3>Add New Event</h3>';
		$subject = '';
		$body = '';
		$initial_date = date('m/d/Y h:i a',(time()+86400));
	} else {
		echo '<h2>' . $this->_name . ' Events (<a href="' . $this->_selfLink . '-events">events home</a>)</h2>';
		echo '<h3>Edit Event</h3>';
		$results = $wpdb->get_row( "SELECT * FROM " . $wpdb->prefix . "ebud_events WHERE id='" . $wpdb->escape( $_GET['edit'] ) . "' LIMIT 1", ARRAY_A );
		if ( empty( $results ) ) {
			$this->alert( 'Unable to find this event to edit.', true );
		} else {
			/*
			$title = $results->title;
			$initial_date = $results->initial_date;
			$recur_amount = $results->recur_amount;
			$recur_unit
			*/
			extract( $results );
			//echo 'yo'.$title;
		}
	}
	?>
	<form method="post" action="<?php echo $this->_selfLink; ?>-events&edit=<?php echo $_GET['edit']; ?>">
		<div class="fullwidth">
			<input class="prompt biginput" style="width: 50%;" type="text" name="title" maxlength="45" value="<?php echo $title; ?>" alt="Enter event name here" /><br /><br />
		</div>
		
		Event Date:
		<span>
			<input type="text" name="initial_date" id="ithemes_datetime" value="<?php echo $initial_date; ?>">
			<small>mm/dd/yyyy hh:mm [am/pm] &middot; Current server time is <?php echo date( 'm/d/Y h:i a e', time() ); ?></small>
		</span>
		<br /><br />
		
		This event should automatically repeat every 
		<input type="text" name="recur_amount" value="<?php echo $recur_amount; ?>" size="4" maxlength="4" />
		<select name="recur_unit">
			<option value="hours" <?php if ( $recur_unit == 'hours' ) { echo 'selected'; } ?>>hours</option>
			<option value="days" <?php if ( $recur_unit == 'days' ) { echo 'selected'; } ?>>days</option>
			<option value="weeks" <?php if ( $recur_unit == 'weeks' ) { echo 'selected'; } ?>>weeks</option>
			<option value="months" <?php if ( $recur_unit == 'months' ) { echo 'selected'; } ?>>months</option>
		</select>.<br />
		
		<br />		
		Send reminder emails at the following times <i>before</i> the event ...<br /><br />

		<?php
		$message_list = '';
		$message_list .= '<option value="">Select message ... </option>';
		$results = $wpdb->get_results( "SELECT id, title FROM " . $wpdb->prefix . "ebud_messages ORDER BY title ASC" );
		foreach ( (array) $results as $id => $item ) {
			$message_list .= '<option value="' . $item->id . '">' . $item->title . '</option>';
		}
		?>
		
		<input class="reminder" id="reminder1" type="text" name="reminder1_amount" value="<?php echo $reminder1_amount; ?>" size="4" maxlength="4" />
		<select name="reminder1_unit">
			<option value="hours" <?php if ( $reminder1_unit == 'hours' ) { echo 'selected'; } ?>>hours</option>
			<option value="days" <?php if ( $reminder1_unit == 'days' ) { echo 'selected'; } ?>>days</option>
			<option value="weeks" <?php if ( $reminder1_unit == 'weeks' ) { echo 'selected'; } ?>>weeks</option>
			<option value="months" <?php if ( $reminder1_unit == 'months' ) { echo 'selected'; } ?>>months</option>
		</select>
		<?php
		echo '<span id="reminder1_hidden" style="display: none;">';
		echo '<select name="reminder1">';
		echo $message_list;
		echo '</select>';
		echo '</span>';
		?>
		<br />
		
		<input class="reminder" id="reminder2" type="text" name="reminder2_amount" value="<?php echo $reminder2_amount; ?>" size="4" maxlength="4" />
		<select name="reminder2_unit">
			<option value="hours" <?php if ( $reminder2_unit == 'hours' ) { echo 'selected'; } ?>>hours</option>
			<option value="days" <?php if ( $reminder2_unit == 'days' ) { echo 'selected'; } ?>>days</option>
			<option value="weeks" <?php if ( $reminder2_unit == 'weeks' ) { echo 'selected'; } ?>>weeks</option>
			<option value="months" <?php if ( $reminder2_unit == 'months' ) { echo 'selected'; } ?>>months</option>
		</select>
		<?php
		echo '<span id="reminder2_hidden" style="display: none;">';
		echo '<select name="reminder2">';
		echo $message_list;
		echo '</select>';
		echo '</span>';
		?>
		<br />
		
		<input class="reminder" id="reminder3" type="text" name="reminder3_amount" value="<?php echo $reminder3_amount; ?>" size="4" maxlength="4" />
		<select name="reminder3_unit">
			<option value="hours" <?php if ( $reminder3_unit == 'hours' ) { echo 'selected'; } ?>>hours</option>
			<option value="days" <?php if ( $reminder3_unit == 'days' ) { echo 'selected'; } ?>>days</option>
			<option value="weeks" <?php if ( $reminder3_unit == 'weeks' ) { echo 'selected'; } ?>>weeks</option>
			<option value="months" <?php if ( $reminder3_unit == 'months' ) { echo 'selected'; } ?>>months</option>
		</select>
		<?php
		echo '<span id="reminder3_hidden" style="display: none;">';
		echo '<select name="reminder3">';
		echo $message_list;
		echo '</select>';
		echo '</span>';
		?>
		<br />
		
		<br />
		Automatically add subscribers of this event to the following ...
		<p>
		<?php $this->print_autoadd( 0, $autoadd_event, $autoadd_group, $autoadd_series ); ?>
		</p>
		
		<p class="submit">
		<?php if ( $_GET['edit'] == '' ) { ?>
			<input type="submit" name="save" value="Add Event" class="button-primary" id="save" />
		<?php } else { ?>
			<input type="submit" name="edit" value="Edit Event" class="button-primary" id="save" />
		<?php } ?>
		</p>

		
		<?php $this->nonce(); ?>
	</form>
	
</div>