<?php
$this->_parent->load();
$this->admin_scripts();

if ( !empty( $_POST['save'] ) ) {
	$this->savesettings();
}
if ( !empty( $_GET['send_queue'] ) ) {
	$this->_parent->queue_process();
	$this->_parent->alert( 'Queue processing has launched.' );
}
if ( !empty( $_GET['clear_queue'] ) ) {
	global $wpdb;
	$wpdb->query( "DELETE from " . $wpdb->prefix . "ebud_queue" );
	$this->_parent->alert( 'All pending queued items have been cleared from the queue.' );
}
if ( !empty( $_POST['send_test_email'] ) ) {
	if ( empty( $_POST['test_email'] ) ) {
		$this->_parent->alert( 'Error: You must supply an email to send the test message to.', true );
	} else {
		wp_mail( $_POST['test_email'], 'EmailBuddy Test Message', 'This is a test email message to verify that email is properly functioning on your server. http://pluginbuddy.com' );
		$this->_parent->alert( 'Test email sent to email "' . htmlentities( $_POST['test_email'] ) . '".' );
	}
}
if ( !empty( $_POST['unsubscribe'] ) ) {
	if ( $this->_parent->unsubscribe( $_POST['unsubscribe'] ) ) {
		$this->_parent->alert( 'Unsubscribed "' . htmlentities( $_POST['unsubscribe'] ) . '" from all lists.' );
	} else {
		$this->_parent->alert( 'Error: "' . $this->_parent->error . '"' );
	}
}

wp_enqueue_script( 'jquery-ui-tabs' );
wp_print_scripts( 'jquery-ui-tabs' );

global $wpdb;
?>
<script type="text/javascript">
	jQuery(document).ready(function() {
		jQuery('#pluginbuddy-emailbuddy-tabs').tabs();
	});
</script>

<div class="wrap">
	<h2><?php echo $this->_name; ?> Tools</h2><br />
	
	<div id="pluginbuddy-emailbuddy-tabs">
		<ul>
			<li><a href="#pluginbuddy-emailbuddy-tabs-1"><span>Emailing</span></a></li>
			<li><a href="#pluginbuddy-emailbuddy-tabs-2"><span>Import Emails</span></a></li>
			<li><a href="#pluginbuddy-emailbuddy-tabs-3"><span>Export Emails</span></a></li>
			<li><a href="#pluginbuddy-emailbuddy-tabs-4"><span>Scheduled Activity</span></a></li>
		</ul>
		<div class="tabs-borderwrap" id="editbox" style="position: relative; height: 100%; -moz-border-radius-topleft: 0px; -webkit-border-top-left-radius: 0px;">
			<div id="pluginbuddy-emailbuddy-tabs-1">
				<h4>Email Queue</h4>
				There are currently <i><?php
				echo $wpdb->get_var( "SELECT count(id) FROM " . $wpdb->prefix . "ebud_queue" );
				?></i> emails waiting to be sent in queue. Emails should<br />be automatically sent by the system but you may override automated sending.<br /><br />
				<a id="pluginbuddy_debugtoggle" class="button secondary-button" href="<?php echo $this->_selfLink; ?>-tools&send_queue=true">Force Send Queue Now</a> &nbsp; <a id="pluginbuddy_debugtoggle" class="button secondary-button" onclick="
					if ( !confirm('WARNING: This will DELETE ALL unsent emails waiting to be sent in the queue. Are you sure you want to do this? This CANNOT be undone!') ) {
						return false;
					}
				" href="<?php echo $this->_selfLink; ?>-tools&clear_queue=true">Clear Queue</a>
				
				<br /><br />
				
				<h4>Send Test Message</h4>
				<form method="post" action="<?php echo $this->_selfLink; ?>-tools">
					<input type="text" name="test_email" size="35" value="<?php echo get_option('admin_email'); ?>" />
					<input type="submit" name="send_test_email" value="Send Test Message" class="button-secondary" />
					<?php $this->nonce(); ?>
				</form>
				
				<br /><br />
				
				<h4>Unsubscribe User from All Lists</h4>
				<form method="post" action="<?php echo $this->_selfLink; ?>-tools">
					<input type="text" name="unsubscribe" size="35" />
					<input type="submit" name="unsubscribe_email" value="Unsubscribe" class="button-secondary" />
					<?php $this->nonce(); ?>
				</form>
			</div>
			<div id="pluginbuddy-emailbuddy-tabs-2">
				<h4>Import Email Addresses</h4>
				You may import email addresses from a plain text file to quickly subscribe users.<br />
				Select which list(s) you would like to import and the email address text file.<br />
				One email per line. Emails will be auto-validated <?php $this->tip( 'Even if you have double opt-in enabled, emails imported here will not require the user to confirm their email address. It is assumed that emails are valid and you have authorization to add them.' ); ?> & not auto-subscribed to other lists <?php $this->tip( 'Even if you have a list set to auto-subscribe a user to another list or event, they will not be. This prevents unintentional subscribing to additional lists.' ); ?>.<br /><br />
				
					<table>
						<form enctype="multipart/form-data" method="post" action="<?php echo admin_url('admin-ajax.php'); ?>?action=emailbuddy_import_emails">
								<?php
								//echo '<div style="padding-left: 15px;">';
								
								?>
								<tr>
									<td valign="top">
										Events:
									</td>
									<td>
										<?php
										$results = $wpdb->get_results( "SELECT id,title FROM " . $wpdb->prefix . "ebud_events ORDER BY title ASC" );
										if ( empty( $results ) ) {
											echo '<i>No events have been created yet.</i>';
										}
										foreach ( (array) $results as $id => $item ) {
											echo '<input type="checkbox" name="lists[]" value="0-' . $item->id . '"';
											echo '> ' . stripslashes( $item->title );
											echo '<br />';
										}
										unset( $results );
										?>
									</td>
								</tr>
								<tr>
									<td valign="top">
										Groups:
									</td>
									<td>
										<?php
										$results = $wpdb->get_results( "SELECT id,title FROM " . $wpdb->prefix . "ebud_groups ORDER BY title ASC" );
										if ( empty( $results ) ) {
											echo '<i>No groups have been created yet.</i>';
										}
										foreach ( (array) $results as $id => $item ) {
											echo '<input type="checkbox" name="lists[]" value="1-' . $item->id . '"';
											echo '> ' . stripslashes( $item->title );
											echo '<br />';
										}
										unset( $results );
										?>
									</td>
								</tr>
								<?php
								/*
								echo '<b>Series</b><br />';
								$results = $wpdb->get_results( "SELECT id,title FROM " . $wpdb->prefix . "ebud_series ORDER BY title ASC" );
								if ( empty( $results ) ) {
									echo '&nbsp;&nbsp;<i>No series have been created yet.</i>';
								}
								foreach ( (array) $results as $id => $item ) {
									echo '&nbsp;&nbsp;&nbsp;<input type="checkbox" name="lists[]" value="2-' . $item->id . '"';
									echo '> ' . $item->title;
									echo '<br />';
								}
								unset( $results );
								*/
								echo '</div><br/ >';

								?>
								<input type="hidden" name="return_url" value="<?php echo $this->_selfLink; ?>-tools" />
								<input type="hidden" name="MAX_FILE_SIZE" value="100000" />
							</td>
						</tr>
						<tr>
							<td colspan="2">&nbsp;</td>
						</tr>
						<tr>
							<td>
								Text file to import from:
							</td>
							<td>
								<input name="uploadedfile" type="file" />
							</td>
						</tr>
						<tr>
							<td colspan="2" style="font-size: 15px; padding: 10px;">
								<center>
									<i><b>and / or</b></i>
								</center>
							</td>
						</tr>
						<tr>
							<td valign="top">
								Email addresses to import:<br />
								<small>(one per line)</small>
							</td>
							<td>
								<textarea name="emails" rows="5" cols="25"></textarea>
							</td>
						</tr>
						<tr>
							<td>&nbsp;</td>
							<td>
								<p>
									<input type="submit" name="save" value="Import Addresses" class="button-primary" id="save" />
								</p>
							</td>
						</tr>
					</table>
					
				</form>
			</div>
			<div id="pluginbuddy-emailbuddy-tabs-3">
				<h4>Export Email Addresses</h4>
				You may download a flat text file containing all email addresses of all subscribers by
				<a href="<?php echo admin_url('admin-ajax.php'); ?>?action=emailbuddy_export_emails">clicking here</a>.
			</div>
			<div id="pluginbuddy-emailbuddy-tabs-4">
				<h4>Scheduled Activity</h4>
				This tab is currently for debugging purposes.<br /><br />
				<hr />
				<ul>
				<?php
				$cron = get_option('cron');
				
				// Loop through each cron time
				foreach ( (array) $cron as $time => $item ) {
					// Loop through each schedule for this time
					foreach ( (array) $item as $event_name => $event ) {
						if ( ( !empty( $_GET['detail_cron'] ) ) || ( $event_name === 'pluginbuddy-emailbuddy-cron_recur_event' ) || ( $event_name === 'pluginbuddy-emailbuddy-cron_process_event' ) ) {
							// Loop through each EmailBuddy cron
							foreach ( (array) $event as $item_name => $item ) {
								echo '<li>';
								echo '<b>Time: ' . date( $this->_parent->_timestamp . ' ' . get_option( 'gmt_offset' ), $time + ( get_option( 'gmt_offset' ) * 3600 ) ) . '<br />';
								echo 'Period: ' . $item['schedule'] . '</b><br />';
								print_r( $item );
								echo '<hr />';
								echo '</li>';
							}
						}
					}
				}
				?>
				</ul>
				
				<a href="?page=pluginbuddy-emailbuddy-tools&detail_cron=on">Show All</a>
			</div>
		</div>
	</div>
	
	
	
	
	

<!-- 
	<br /><br /><br />
	TODO:
	<ul>
		<li>Import email addresses - Flat list? comma separated with event type?</li>
		<li>Search for email/user</li>
	</ul>
	
	
	<br /><br /><br />
	Postpone to next release?:
	<ul>
		<li>Email spell checking</li>
		<li>Clear all waiting items from queue</li>
		<li>click tracking</li>
		<li>sending email to users who havent visited in a while</li>
		<li>Show count of items waiting in queue</li>
		<li>Check for bounces in return address account via POP3</li>
		<li>send email of new post from add post page</li>
		<li>Series</li>
	</ul>
	-->
	
</div>