<?php
/**
 * widget_PluginBuddyEmailBuddy Class
 *
 * Adds widget capabilities.
 *
 * Author:	Dustin Bolton
 * Date:	January 2010
 *
 */

 
class widget_PluginBuddyEmailBuddy extends WP_Widget {
	var $_widget_control_width = 300;
	var $_widget_control_height = 300;
	
	
	/**
	 * widget_PluginBuddyEmailBuddy::widget_PluginBuddyEmailBuddy()
	 * 
	 * Default constructor.
	 * 
	 * @return void
	 */
	function widget_PluginBuddyEmailBuddy() {
		$widget_ops = array('description' => __('Displays a subscription form to a list of your choice.', 'PluginBuddyEmailBuddy'));
		$this->WP_Widget('PluginBuddyEmailBuddy', __('EmailBuddy'), $widget_ops);
	}
	
	
	/**
	 * widget_PluginBuddyEmailBuddy::widget()
	 *
	 * Display public widget.
	 *
	 * @param	array	$args		Widget arguments -- currently not in use.
	 * @param	array	$instance	Instance data including title, group id, etc.
	 * @return	void
	 */
	function widget($args, $instance) {
		extract( $args ); // Extracts each item of array into a root variable.
		$title = apply_filters( 'widget_title', $instance['title'] );
		echo $before_widget;

		if ( $title ) {
			echo $before_title . $title . $after_title;
		}
		
		// $id is widget ID...
		
		$group = intval( $instance['list'] );
		do_action( 'pluginbuddy-emailbuddy-widget', $instance, true);
		
		echo $after_widget;
	}
	
	
	/**
	 * widget_PluginBuddyEmailBuddy::update()
	 *
	 * Save widget form settings.
	 *
	 * @param	array	$new_instance	NEW instance data including title, group id, etc.
	 * @param	array	$old_instance	PREVIOUS instance data including title, group id, etc.
	 * @return	void
	 */
	function update($new_instance, $old_instance) {
		if (!isset($new_instance['submit'])) {
			return false;
		}
		$instance = $old_instance;
		$instance['title'] = strip_tags( $new_instance['title'] );
		$instance['list'] = strip_tags( $new_instance['list'] );
		$instance['submit_value'] = strip_tags( $new_instance['submit_value'] );
		$instance['subscription_confirmation'] = strip_tags( $new_instance['subscription_confirmation'] );
		
		$instance['pre_text'] = strip_tags( $new_instance['pre_text'] );
		$instance['post_text'] = strip_tags( $new_instance['post_text'] );
		$instance['custom_inputs'] = strip_tags( $new_instance['custom_inputs'] );
		
		
		$instance['text'] = strip_tags( $new_instance['text'] );
		
		return $instance;
	}
	
	
	/**
	 * widget_PluginBuddyEmailBuddy::form()
	 *
	 * Display widget control panel.
	 *
	 * @param	array	$instance	Instance data including title, group id, etc.
	 * @return	void
	 */
	function form($instance) {
		?>
		<style type="text/css">
			optgroup option {
				margin-left: 10px;
			}
		</style>
		<label for="<?php echo $this->get_field_id('title'); ?>">Title:
			<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php if ( isset( $instance['title'] ) ) { echo $instance['title']; } ?>" />
		</label>
		
		<label for="<?php echo $this->get_field_id('list'); ?>">List to subscribe user to:
			<select class="widefat" id="<?php echo $this->get_field_id('list'); ?>" name="<?php echo $this->get_field_name('list'); ?>">
				
				<?php
				global $wpdb;

				
				echo '<optgroup label="Events">';
				$results = $wpdb->get_results( "SELECT id,title FROM " . $wpdb->prefix . "ebud_events ORDER BY title ASC" );
				foreach ( (array) $results as $id => $item ) {
					echo '<option value="0-' . $item->id . '"';
					if ( ( isset( $instance['list'] ) ) && ( $instance['list'] =='0-' . $item->id ) ) { echo " selected"; }
					echo '>' . stripslashes( $item->title ) . '</option>';
				}
				unset( $results );
				echo '</optgroup>';
				
				echo '<optgroup label="Groups">';
				$results = $wpdb->get_results( "SELECT id,title FROM " . $wpdb->prefix . "ebud_groups ORDER BY title ASC" );
				foreach ( (array) $results as $id => $item ) {
					echo '<option value="1-' . $item->id . '"';
					if ( ( isset( $instance['list'] ) ) && ( $instance['list'] =='1-' . $item->id ) ) { echo " selected"; }
					echo '>' . stripslashes( $item->title ) . '</option>';
				}
				unset( $results );
				echo '</optgroup>';

				/*
				echo '<optgroup label="Series">';
				$results = $wpdb->get_results( "SELECT id,title FROM " . $wpdb->prefix . "ebud_series ORDER BY title ASC" );
				foreach ( (array) $results as $id => $item ) {
					echo '<option value="2-' . $item->id . '"';
					if ( $instance['list'] =='2-' . $item->id ) { echo " selected"; }
					echo '>' . $item->title . '</option>';
				}
				unset( $results );
				echo '</optgroup>';
				*/
				

				?>

			</select>
		</label>
		
		<label for="<?php echo $this->get_field_id('text'); ?>">Email box text (optional):
			<input class="widefat" id="<?php echo $this->get_field_id('text'); ?>" name="<?php echo $this->get_field_name('text'); ?>" type="text" value="<?php if ( isset( $instance['text'] ) ) { echo $instance['text']; } else { echo 'Enter your email...'; } ?>" />
		</label>
		
		<label for="<?php echo $this->get_field_id('submit_value'); ?>">Submit button text:
			<input class="widefat" id="<?php echo $this->get_field_id('submit_value'); ?>" name="<?php echo $this->get_field_name('submit_value'); ?>" type="text" value="<?php if ( isset( $instance['submit_value'] ) ) { echo $instance['submit_value']; } else { echo 'Subscribe'; } ?>" />
		</label>
		
		<label for="<?php echo $this->get_field_id('subscription_confirmation'); ?>">Confirmation text OR page URL<br />(page URL must be on this site):
			<input class="widefat" id="<?php echo $this->get_field_id('subscription_confirmation'); ?>" name="<?php echo $this->get_field_name('subscription_confirmation'); ?>" type="text" value="<?php if ( isset( $instance['subscription_confirmation'] ) ) { echo $instance['subscription_confirmation']; } else { echo 'Thank you for subscribing!'; } ?>" />
		</label>
		
		<label for="<?php echo $this->get_field_id('pre_text'); ?>">Text before form:
			<input class="widefat" id="<?php echo $this->get_field_id('pre_text'); ?>" name="<?php echo $this->get_field_name('pre_text'); ?>" type="text" value="<?php if ( isset( $instance['pre_text'] ) ) { echo $instance['pre_text']; } ?>" />
		</label>
		
		<label for="<?php echo $this->get_field_id('post_text'); ?>">Text after form:
			<input class="widefat" id="<?php echo $this->get_field_id('post_text'); ?>" name="<?php echo $this->get_field_name('post_text'); ?>" type="text" value="<?php if ( isset( $instance['post_text'] ) ) { echo $instance['post_text']; } ?>" />
		</label>
		
		<label for="<?php echo $this->get_field_id('custom_inputs'); ?>">Custom form inputs:<br />
			<span><input style="width: 15px;" class="widefat" id="<?php echo $this->get_field_id('custom_inputs'); ?>" name="<?php echo $this->get_field_name('custom_inputs'); ?>" type="checkbox" value="name" <?php if ( isset( $instance['custom_inputs'] ) && ( $instance['custom_inputs'] == 'name' ) ) { echo 'checked'; } ?> /> Your Name</span>
		</label>
		
		<input type="hidden" id="<?php echo $this->get_field_id('submit'); ?>" name="<?php echo $this->get_field_name('submit'); ?>" value="1" />
		<?php
	}
	
	
} // End widget_PluginBuddyEmailBuddy class.

// Register function to create widget.
add_action('widgets_init', 'widget_PluginBuddyEmailBuddy_init');

function widget_PluginBuddyEmailBuddy_init() {
	register_widget('widget_PluginBuddyEmailBuddy');
}
?>