CREATE TABLE `%PREFIX%ebud_events` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(45) NOT NULL,
  `initial_date` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `recur_amount` int(10) unsigned NOT NULL,
  `reminder1_amount` int(10) unsigned NOT NULL,
  `reminder1_unit` varchar(45) NOT NULL,
  `reminder2_amount` int(10) unsigned NOT NULL,
  `reminder2_unit` varchar(45) NOT NULL,
  `reminder3_amount` int(10) unsigned NOT NULL,
  `reminder3_unit` varchar(45) NOT NULL,
  `autoadd_group` int(10) unsigned NOT NULL COMMENT 'ID of group to auto subscribe to.',
  `autoadd_series` int(10) unsigned NOT NULL COMMENT 'ID of series to auto subscribe to.',
  `updated` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `created` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `recur_unit` varchar(45) NOT NULL,
  `reminder1_message` int(10) unsigned NOT NULL,
  `reminder2_message` int(10) unsigned NOT NULL,
  `reminder3_message` int(10) unsigned NOT NULL,
  `welcome_message` int(10) unsigned NOT NULL,
  `cron_keys` text NOT NULL,
  PRIMARY KEY (`id`)
)CHARACTER SET utf8 COLLATE utf8_unicode_ci;
CREATE TABLE `%PREFIX%ebud_groups` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(45) NOT NULL,
  `updated` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `creator` int(10) unsigned NOT NULL,
  `created` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `autoadd_event` int(10) unsigned NOT NULL COMMENT 'ID of event to auto subscribe to',
  `autoadd_series` int(10) unsigned NOT NULL COMMENT 'ID of series to auto subscribe to',
  PRIMARY KEY (`id`)
)CHARACTER SET utf8 COLLATE utf8_unicode_ci;
CREATE TABLE `%PREFIX%ebud_messages` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(45) NOT NULL,
  `body` text NOT NULL,
  `updated` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `created` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `creator` int(10) unsigned NOT NULL,
  `updater` int(10) unsigned NOT NULL,
  `message_id` int(10) unsigned NOT NULL,
  PRIMARY KEY (`id`)
)CHARACTER SET utf8 COLLATE utf8_unicode_ci;
CREATE TABLE `%PREFIX%ebud_queue` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `subscriber_id` int(10) unsigned NOT NULL,
  `step` int(10) unsigned NOT NULL COMMENT 'Event or series step',
  `item_id` int(10) unsigned NOT NULL,
  `item_type` tinyint(1) unsigned NOT NULL COMMENT '0=event,1=group,2=series',
  `message_id` int(10) unsigned NOT NULL,
  PRIMARY KEY (`id`)
)CHARACTER SET utf8 COLLATE utf8_unicode_ci;
CREATE TABLE `%PREFIX%ebud_subscribers` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `uid` int(10) unsigned NOT NULL,
  `email` varchar(45) NOT NULL,
  `updated` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `created` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `meta` longtext NOT NULL,
  PRIMARY KEY (`id`),
  KEY `email` (`email`)
)CHARACTER SET utf8 COLLATE utf8_unicode_ci;
CREATE TABLE `%PREFIX%ebud_subscriptions` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `subscriber_id` int(10) unsigned NOT NULL,
  `subscribed_id` int(10) unsigned NOT NULL COMMENT 'What they are subscribed to.',
  `sub_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '0=event,1=group,2=series',
  `series_step` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT 'For series, monitors the current step the user is on.',
  `activated` tinyint(1) unsigned NOT NULL,
  PRIMARY KEY (`id`),
  KEY `subscribed_id` (`subscribed_id`),
  KEY `sub_type` (`sub_type`)
)CHARACTER SET utf8 COLLATE utf8_unicode_ci;
