<?php
/**
 *
 * Plugin Name: EmailBuddy
 * Plugin URI: http://pluginbuddy.com/
 * Description: Email newsletter solution for WordPress. Send broadcasts, event reminders, and manage subscribers by groups.
 * Version: 1.0.31
 * Author: The PluginBuddy Team
 * Author URI: http://pluginbuddy.com/
 *
 * Installation:
 * 
 * 1. Download and unzip the latest release zip file.
 * 2. If you use the WordPress plugin uploader to install this plugin skip to step 4.
 * 3. Upload the entire plugin directory to your `/wp-content/plugins/` directory.
 * 4. Activate the plugin through the 'Plugins' menu in WordPress Administration.
 * 
 * Usage:
 * 
 * 1. Navigate to the new menu in the Wordpress Administration Panel.
 *
 */

 
if (!class_exists("PluginBuddyEmailBuddy")) {
	class PluginBuddyEmailBuddy {
		var $_version = '1.0.31';
		var $_updater = '1.0.8';
		var $_var = 'pluginbuddy-emailbuddy';
		var $_name = 'EmailBuddy';
		var $_timeformat = '%b %e, %Y, %l:%i%p';	// mysql time format
		var $_timestamp = 'M j, Y, g:iA e';			// php timestamp format
		var $_defaults = array(
			'return_name'						=> 'Your Name',
			'return_address'					=> 'noreplay@yourdomain.com',
			'double_opt'						=> '1',					// Require user to click on a link in an email to authorize subscription.
			'eb_promo'							=> '1',					// Include promotional link to EmailBuddy in email footers.
			'log_level'							=> '1',					// Valid options: 0 = none, 1 = errors only, 2 = errors + warnings, 3 = debugging (all kinds of actions)
			'emails_per_cycle'					=> '50',				// Number of emails to send per queue_process();
			'cycle_pause'						=> '1',					// Minutes. Time ahead to schedule cycle_pause for.
			'smtp'								=> '',					// Override default server SMTP.
			'smtp_port'							=> '',					// Override default server SMTP port.
			'double_subject'					=> 'Please validate your email',
			'double_body'						=> 'Please click the link below to validate your email and activate your email subscription.',
			'email_footer'						=>	'',
			'subscription_alert'				=>	'0',				// Whether to send notification of subscriptions.
			'alert_email'						=>	'',					// Email address to send subscription alerts to.
			'send_welcome'						=>	'0',
			'welcome_subject'					=>	'',
			'welcome_body'						=>	'',
			'unsubscribe_text'					=>	'If you received this email in error or would like to unsubscribe, click the link below:',
			'customstyles_enabled'				=>	false,
			'custom_inputs'						=>	array(
														'name'		=>		array( 'Your Name', 'Sir/Madam' ),
													)
		);
		var $_mailvars = array(
			'{email_address}'					=> 'User\'s email address',
			'{datetime}'						=> 'Date & time when message is sent',
			'{siteurl}'							=> 'URL to this site.',
			'{unsubscribe}'						=> 'Unsubscribe link',
			'{blogname}'						=> 'Name of blog',
			'{event_title}'						=> 'Title of event that sent email',
			'{group_title}'						=> 'Title of group email sent to',
			'{series_title}'					=> 'Title of series that sent email',
			'{title}'							=> 'Title of email',
		);
		var $error = '';
		var $throttle = '5';	// Number of seconds after an action to prevent user from doing another. IP-based.
		
		
		
		// Default constructor. This is run when the plugin first runs.
		function PluginBuddyEmailBuddy() {
			$this->_pluginPath = dirname( __FILE__ );
			$this->_pluginRelativePath = ltrim( str_replace( '\\', '/', str_replace( rtrim( ABSPATH, '\\\/' ), '', $this->_pluginPath ) ), '\\\/' );
			$this->_pluginURL = site_url() . '/' . $this->_pluginRelativePath;
			if ( isset( $_SERVER['HTTPS'] ) && $_SERVER['HTTPS'] == 'on' ) { $this->_pluginURL = str_replace( 'http://', 'https://', $this->_pluginURL ); }
			$this->_selfLink = array_shift( explode( '?', $_SERVER['REQUEST_URI'] ) ) . '?page=' . $this->_var;
			
			require_once( dirname( __FILE__ ) . '/classes/widget.php' );
			
			add_action($this->_var.'-queue_process', array(&$this, 'queue_process') );
			add_filter('cron_schedules', array(&$this, 'cron_add_schedules'));
			add_filter('cron_recur_event', array(&$this, 'cron_recur_event'));
			add_filter($this->_var.'-cron_process_event', array(&$this, 'cron_process_event'), 10, 2);
			
			
			if ( is_admin() ) { // Runs when an admin is in the dashboard.
				add_action( 'init', array( &$this, 'upgrader_register' ), 50 );
				add_action( 'init', array( &$this, 'upgrader_select' ), 100 );
				add_action( 'init', array( &$this, 'upgrader_instantiate' ), 101 );
				require_once( $this->_pluginPath . '/classes/admin.php');
				require_once( $this->_pluginPath . '/lib/updater/updater.php');
				// NOTE: In 3.1 use register_update_hook()
				register_activation_hook( __FILE__, array( &$this, 'activate' ) ); // Run some code when plugin is activated in dashboard.
				//add_action( 'admin_menu', array( &$this, 'public_admin_menu' ) ); // Add public dashboard menus
			} else { // Runs when in non-dashboard parts of the site.
				add_action( 'template_redirect', array( &$this, 'init_public'), 2 );
				add_shortcode( 'emailbuddy', array( &$this, 'shortcode' ) );
				
				add_action( $this->_var . '-widget', array( &$this, 'widget' ), 10, 2 ); // Add action to run widget function.
			}
		}
		
		/**
		 *	alert()
		 *
		 *	Displays a message to the user at the top of the page when in the dashboard.
		 *
		 *	$message		string		Message you want to display to the user.
		 *	$error			boolean		OPTIONAL! true indicates this alert is an error and displays as red. Default: false
		 *	$error_code		int			OPTIONAL! Error code number to use in linking in the wiki for easy reference.
		 */
		function alert( $message, $error = false, $error_code = '' ) {
			$log_error = false;
			
			echo '<div id="message" class="';
			if ( $error == false ) {
				echo 'updated fade';
			} else {
				echo 'error';
				$log_error = true;
			}
			if ( $error_code != '' ) {
				$message .= '<p><a href="http://ithemes.com/codex/page/' . $this->_name . ':_Error_Codes#' . $error_code . '" target="_new"><i>' . $this->_name . ' Error Code ' . $error_code . ' - Click for more details.</i></a></p>';
				$log_error = true;
			}
			if ( $log_error === true ) {
				$this->log( $message . ' Error Code: ' . $error_code, 'error' );
			}
			echo '"><p><strong>'.$message.'</strong></p></div>';
		}
		
		function public_alert( $alert_message ) {
			
			if ( !isset( $this->alerted ) ) {
				$this->alerted = false;
			}
			if ( $this->alerted !== true ) {
				?>
				
				<style type="text/css">
					#pluginbuddyalert {
						overflow: hidden;
						width: 100%;
						text-align: center;
						position: fixed;
						top: 0;
						left: 0;
						height: 0;
						font: 20px/40px arial, sans-serif;
						opacity: .9;
						z-index: 30;
						margin-bottom: 10px;
						
						-moz-box-shadow: 0px 0px 15px 5px #000000;
						border-bottom: 1px solid;
						text-shadow:0 -1px 1px rgba(0,0,0,0.5); 
					}
				</style>
				
				
				<?php
				//echo '<link rel="stylesheet" href="'.$this->_pluginURL . '/style_public.css" type="text/css" media="all" />';
				add_action( 'wp_footer', array( &$this, 'print_footer') );
				
				echo '<script type="text/javascript">jQuery(document).ready(function() {jQuery(\'#pluginbuddyalert\').alert(\'' . $alert_message . '\');});</script>';
				echo '<div id="pluginbuddyalert"></div>';
			}
			
			$this->alerted = true;
		}
		

		function print_footer() {
			$this->load();
			
			wp_enqueue_style('emailbuddy_public-defaults', $this->_pluginURL . '/style_defaults.css' );
			wp_print_styles('emailbuddy_public-defaults');
			
			if ( $this->_options['customstyles_enabled'] === true ) {
				$wp_upload_dir = WP_UPLOAD_DIR();
				$custom_style_file = $wp_upload_dir['basedir'] . '/emailbuddy/style_custom.css';
				if ( file_exists( $custom_style_file ) ) {
					$custom_style_url = $wp_upload_dir['baseurl'] . '/emailbuddy/style_custom.css';
					wp_enqueue_style('emailbuddy_public-custom', $custom_style_url );
					wp_print_styles('emailbuddy_public-custom');
				} else {
					echo '<!-- EmailBuddy ERROR: Missing style file! -->';
				}
			}
		}
		
		
		/**
		 * activate()
		 *
		 * Run on plugin activation. Useful for setting up initial stuff.
		 *
		 */
		function activate() {
			//echo 'checking database...';
			global $wpdb;
			$wpdb->show_errors=true;
			
			$db_ver = 2; // Current DB version number.
			$update_sql = false;
			
			if($wpdb->get_var("SHOW TABLES LIKE '".$wpdb->prefix."ebud_queue'") != $wpdb->prefix."ebud_queue") { // Table does not exist.
				//echo 'Creating database tables ...';
				$this->log( 'About to begin creating database tables ...' );
				
				$update_sql = true;
			} elseif (get_option($this->_var.'-db') < $db_ver) { // Needs updated.
				//echo 'Updating database tables ...';
				$this->log( 'About to begin updating database tables ...' );
				
				$update_sql = true;
			}
			
			if ( $update_sql === true ) {
				$this->log( 'Updating database tables...' );
			
				require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
				
				$sql = str_replace('%PREFIX%', $wpdb->prefix, file_get_contents(dirname( __FILE__ ).'/db.sql'));
				$sql = explode( ';', $sql );
				foreach ( (array) $sql as $key => $item ) {
					$item = str_replace( '`', '', $item );
					//echo '<pre>' . $item . '</pre><br /><Br />';
					dbDelta( $item . ';' );
				}
			}
			
			// If it still doesnt exist, fail.
			if($wpdb->get_var("SHOW TABLES LIKE '".$wpdb->prefix."ebud_queue'") != $wpdb->prefix."ebud_queue") {
				$this->log( 'ERROR! Unable to update database tables...', 'error' );
				die("Error #8541. Unable to create EmailBuddy database table(s).");
			} else { // Success probably so update db version.
				$this->_options=add_option( $this->_var.'-db', $db_ver,'','no'); // Database version. Useful for later upgrades.
				update_option( $this->_var.'-db', $db_ver );
				$this->log( 'Updating database tables SUCCEEDED...' );
			}
		}
		
		/**
		 * init_public()
		 *
		 * Run on on public pages (non-dashboard).
		 *
		 */
		function init_public() {
			require_once(dirname( __FILE__ ).'/classes/public.php');
		}
		
		// OPTIONS STORAGE //////////////////////
		
		
		function save() {
			add_option($this->_var, $this->_options, '', 'no'); // 'No' prevents autoload if we wont always need the data loaded.
			update_option($this->_var, $this->_options);
			return true;
		}
		
		
		function load() {
			$this->_options=get_option($this->_var);
			$options = array_merge( $this->_defaults, (array)$this->_options );
			
			if ( $options !== $this->_options ) {
				// Defaults existed that werent already in the options so we need to update their settings to include some new options.
				$this->_options = $options;
				$this->save();
			}
			
			return true;
		}
		
		
		function shortcode( $instance ) {
			if ( $instance['type'] == 'event' ) {
				$instance['type'] = '0';
			} elseif ( $instance['type'] == 'group' ) {
				$instance['type'] = '1';
			} elseif ( $instance['type'] == 'series' ) {
				$instance['type'] = '2';
			}
			
			if ( !empty( $instance['text'] ) ) {
				$text = $instance['text'];
			} else {
				$text = '';
			}
			
			if ( !empty( $instance['custom_inputs'] ) ) {
				$custom_inputs = $instance['custom_inputs'];
			} else {
				$custom_inputs = '';
			}
			
			return $this->subscription_form( $instance['type'] . '-' . $instance['list'], $instance['confirmation'], $instance['button'], $text, '', '', $custom_inputs );
		}
		
		
		function widget( $instance ) {
			if ( !empty( $instance['custom_inputs'] ) ) {
				$custom_inputs = $instance['custom_inputs'];
			} else {
				$custom_inputs = '';
			}
			
			echo $this->subscription_form( $instance['list'], $instance['subscription_confirmation'], $instance['submit_value'], $instance['text'], $instance['pre_text'], $instance['post_text'], $custom_inputs );
		}
		
		
		function subscription_form( $list, $confirmation, $button, $text = '', $pre_text = '', $post_text = '', $custom_inputs ) {
			$this->load();
			
			add_action( 'wp_footer', array( &$this, 'print_footer') );
			
			$output = '';
			
			if ( !empty( $pre_text ) ) {
				$output .= '<div class="emailbuddy_pretext">' . $pre_text . '</div>';
			}
			
			$output .= '<form method="post" class="emailbuddy"';
			if ( !empty( $confirmation ) && ( substr( strtolower( $confirmation ), 0, 7 ) == 'http://' ) ) {
				$output .= ' action="' . $confirmation . '" ';
			}
			$output .= '>';
			
			if ( $custom_inputs == 'name' ) {
				$output .= '<input type="hidden" name="custom_inputs" value="name" />';
			
				$output .= '<input type="text" name="custom_inputs_name" value="' . $this->_options['custom_inputs']['name'][0] . '" ';
				$output .= ' onfocus="if (this.value == \'' . addslashes( $this->_options['custom_inputs']['name'][0] ) . '\') {this.value = \'\';}" onblur="if (this.value == \'\') {this.value = \'' . addslashes( $this->_options['custom_inputs']['name'][0] ) . '\';}"';
				$output .= '/>';
			}
			
			$output .= '<input type="email" name="email_address" value="'; // Using input type email for iphone and other stuff to handle the form better.
			if ( !empty( $text ) ) { // If text set then use it in box.
				$output .= $text;
			} else { // No text so we will put email if available.
				global $current_user;
				get_currentuserinfo();
				if ( isset( $current_user->user_email ) ) {
					$output .= $current_user->user_email;
				}
			}
			$output .= '"';
			if ( !empty( $text ) ) {
				$output .= ' onfocus="if (this.value == \'' . addslashes( $text ) . '\') {this.value = \'\';}" onblur="if (this.value == \'\') {this.value = \'' . addslashes( $text ) . '\';}"';
			}
			$output .= ' />';
			
			$output .= '<input type="submit" name="emailbuddy_submit" value="' . $button . '" />';
			$output .= '<input type="hidden" name="subscription_confirmation" value="' . $confirmation . '" />';
			$output .= '<input type="hidden" name="list" value="' . $list . '" />';
			$output .= '</form>';
			
			if ( !empty( $post_text ) ) {
				$output .= '<div class="emailbuddy_posttext">' . $post_text . '</div>';
			}
			
			return $output;
		}
		
		/**
		 *	cron_add_schedules()
		 *
		 *	Adds the following intervals to cron schedular: weekly, monthly
		 *
		 *	$schedules	array		Array of existing schedules.
		 *	@return		array		Array of all schedules, old and new.
		 */
		function cron_add_schedules( $schedules = array() ) {
			$schedules['weekly'] = array( 'interval' => 604800, 'display' => 'Once Weekly' );
			$schedules['monthly'] = array( 'interval' => 2629744, 'display' => 'Once Monthly' );
			$schedules['yearly'] = array( 'interval' => 31556926, 'display' => 'Once Yearly' );
			return $schedules;
		}
		
		// sets up new cron stuff for a recurring event...
		function cron_recur_event( $event_id, $delete_only = false ) {
			if ( !function_exists( 'seconds_in_time' ) ) {
				function seconds_in_time( $unit ) {
					if ( $unit == 'hourly' ) {
						return '3600';
					} elseif ( $unit == 'daily' ) {
						return '86400';
					} elseif ( $unit == 'weekly' ) {
						return '604800';
					} elseif ( $unit == 'monthly' ) {
						return '2629744';
					}
				}
			}
			
			global $wpdb;
			$results = $wpdb->get_row( "SELECT cron_keys,recur_amount,recur_unit,UNIX_TIMESTAMP(initial_date) as initial_date,reminder1_amount,reminder2_amount,reminder3_amount,reminder1_unit,reminder2_unit,reminder3_unit FROM " . $wpdb->prefix . "ebud_events WHERE id='" . $wpdb->escape( $event_id ) . "'", ARRAY_A );
			if ( isset( $results ) ) {
				extract( $results );
			} else {
				$cron_keys = '';
			}
			
			// Delete any existing cron jobs for this event.
			if ( $cron_keys != '' ) {
				$cron_keys = unserialize( $cron_keys );
				$cron = get_option('cron');
				foreach ( (array) $cron as $time => $item ) {
					// Loop through each schedule for this time
					foreach ( (array) $item as $event_name => $event ) {
						if ( $event_name === 'pluginbuddy-emailbuddy-cron_recur_event' ) {
							// Loop through each EmailBuddy cron
							foreach ( (array) $event as $item_name => $item ) {
								//echo $item_name . '<br />';
								if ( in_array( $item_name, $cron_keys ) ) {
									//echo 'delete' . $item_name . '<br />';
									$this->log( 'Removed cron ' . $item_name );
								}
							}
						}
					}
				}
			}
			
			if ( $delete_only === false ) {
				// Create new cron jobs.
				
				$cron_keys = array();
				
				// reminder1:
				$initial_modifier = $initial_date - ( $reminder1_amount * seconds_in_time( $reminder1_unit ) );
				wp_schedule_single_event( $initial_modifier, $this->_var.'-cron_process_event', array( $event_id, '1' ) );
				$key = md5(serialize(array( $event_id, '1' )));
				array_push( $cron_keys, $key );
				$this->log( 'Scheduled step1 of single event "' . $event_id . '" at time "' . $initial_modifier . '" with key "' . $key . '"' );
				
				// reminder2:
				$initial_modifier = $initial_date - ( $reminder2_amount * seconds_in_time( $reminder2_unit ) );
				wp_schedule_single_event( $initial_modifier, $this->_var.'-cron_process_event', array( $event_id, '2' ) );
				$key = md5(serialize(array( $event_id, '2' )));
				array_push( $cron_keys, $key );
				$this->log( 'Scheduled step2 of single event "' . $event_id . '" at time "' . $initial_modifier . '" with key "' . $key . '"' );
				
				// reminder3:
				$initial_modifier = $initial_date - ( $reminder3_amount * seconds_in_time( $reminder3_unit ) );
				wp_schedule_single_event( $initial_modifier, $this->_var.'-cron_process_event', array( $event_id, '3' ) );
				$key = md5(serialize(array( $event_id, '3' )));
				array_push( $cron_keys, $key );
				$this->log( 'Scheduled step3 of single event "' . $event_id . '" at time "' . $initial_modifier . '" with key "' . $key . '"' );
				
				// Set event recurring stuff. Skip is set to '' to not recur.
				if ( $recur_unit != '' ) {
					wp_schedule_event( $initial_date, $recur_unit, $this->_var.'-cron_recur_event', array( $event_id ) );
					$key = md5(serialize(array( $event_id )));
					array_push( $cron_keys, $key );
					$this->log( 'Scheduled recurring event "' . $event_id . '" with recur unit "' . $recur_unit . '" with recur value of "' . $recur_amount . '" with key "' . $key . '"' );
				
					$wpdb->query( "UPDATE " . $wpdb->prefix . "ebud_events SET cron_keys='" . serialize( $cron_keys ) . "' WHERE id='" . $event_id . "'" );
				}
			}
		}
		
		
		/**
		 *	touch_subscriber()
		 *
		 *	Gets & returns user's subscriber id if they already exist in db. Adds them otherwise and returns subscriber id.
		 *
		 *	$email		string		Email address of subscriber to get id for or add.
		 *	$meta		array		Associate array of custom meta data paired with the values. Do NOT pre-serialize before passing to this function.
		 *	@return		int			Subscriber ID number. You can use this to add a subscription.
		 */
		function touch_subscriber( $email, $event_id = '', $meta = '' ) {
			
			global $wpdb;
			$email = $wpdb->escape( $email );
			if ( !empty( $meta ) ) {
				$meta = $wpdb->escape( serialize( $meta ) );
			}
			
			// check if email already belongs to a WordPress user account. If so assign their uid to our EB entry.
			require_once(ABSPATH . WPINC . '/user.php'); // replaced deprecated registration.php with user.php, this file now includes email_exists
			if ( email_exists( $email ) ) {
				$wp_uid = email_exists( $email );
			} else {
				$wp_uid = '';
			}
			
			$subscriber_sql = "SELECT id FROM " . $wpdb->prefix . "ebud_subscribers WHERE email='" . $email . "' LIMIT 1";
			
			$subscriber_id = $wpdb->get_var( $subscriber_sql );
			if ( empty( $subscriber_id ) ) {
				$wpdb->query( "INSERT INTO " . $wpdb->prefix . "ebud_subscribers ( email, created, uid, meta ) VALUES( '" . $email . "', NOW(), '" . $wp_uid . "', '" . $meta . "' )" );
				$subscriber_id = $wpdb->get_var( $subscriber_sql );
			} else { // User already subscribed so update meta.
				$wpdb->query( "UPDATE " . $wpdb->prefix . "ebud_subscribers SET meta='" . $meta . "' WHERE id='" . $subscriber_id . "' LIMIT 1" );
			}
			
			return $subscriber_id;
		}
		
		
		// Now validates all occurances of this email address!
		//function validate( $email, $event_id, $type, $validation_code ) {
		function validate( $email, $validation_code ) {
			//$this->log( 'Validating email "' . $email . '" for list "' . $event_id . '" of type "' . $type . '" with validation code "' . $validation_code . '".' );
			$this->log( 'Validating email "' . $email . '" with validation code "' . $validation_code . '".' );
			if ( md5( $email . '34d' ) != $validation_code ) {
				$this->log( 'Validation failed for "' . $email . '". Invalid validation code.' );
				return false;
			}
			
			global $wpdb;
			$subscriber_id = $wpdb->get_var( "SELECT id FROM " . $wpdb->prefix . "ebud_subscribers WHERE email='" . $wpdb->escape( $email ) . "'" );
			if ( isset( $subscriber_id ) ) {
				//$wpdb->query( "UPDATE " . $wpdb->prefix . "ebud_subscriptions SET activated='1' WHERE subscriber_id='" . $subscriber_id . "' AND subscribed_id='" . $wpdb->escape( $event_id ) . "' AND sub_type='" . $wpdb->escape( $type ) . "'" );
				$wpdb->query( "UPDATE " . $wpdb->prefix . "ebud_subscriptions SET activated='1' WHERE subscriber_id='" . $subscriber_id . "'" ); // AND subscribed_id='" . $wpdb->escape( $event_id ) . "' AND sub_type='" . $wpdb->escape( $type ) . "'" );
				//echo "UPDATE " . $wpdb->prefix . "ebud_subscriptions SET activated='1' WHERE subscriber_id='" . $subscriber_id . "' AND subscribed_id='" . $wpdb->escape( $event_id ) . "' AND sub_type='" . $wpdb->escape( $type ) . "'";
				$this->log( 'Validated "' . $email . '".' );
				return true;
			} else {
				$this->log( 'Could not validate "' . $email . '" since we could not find subscriber.' );
				return false;
			}
		}
		
		
		// Returns true on success, false otherwise.
		function subscribe( $email, $event_id, $type, $custom_inputs = '' ) {
			$this->log( 'Subscribing "' . $email . '" to list "' . $event_id . '" of type "' . $type . '"' );
			
			// Prevent bots from subscribing people by throttling by IP.
			if ( get_transient( 'eb_1_' . $_SERVER['REMOTE_ADDR'] ) ) {
				$this->error = 'Error #593-1. You are performing actions too quickly & have been throttled. Please wait & try again.';
				return false;
			} else {
				set_transient( 'eb_1_' . $_SERVER['REMOTE_ADDR'], 'true', $this->throttle );
			}
			
			$call_event = '0';
			$call_group = '0';
			$call_series = '0';
			$got_success = false;
			$meta = '';
			
			global $wpdb;
			
			if ( $type == 0 ) { // event
				$results = $wpdb->get_row( "SELECT autoadd_group,autoadd_series,title FROM " . $wpdb->prefix . "ebud_events WHERE id='" . $wpdb->escape( $event_id ) . "' LIMIT 1" );
				
				if ( !isset( $results ) ) {
					die( 'Invalid event ID.  Update your widget to make sure you select a valid list.' );
				}
				
				if ( $results->autoadd_group != '0' ) {
					$call_group = $results->autoadd_group;
				}
				if ( $results->autoadd_series != '0' ) {
					$call_series = $results->autoadd_series;
				}
				
				$description = 'event "' . $results->title . '"';
				
				unset( $results );
				
				$call_event = $event_id;
			} elseif ( $type == 1 ) { // group
				$results = $wpdb->get_row( "SELECT autoadd_event,autoadd_series,title FROM " . $wpdb->prefix . "ebud_groups WHERE id='" . $wpdb->escape( $event_id ) . "' LIMIT 1" );
				
				if ( !isset( $results ) ) {
					die( 'Invalid event ID.  Update your widget to make sure you select a valid list.' );
				}
				
				if ( $results->autoadd_event != '0' ) {
					$call_event = $results->autoadd_event;
				}
				if ( $results->autoadd_series != '0' ) {
					$call_series = $results->autoadd_series;
				}
				
				$description = 'group "' . $results->title . '"';
				
				unset( $results );
				
				$call_group = $event_id;
			} elseif ( $type == 2 ) { // series
				$results = $wpdb->get_row( "SELECT autoadd_event,autoadd_group,title FROM " . $wpdb->prefix . "ebud_series WHERE id='" . $wpdb->escape( $event_id ) . "' LIMIT 1" );
				
				if ( !isset( $results ) ) {
					die( 'Invalid event ID.  Update your widget to make sure you select a valid list.' );
				}
				
				if ( $results->autoadd_event != '0' ) {
					$call_event = $results->autoadd_event;
				}
				if ( $results->autoadd_group != '0' ) {
					$call_group = $results->autoadd_group;
				}
				
				
				$description = 'series "' . $results->title . '"';
				unset( $results );
				
				$call_series = $event_id;
			}
			
			if ( !empty( $custom_inputs ) ) {
				$custom_inputs = explode( ',', $custom_inputs );
				foreach( $custom_inputs as $custom_input ) {
					$meta[$custom_input] = $_POST['custom_inputs_' . $custom_input];
				}
			} else {
				$meta = '';
			}
			
			if ( $call_event  != '0' ) {
				if ( $this->subscribe_event( $email, $call_event, false, $meta ) ) {
					$got_success = true;
				}
			}
			if ( $call_group != '0' ) {
				if ( $this->subscribe_group( $email, $call_group, false, $meta ) ) {
					$got_success = true;
				}
			}
			if ( $call_series != '0' ) {
				if ( $this->subscribe_series( $email, $call_series, false, $meta ) ) {
					$got_success = true;
				}
			}
			
			if ( $got_success === true ) {
				// If welcome email defined, send it here.
				if ( $this->_options['double_opt'] == '1' ) {
					//$body = "\r\n\r\nVALIDATION LINK:\r\n" . get_option( 'home' ) . '/?validate=' . urlencode( $email ) . '&list=' . $event_id . '&type=' . $type . '&v=' . md5( $email . '34d' );
					$body = "\r\n\r\nVALIDATION LINK:\r\n" . get_option( 'home' ) . '/?validate=' . urlencode( $email ) . '&v=' . md5( $email . '34d' );
					
					$this->send_email( $email, $this->_options['double_subject'], $this->_options['double_body'] . $body );
				}
				
				// If subscription alerts enabled, send email to defined alert email with details of subscription.
				if ( isset( $this->_options['subscription_alert'] ) && ( $this->_options['subscription_alert'] == '1' ) ) {
					$descriptionb = 'You have received a new subscription to your EmailBuddy list. Details:' . "\r\n\r\n";
					
					$descriptionb .= 'Site: ' . site_url() . "\r\n";
					$descriptionb .= 'Subscription: ' . $description . "\r\n";
					$descriptionb .= 'Email: ' . $email . "\r\n\r\n";
					
					$descriptionb .= 'Time: ' . date( $this->_timestamp . ' ' . get_option( 'gmt_offset' ), time() + (get_option( 'gmt_offset' )*3600) ) . "\r\n";
					$descriptionb .= 'IP Address: ' . $_SERVER['REMOTE_ADDR'] . "\r\n";
					$this->send_email( $this->_options['alert_email'], 'EmailBuddy Subscription Notification', $descriptionb );
				}
				
				return true; // At least one thing succeeded!
			} else {
				return false;
			}
		}
		
		
		// type = 0. return true on success, false otherwise.
		// $meta = serialized array of value/pairs to save
		function subscribe_event( $email, $event_id, $force_validated = false, $meta = '' ) {
			if ( !is_email( $email ) ) { // Verify email is valid format.
				return false;
			}
			
			$subscriber_id = $this->touch_subscriber( $email, $event_id, $meta );
			
			
			global $wpdb;
			
			// Return false if user already subscribed to this list.
			if ( $wpdb->get_var( "SELECT COUNT(*) FROM " . $wpdb->prefix . "ebud_subscriptions WHERE subscriber_id='" . $subscriber_id . "' AND subscribed_id='" . $event_id . "' AND sub_type='0'") >= 1 ) {
				$this->error = 'This email address is already subscribed to this list.';
				return false;
			}
			
			// Return false if this event doesnt actually exist.
			if ( $wpdb->get_var( "SELECT COUNT(*) FROM " . $wpdb->prefix . "ebud_events WHERE id='" . $event_id . "'") == 0 ) {
				$this->error = 'Invalid event.';
				return false;
			}
			
			// If not double opt-in, then we can set this subscription to activated now.
			if ( ( $this->_options['double_opt'] != '1' ) || ( $force_validated === true ) ) {
				$activated = '1';
			} else {
				$activated = '0';
			}
			
			$wpdb->query( "INSERT INTO " . $wpdb->prefix . "ebud_subscriptions ( subscriber_id, subscribed_id, sub_type, activated ) VALUES( '" . $subscriber_id . "', '" . $event_id . "', '0', '" . $activated . "' )" );
			
			// Add event to the WP cron scheduler to run process_event()
			// TODO: send welcome email if defined
			return true;
		}
		
		
		// type=1. return true on success, false otherwise.
		function subscribe_group( $email, $event_id, $force_validated = false, $meta = '' ) {
			if ( !is_email( $email ) ) { // Verify email is valid format.
				$this->error = 'The supplied email address appears to be an invalid format.';
				return false;
			}
			
			$subscriber_id = $this->touch_subscriber( $email, $event_id, $meta );

			global $wpdb;
			
			// Return false if user already subscribed to this list.
			if ( $wpdb->get_var( "SELECT COUNT(*) FROM " . $wpdb->prefix . "ebud_subscriptions WHERE subscriber_id='" . $subscriber_id . "' AND subscribed_id='" . $event_id . "' AND sub_type='1'") >= 1 ) {
				$this->error = 'This email address is already subscribed to this list.';
				return false;
			}
			
			// If not double opt-in, then we can set this subscription to activated now.
			if ( ( $this->_options['double_opt'] != '1' ) || ( $force_validated === true ) ) {
				$activated = '1';
			} else {
				$activated = '0';
			}
			
			
			$wpdb->query( "INSERT INTO " . $wpdb->prefix . "ebud_subscriptions ( subscriber_id, subscribed_id, sub_type, activated ) VALUES( '" . $subscriber_id . "', '" . $event_id . "', '1', '" . $activated . "' )" );
			
			// TODO: send welcome email if defined
			return true;
		}
		
		
		// type=2. return true on success, false otherwise.
		/* Postponed to future version.
		function subscribe_series( $email, $event_id, $force_validated = false ) {
			if ( !is_email( $email ) ) { // Verify email is valid format.
				return false;
			}
			
			$subscriber_id = $this->touch_subscriber( $email, $event_id );
			
			global $wpdb;
			// Return false if user already subscribed to this list.
			if ( $wpdb->get_var( "SELECT COUNT(*) FROM " . $wpdb->prefix . "ebud_subscriptions WHERE subscriber_id='" . $subscriber_id . "' AND subscribed_id='" . $event_id . "' AND sub_type='2'") >= 1 ) {
				return false;
			}

			
			// If not double opt-in, then we can set this subscription to activated now.
			if ( ( $this->_options['double_opt'] != '1' ) || ( $force_validated === true ) ) {
				$activated = '1';
			} else {
				$activated = '0';
			}
			
			$wpdb->query( "INSERT INTO " . $wpdb->prefix . "ebud_subscriptions ( subscriber_id, subscribed_id, sub_type, activated ) VALUES( '" . $subscriber_id . "', '" . $event_id . "', '2', '" . $activated . "' )" );
			
			// Add series checking to the schedular cron so once an hour it will select *from wp_ebud_subscriptions where type=2 and the proper time period has elapsed since the last email sent
			// TODO: send welcome email if defined
			return true;
		}
		*/
		
		
		// Loop through everyone in the list and add them to queue.
		// Returns number of emails enqueued.
		function broadcast( $event_id, $type, $message_id ) {
			$this->log( 'Broadcasting message "' . $message_id . '" to list "' . $event_id . '" of type "' . $type . '". process_event()' );
			
			global $wpdb;
			
			$event_id = $wpdb->escape( $event_id );
			$type = $wpdb->escape( $type );
			$message_id = $wpdb->escape( $message_id );

			$results = $wpdb->get_results( "SELECT subscriber_id FROM " . $wpdb->prefix . "ebud_subscriptions WHERE subscribed_id='" . $event_id . "' AND sub_type='" . $type . "' AND activated='1'" );
			$i = 0;
			foreach ( (array) $results as $id => $item ) {
				$i++;
				$wpdb->query( "INSERT INTO " . $wpdb->prefix . "ebud_queue ( subscriber_id, item_id, item_type, message_id ) VALUES( '" . $item->subscriber_id . "', '" . $event_id . "', '" . $type . "', '" . $message_id . "' )" );
			}
			
			$this->launch_queue_via_cron();
			
			return $i;
		}
		
		
		/**
		 *	cron_process_event()
		 *
		 *	Whenever a scheduled event is triggered, run this.
		 *
		 *	$event_id	int		ID number of the event in the database.
		 *	$step		int		Message step that triggered. Valid values: 1, 2, or 3.
		 *	@return		int		Number of enqueed items.
		 *
		 */
		function cron_process_event( $event_id, $step ) {
			$this->log( 'Processing event "' . $event_id . '" at step "' . $step . '" cron_process_event()' );
			$i = 0;
			global $wpdb;
			
			$event_id = $wpdb->escape( $event_id );
			$step = $wpdb->escape( $step );
			
			//$message_id = $wpdb->escape( $message_id );
			$message_id = $wpdb->get_var( "SELECT reminder" . $step . "_message FROM " . $wpdb->prefix . "ebud_events WHERE id='" . $event_id . "'" );
			
			// log the message id check
			$this->log( 'check for sending == MESSAGE ID = ' . $message_id );
			
			if ( $message_id !== '0') {
				// log message id
				$this->log( 'cron_process_event() == MESSAGE ID = ' . $message_id );
				
				$results = $wpdb->get_results( "SELECT subscriber_id FROM " . $wpdb->prefix . "ebud_subscriptions WHERE subscribed_id='" . $event_id . "' AND sub_type='0' AND activated='1'" );
			
				foreach ( (array) $results as $id => $item ) {
					$i++;
					$wpdb->query( "INSERT INTO " . $wpdb->prefix . "ebud_queue ( subscriber_id, item_id, item_type, message_id ) VALUES( '" . $item->subscriber_id . "', '" . $event_id . "', '" . $type . "', '" . $message_id . "' )" );
				}
			
				$this->launch_queue_via_cron();
			}
			return $i;
		}
		
		
		/* SERIES DISABLED AND POSTPONED TO FUTURE VERSION
		// whenever a scheduled series check is triggered, run this
		// base series checking on settings resolution. once per hour? day? week?
		function process_series( $event_id ) {
			// TODO:
			// put into the queue
			// update user subscription to reflect next series step
			// wp instant cron a queue_process()
		}
		*/
		
		
		// Using a cut down version of WordPress' spawn_cron that doesn't have a limit holding us back.
		function spawn_private_cron( $local_time = 0 ) {
			//sanity check
			$crons = _get_cron_array();
			if ( !is_array($crons) )
				return;
				
				
			$this->log( 'Spawned4' );
			
			if ( defined('ALTERNATE_WP_CRON') && ALTERNATE_WP_CRON ) {
				
				if ( !empty($_POST) || defined('DOING_AJAX') )
					return;
					
				set_transient( 'doing_cron', $local_time );
				
				ob_start();
				wp_redirect( add_query_arg('doing_wp_cron', '', stripslashes($_SERVER['REQUEST_URI'])) );
				echo ' ';
				
				
				// flush any buffers and send the headers
				while ( @ob_end_flush() );
				flush();
				
				WP_DEBUG ? include_once( ABSPATH . 'wp-cron.php' ) : @include_once( ABSPATH . 'wp-cron.php' );
				return;
			}
			
			set_transient( 'doing_cron', $local_time );
			
			$cron_url = site_url() . '/wp-cron.php?doing_wp_cron';
			wp_remote_post( $cron_url, array('timeout' => 0.01, 'blocking' => false, 'sslverify' => apply_filters('https_local_ssl_verify', true)) );
		}
		
		// Prepares and sets up the queue to be processed by launching a one-time cron.
		function launch_queue_via_cron() {
			$this->log( 'Queue being set up to launch via cron. launch_queue_via_cron()' );
			
			wp_schedule_single_event( time() + ($this->_options['cycle_pause'] * 60), $this->_var.'-queue_process' );
			
			// If we want to trigger this in a minute or less we need to trick WordPress into thinking it didn't just run a cronjob...
			if ( ( $this->_options['cycle_pause'] * 60 ) <= 60 ) {
				set_transient('doing_cron', ( get_transient('doing_cron') - 75 ) ); // Make WordPress think the last cron ran 75 seconds ago so it won't cronblock us.
				// If no pause between cycles, carry on now! Instant gratification!
				if ( $this->_options['cycle_pause'] == 0 ) {
					//defined('DOING_CRON') || isset($_GET['doing_wp_cron']) )
					unset( $_GET['doing_wp_cron'] );
				
					// Spawn cron using our modified version since WordPress cronblocks anything happening too fast!
					$this->spawn_private_cron();
					$this->log( 'Spawned instant cron. No pause.' );
				}
			}
		}
		
		function queue_process() {
			if ( !isset( $this->_options ) ) {
				$this->load();
			}

			$this->log( 'Beginning queue process. queue_process()' );
			

			
			global $wpdb;
			$results = $wpdb->get_results( "SELECT " . $wpdb->prefix . "ebud_queue.item_type," . $wpdb->prefix . "ebud_queue.item_id," . $wpdb->prefix . "ebud_queue.id as queue_id," . $wpdb->prefix . "ebud_subscribers.email," . $wpdb->prefix . "ebud_subscribers.meta as meta, " . $wpdb->prefix . "ebud_messages.title as email_subject, " . $wpdb->prefix . "ebud_messages.body FROM " . $wpdb->prefix . "ebud_queue LEFT JOIN " . $wpdb->prefix . "ebud_messages ON ( " . $wpdb->prefix . "ebud_queue.message_id = " . $wpdb->prefix . "ebud_messages.id ) LEFT JOIN " . $wpdb->prefix . "ebud_subscribers ON ( " . $wpdb->prefix . "ebud_queue.subscriber_id = " . $wpdb->prefix . "ebud_subscribers.id ) LIMIT " . ($this->_options['emails_per_cycle']+1) );
			$i = 0;
			foreach ( (array) $results as $id => $item ) {
				$i++;
				
				// Process emails up to the cycle limit.  We grabbed 1 extra in the SQL query above so we could tell if we still have any unprocessed queue items.
				if ( $i <= $this->_options['emails_per_cycle'] ) {
					// call email_variable_swap on subject and body for each email
					$body = $this->email_variable_swap( stripslashes( $item->body ), $item->email, $item->email_subject, '', $item->meta );
					
					$body .= "\r\n\r\n";
					$body .= $this->_options['unsubscribe_text'];
					
					if ( $this->_options['unsubscribe_text'] == '' ) {
						$body .= 'UNSUBSCRIBE:';
					}
					
					$body .= "\r\n";
					
					$body .= get_option( 'home' ) . '/?unsubscribe=' . urlencode( $item->email ) . '&list=' . $item->item_id . '&type=' . $item->item_type;
					
					$success = $this->send_email( $item->email, $item->email_subject, $body );
					
					// Only remove this email from the queue if the sending attempt succeeded.
					if ( $success === true ) {
						$results = $wpdb->query( "DELETE FROM " . $wpdb->prefix . "ebud_queue WHERE id='" . $item->queue_id . "' LIMIT 1" );
					}
				} else {
					echo 'went over!';
					$this->launch_queue_via_cron();
					break;
				}
			}
			
			// If last indices is set then there are more to process...
			/*if ( isset( $results[ $this->_options['emails_per_cycle'] ] ) ) {
				$this->launch_queue_via_cron();
			}*/
			
			
			
			// if we reach number of messages and still more remain, use instant cron to spawn more sending
		}
		
		// Returns boolean indicating whether wp_mail reported it was able to try to send
		function send_email( $to, $subject, $message ) { //, $list='', $type='' ) {
			// Handled in queue! $message = stripslashes( $this->email_variable_swap( $message, $to, $subject ) );
			$subject = stripslashes( $subject );
			
			if ( $this->_options['email_footer'] != '' ) {
				$message .= "\r\n\r\n" . stripslashes( $this->_options['email_footer'] );
			}
			
			if ( $this->_options['eb_promo'] == '1' ) {
				$message .= "\r\n\r\nPowered by EmailBuddy by PluginBuddy.com";
			}
			
			$headers = 'From: ' . $this->_options['return_name'] . ' <' . $this->_options['return_address'] . '>' . "\r\n";
			//echo 'sending from ' . $this->_options['return_address'] . ' to ' . $to . ' with subject ' . $subject . ' and message ' . $message;
			
			if ( $this->_options['smtp'] != '' ) {
				ini_set( 'SMTP', $this->_options['smtp'] ); // MUST use all caps for SMTP here.
			}
			if ( $this->_options['smtp_port'] != '' ) {
				ini_set( 'smtp_port', $this->_options['smtp_port'] ); // DONT use all caps for smtp here.
			}
			
			//$this->log( $message );
			if ( wp_mail( $to, $subject, $message, $headers ) ) {
				$success = true;
				$this->log( 'Sent email "' . $subject . '". Recipient: ' . $to );
			} else {
				$this->log( 'Unable to send email "' . $subject . '". Check your php.ini SMTP settings since wp_mail returned false. Recipient: ' . $to, 'error' );
				$success = false;
			}
			
			return $success;
		}
		
		/**
		 *	log()
		 *
		 *	Logs to a text file depending on settings.
		 *	0 = none, 1 = errors only, 2 = errors + warnings, 3 = debugging (all kinds of actions)
		 *
		 *	$text	string			Text to log.
		 *	$log_type	string		Valid options: error, warning, all (default so may be omitted).
		 *
		 */
		function log( $text, $log_type = 'all' ) {
			$write = false;
			
			if ( !isset( $this->_options['log_level'] ) ) {
				$this->load();
			}
			
			if ( $this->_options['log_level'] == 0 ) { // No logging.
				return;
			} elseif ( $this->_options['log_level'] == 1 ) { // Errors only.
				if ( $log_type == 'error' ) {
					$write = true;
				}
			} elseif ( $this->_options['log_level'] == 2 ) { // Errors and warnings only.
				if ( ( $log_type == 'error' ) || ( $log_type == 'warning' ) ) {
					$write = true;
				}
			} elseif ( $this->_options['log_level'] == 3 ) { // Log all; Errors, warnings, actions, notes, etc.
				$write = true;
			}
			
			if ( $write === true ) {
				$fh = fopen( WP_CONTENT_DIR . '/uploads/' . $this->_var . '.txt', 'a');
				fwrite( $fh, '[' . date( $this->_timestamp . ' ' . get_option( 'gmt_offset' ), time() + (get_option( 'gmt_offset' )*3600) ) . '-' . $log_type . '] ' . $text . "\n" );
				fclose( $fh );
			}
		}
		
		
		/**
		 *	tip()
		 *
		 *	Displays a message to the user when they hover over the question mark. Gracefully falls back to normal tooltip.
		 *	HTML is supposed within tooltips.
		 *
		 *	$message		string		Actual message to show to user.
		 *	$title			string		Title of message to show to user. This is displayed at top of tip in bigger letters. Default is blank. (optional)
		 *	$echo_tip		boolean		Whether to echo the tip (default; true), or return the tip (false). (optional)
		 */
		function tip( $message, $title = '', $echo_tip = true ) {
			$tip = ' <a class="pluginbuddy_tip" title="' . $title . ' - ' . $message . '"><img src="' . $this->_pluginURL . '/images/pluginbuddy_tip.png" alt="(?)" /></a>';
			if ( $echo_tip === true ) {
				echo $tip;
			} else {
				return $tip;
			}
		}
		
		
		function genemails() {
			$fh = fopen( WP_CONTENT_DIR . '/uploads/emails.txt', 'a');
			$i = 0;
			while ($i < 4000 ) {
				$i++;
				fwrite( $fh, $i . '@localhost.com' . "\n" );
			}
			fclose( $fh );
		}
		
		// Returns variable swapped content text.
		// TODO: is $type needed?
		function email_variable_swap( $text, $to, $subject, $type = '', $meta = '' ) {
			$text = str_replace( '{email_address}', $to, $text ); // User's email address.
			$my_date_time = date( 'm/d/Y h:i a e ' . get_option( 'gmt_offset' ), time() + ( get_option( 'gmt_offset' ) * 3600 ) ); //seems to work just fine for current time
			$text = str_replace( '{datetime}', $my_date_time, $text ); // Current date & time.
			//$text = str_replace( '{datetime}', $to, $text ); // Current date & time.
			$text = str_replace( '{siteurl}', get_option( 'home' ), $text ); // User's email address.
			$text = str_replace( '{unsubscribe}', get_option( 'home' ) . '?unsubscribe=' . urlencode( $to ), $text ); // Unsubscribe link.
			$text = str_replace( '{blogname}', get_option( 'blogname' ), $text ); // Blog name.
			$text = str_replace( '{blogdescription}', get_option( 'blogdescription' ), $text ); // Blog description.
			// TODO: add.... $text = str_replace( '{event_title}', $to, $text ); // Title of event that sent email.
			// TODO: add.... $text = str_replace( '{group_title}', $to, $text ); // Title of group email was sent to.
			// TODO: add.... $text = str_replace( '{series_title}', $to, $text ); // Title of this series that sent email.
			$text = str_replace( '{subject}', $subject, $text ); // Email subject/title
			
			// Custom name... Eventually replace this with foreach if ever adding additional custom fields!
			if ( !empty( $meta ) ) {
				$meta = unserialize( $meta );
			}
			if ( !isset( $meta['name'] ) ) {
				$meta['name'] = $this->_options['custom_inputs']['name'][1];
			}
			$text = str_replace( '{custom_name}', stripslashes( $meta['name'] ), $text );
			
			return $text;
		}
		
		// Unsubscribe a user
		// Removes subscription email, subscriptions, and any queued emails to this user
		function unsubscribe( $email, $event_id = '', $type = '' ) {
			$this->log( 'Unsubscribing "' . $email . '" from list "' . $event_id . '" of type "' . $type . '"' );
			
			// Prevent bots from subscribing people by throttling by IP.
			// Unsubscribing throttles via different transient as subscribing so users can quickly unsubscribe if needed.
			if ( get_transient( 'eb_2_' . $_SERVER['REMOTE_ADDR'] ) ) {
				$this->error = 'Error #593-2. You are performing actions too quickly & have been throttled. Please wait & try again.';
				return false;
			} else {
				set_transient( 'eb_2_' . $_SERVER['REMOTE_ADDR'], 'true', $this->throttle );
			}
		
			global $wpdb;
			
			$email = $wpdb->escape( $email );
			
			if ( $subscriber_id = $wpdb->get_var( "SELECT id FROM " . $wpdb->prefix . "ebud_subscribers WHERE email='" . $email . "'" ) ) {
				$wpdb->query( "DELETE FROM " . $wpdb->prefix . "ebud_subscribers WHERE id='" . $subscriber_id . "' LIMIT 1" );
				$wpdb->query( "DELETE FROM " . $wpdb->prefix . "ebud_subscriptions WHERE subscriber_id='" . $subscriber_id . "' LIMIT 1" );
				$wpdb->query( "DELETE FROM " . $wpdb->prefix . "ebud_queue WHERE subscriber_id='" . $subscriber_id . "'" );
			} else {
				$this->error = 'Email not found to unsubscribe.';
				return false;
			}
			
			return true;
		}
		//Register the updater version
		function upgrader_register() {
			$GLOBALS['pb_classes_upgrade_registration_list'][$this->_var] = $this->_updater;
		} //end register_upgrader
		//Select the greatest version
		function upgrader_select() {
			if ( !isset( $GLOBALS[ 'pb_classes_upgrade_registration_list' ] ) ) {
				//Fallback - Just include this class
				require_once( $this->_pluginPath . '/lib/updater/updater.php' );
				return;
			}
			//Go through each global and find the highest updater version and the plugin slug
			$updater_version = 0;
			$plugin_var = '';
			foreach ( $GLOBALS[ 'pb_classes_upgrade_registration_list' ] as $var => $version) {
				if ( version_compare( $version, $updater_version, '>=' ) ) {
					$updater_version = $version;
					$plugin_var = $var;
				}
			}
			//If the slugs match, load this version
			if ( $this->_var == $plugin_var ) {
				require_once( $this->_pluginPath . '/lib/updater/updater.php' );
			}
		}
		 //end upgrader_select
		function upgrader_instantiate() {
			
			$pb_product = strtolower( $this->_var );
			$pb_product = str_replace( 'ithemes-', '', $pb_product );
			$pb_product = str_replace( 'pluginbuddy-', '', $pb_product );
			$pb_product = str_replace( 'pluginbuddy_', '', $pb_product );
			$pb_product = str_replace( 'pb_thumbsup', '', $pb_product );
			
			$args = array(
				'parent' => $this, 
				'remote_url' => 'http://updater2.ithemes.com/index.php',
				'version' => $this->_version,
				'plugin_slug' => $this->_var,
				'plugin_path' => plugin_basename( __FILE__ ),
				'plugin_url' => $this->_pluginURL,
				'product' => $pb_product,
				'time' => 43200,
				'return_format' => 'json',
				'method' => 'POST',
				'upgrade_action' => 'check' );
			$this->_pluginbuddy_upgrader = new iThemesPluginUpgrade( $args );

		} //end upgrader_instantiate
    } // End class

	$PluginBuddyEmailBuddy = new PluginBuddyEmailBuddy(); // Create instance
	//require_once( dirname( __FILE__ ) . '/classes/widget.php');
}



?>
