<?php
//namespace pluginbuddy\frolic;

pb_frolic::$ui->title( 'Frolic Settings' );

// Prepare data for plugin settings form.
	if ( current_user_can( 'activate_plugins' ) ) {
		$settings_form = new pb_frolic_settings('settings', '' );
		
		$settings_form->add_setting( array(
			'type'		=>		'select',
			'name'		=>		'access',
			'title'		=>		'Plugin access limits',
			'options'	=>		array( 'manage_network' => 'Network Administrator', 'activate_plugins' => 'Administrator', 'moderage_comments' => 'Editor', 'edit_published_posts' => 'Author', 'edit_posts' => 'Contributor' ),
			'tip'		=>		'[Default: administrator] - Determine which user roles are allowed to have access to all plugin features. WARNING: This will allow other roles access to configure plugin settings and content and could be a security risk if you are not careful and use caution.',
			'rules'		=>		'required',
		) );
		// Checkbox input:
		$settings_form->add_setting( array(
			'type'		=>		'checkbox',
			'name'		=>		'enable_twitter_dash',
			'options'	=>		array( 'unchecked' => 'false', 'checked' => 'true' ),
			'title'		=>		'Twitter in Dashboard',
			'tip'		=>		'When enabled, will display feed objects from active Twitter accounts in the dashboard.',
			'css'		=>		'',
			'after'		=>		'',
			'rules'		=>		'required',
		) );
		$settings_form->add_setting( array(
			'type'		=>		'checkbox',
			'name'		=>		'enable_facebook_dash',
			'options'	=>		array( 'unchecked' => 'false', 'checked' => 'true' ),
			'title'		=>		'Facebook in Dashboard',
			'tip'		=>		'When enabled, will display Activity Feed, and Comments objects from active Facebook accounts in the dashboard.',
			'css'		=>		'',
			'after'		=>		'',
			'rules'		=>		'required',
		) );
		
		$data['settings_form'] = $settings_form;

		$settings_form->process(); // Handles processing the submitted form (if applicable).
	}

// Load view.
pb_frolic::load_view( 'settings', $data );



?>
