<?php
if ( !class_exists( "iThemesMobileBuddy_admin" ) ) {
    class iThemesMobileBuddy_admin {
	
		function iThemesMobileBuddy_admin(&$parent) {
			$this->_parent = &$parent;
			$this->_parent->load();
			$this->_options = &$parent->_options;

			add_action('admin_menu', array(&$this, 'admin_menu')); // Add menu in admin.
			//add_action('admin_init', array(&$this, 'init_admin' )); // Run on admin initialization.
			// When user activates plugin in plugin menu.
			register_activation_hook(__FILE__, array(&$this, '_activate'));
			
			add_action('wp_ajax_ithemes-mobilebuddy-mediabrowser', array(&$this, 'ajax_media') );
			add_action('wp_ajax_ithemes-mobilebuddy-headerupload', array(&$this, 'ajax_headerupload') );
			
			
		}
		

		function ajax_media() {
			require_once( $this->_parent->_pluginPath . '/lib/mediabrowser/mediabrowser.php' );
		}
		
		function ajax_headerupload() {
			if ( is_array( $_FILES['file'] ) ) {
				require_once( $this->_parent->_pluginPath . '/lib/file-utility/file-utility.php' );
				$file = iThemesFileUtility::uploadFile( 'file' );
				if ( is_wp_error( $file ) ) {
					$this->_errors[] = 'Unable to save uploaded image. Ensure that the web server has permissions to write to the uploads folder';
				} else {
					$attachment_id = $file['id'];
				}
			} else {
				$this->_errors[] = 'You must select a file to upload.';
			}
			
			
			if ( ! empty( $this->_errors ) ) {
				echo 'ERROR: ' . $this->_errors;
			} else {
				echo $file['url'];
			}

			die();
		}
		
		// ADMIN MENU FUNCTIONS /////////////////

		
		/** admin_menu()
		 *
		 * Initialize menu for admin section.
		 *
		 */		
		function admin_menu() {
			// Add main menu (default when clicking top of menu)
			add_menu_page($this->_parent->_name.' Getting Started', 'Mobile', 'administrator', $this->_parent->_var, array(&$this, 'view_information'), $this->_parent->_pluginURL.'/images/mobile.png');
			// Add sub-menu items (first should match default page above)
			add_submenu_page( $this->_parent->_var, $this->_parent->_name.' Getting Started', 'Getting Started', 'administrator', $this->_parent->_var, array(&$this, 'view_information'));
			add_submenu_page( $this->_parent->_var, $this->_parent->_name.' Themes & Devices', 'Themes & Devices', 'administrator', $this->_parent->_var.'-themes', array(&$this, 'view_themes'));
			add_submenu_page( $this->_parent->_var, $this->_parent->_name.' Settings', 'Settings', 'administrator', $this->_parent->_var.'-settings', array(&$this, 'view_settings'));

		}


		
		// PAGES //////////////////////////////

		
		/**
		 * iThemesMobileBuddy::view_index()
		 *
		 * Displays default plugin page.
		 *
		 */	
		 /*
		function view_index() {
			$this->_parent->load();
			
			echo '<div class="wrap">';
			
			echo '<h2>'.$this->_parent->_name.'</h2>';
			echo 'This is the default page!';
			
			if ( isset($_SERVER['HTTP_USER_AGENT']) ) {
				echo 'agent: ' . $_SERVER['HTTP_USER_AGENT'];
			} else {
				echo 'no agent oh noes';
			}
			
			echo 'upload_dir:'. print_r(WP_UPLOAD_DIR());
			
			echo '</div>';
		}
		*/
		
		/**
		 * iThemesMobileBuddy::view_settings()
		 *
		 * Displays settings form and values for viewing & editing.
		 *
		 */		
		function view_settings() {
			$this->_parent->load();
		
			if (!empty($_POST['save'])) {
				$this->_saveSettings();
			}

			if ( ! function_exists( 'get_site_transient' ) ) {
				$this->_parent->alert( 'ERROR: WordPress 2.9.0 or newer is required for PluginBuddy Mobile.', true, '9001' );
			}
			
			// Load scripts and CSS used on this page.
			wp_enqueue_script( 'ithemes-tooltip-js', $this->_parent->_pluginURL . '/js/tooltip.js' );
			wp_print_scripts( 'ithemes-tooltip-js' );
			wp_enqueue_script( 'ithemes-ajaxupload-js', $this->_parent->_pluginURL . '/js/ajaxupload.js' );
			wp_print_scripts( 'ithemes-ajaxupload-js' );
			wp_enqueue_script( 'ithemes-'.$this->_parent->_var.'-admin-js', $this->_parent->_pluginURL . '/js/admin.js' );
			wp_print_scripts( 'ithemes-'.$this->_parent->_var.'-admin-js' );
			echo '<link rel="stylesheet" href="'.$this->_parent->_pluginURL . '/css/admin.css" type="text/css" media="all" />';
			
			echo '<div class="wrap">';
			?>
			
				<h2><?php echo $this->_parent->_name; ?> Settings</h2>
				<?php $this->_usedInputs=array(); ?>
				<form method="post" action="<?php echo $this->_parent->_selfLink; ?>-settings">
					<table class="form-table">
					
					
					
					
					
						<tr>
							<td><label>Enable mobile versions <a class="ithemes_tip" title=" - [Default: enabled] - When enabled, visitors using a mobile device will be shown the mobile theme you have defined on the Themes & Devices page. When disabled, users will be shown your normal site theme.">(?)</a></label></td>
							<td><?php $this->_addCheckBox('enabled', array( 'size' => '45', 'maxlength' => '45', 'value' => 1, 'id' => 'enabled' ) ); ?> <label for="enabled">Enable mobile versions</label></td>
						</tr>
					
						<tr>
							<td><label>Show a link to non-mobile site version <a class="ithemes_tip" title=" - [Default: enabled] - When enabled, a link will be displayed at the bottom of mobile user's pages to return to the non-mobile version of the site for the duration of their session.">(?)</a></label></td>
							<td><?php $this->_addCheckBox('regular_link', array( 'size' => '45', 'maxlength' => '45', 'value' => 1, 'id' => 'regular_link' ) ); ?> <label for="regular_link">Enable link to non-mobile site</label></td>
						</tr>
						
						<tr>
							<td><label>Show a link to mobile site for mobile users <a class="ithemes_tip" title=" - [Default: enabled] - When enabled, users of mobile devices will be shown a link to the mobile site at the bottom of the page via the wp_footer function.">(?)</a></label></td>
							<td><?php $this->_addCheckBox('mobile_link', array( 'size' => '45', 'maxlength' => '45', 'value' => 1, 'id' => 'mobile_link' ) ); ?> <label for="mobile_link">Enable link to mobile site for mobile users</label></td>
						</tr>
						
						<tr>
							<td><label>Upgrade themes on automatic upgrade <a class="ithemes_tip" title=" - [Default: enabled] - When enabled, themes will be automatically upgrade whenever you upgrade this plugin using automatic upgrades or re-activate it.  If you make customizations to a theme you can either disable this option or clone the theme and make it a new name.">(?)</a></label></td>
							<td><?php $this->_addCheckBox('upgrade_themes', array( 'size' => '45', 'maxlength' => '45', 'value' => 1, 'id' => 'upgrade_themes' ) ); ?> <label for="upgrade_themes">Enable theme upgrading on automatic upgrade</label></td>
						</tr>
					
						<tr>
							<td>Mobile theme directory <a class="ithemes_tip" title=" - This is the location of mobile themes on the server.  You may upload additional mobile themes for PluginBuddy mobile here.">(?)</a></td>
							<td>
								<?php
								$wp_upload_dir = WP_UPLOAD_DIR();
								echo $wp_upload_dir['basedir'] . '/pluginbuddy_mobile/';
								?>
							</td>
						</tr>
						<tr>
							<td>Mobile Theme URL <a class="ithemes_tip" title=" - This is the web-accessible URL corresponding to the mobile themes directory on the server.">(?)</a></td>
							<td>
								<?php
								$wp_upload_dir = WP_UPLOAD_DIR();
								echo $wp_upload_dir['baseurl'] . '/pluginbuddy_mobile/';
								?>
							</td>
						</tr>
						<tr>
							<td><label for="blogname">Blog Name <a class="ithemes_tip" title=" - This allows you to a set a different blog name than the one of the non-mobile site.">(?)</a></label></td>
							<td><?php 
								if ( isset( $this->_options['blogname'] ) ) {
									$blogname = $this->_options['blogname'];
								} else {
									$blogname = '';
								}
								$this->_addTextBox('blogname', array( 'size' => '45', 'maxlength' => '45', 'value' => $blogname ) );
							?></td>
						</tr>
						<tr>
							<td><label for="blogdescription">Blog Description <a class="ithemes_tip" title=" - This allows you to set a different blog description than the one of the non-mobile site.">(?)</a></label></td>
							<td><?php
							if ( isset( $this->_options['blogdescription'] ) ) {
								$blogdescription = $this->_options['blogdescription'];
							} else {
								$blogdescription = '';
							}
							if ( isset( $this->_options['headcontent'] ) ) {
								$headcontent = $this->_options['headcontent'];
							} else {
								$headcontent = '';
							}
							$this->_addTextBox('blogdescription', array( 'size' => '45', 'maxlength' => '200', 'value' => $blogdescription ) );
							?></td>
						</tr>
						<!--
						<tr>
							<td><label for="apple_icon">Apple Icon <a class="ithemes_tip" title=" - [57x57 pixel PNG image] - Apple iPhone, iPod, and iPad users have the ability to add a bookmark to your website to their homescreen.  This icon will be used for the bookmark.  If not set then a screenshot of your page is used by default.">(?)</a>:</label></td>
							<td>
								<a  class="button add-new-h2" id="ithemes-upload_button">Upload New Icon</a> (57x57 PNG Image)
							</td>
						</tr>
						-->
						<tr>
							<td valign="top"><label for="header_html">Additional HTML inside Header <a class="ithemes_tip" title=" - This allows you to insert custom HTML into the header of each page on the mobile site.  This is useful for including statistics trackers such as Google analytics or any other scripts or content you would like to be included within the HEAD of each mobile page.">(?)</a><br /><small>ie. Google analytics code</small></label></td>
							<td>
								<?php $this->_addTextArea('headcontent', array( 'rows' => '5', 'cols' => '45', 'maxlength' => '9000', 'value' => $headcontent ) ); ?>
							</td>
						</tr>
						<tr>
							<td>&nbsp;</td>
							<td>
								<?php $this->_addSubmit( 'save', 'Save Settings' ); ?>
								<?php $this->_addUsedInputs(); ?>
								<?php wp_nonce_field( $this->_parent->_var . '-nonce' ); ?>
							</td>
						</tr>
					</table>
				</form>
				
				
				
			
			<?php
			echo '</div>';
		}

		
		/**
		 * iThemesMobileBuddy::view_index()
		 *
		 * Displays default plugin page.
		 *
		 */		
		function view_themes() {
			$this->_parent->load();

			// Load scripts and CSS used on this page.
			wp_enqueue_script( 'ithemes-tooltip-js', $this->_parent->_pluginURL . '/js/tooltip.js' );
			wp_print_scripts( 'ithemes-tooltip-js' );
			wp_enqueue_script( 'ithemes-ajaxupload-js', $this->_parent->_pluginURL . '/js/ajaxupload.js' );
			wp_print_scripts( 'ithemes-ajaxupload-js' );
			wp_enqueue_script( 'ithemes-'.$this->_parent->_var.'-admin-js', $this->_parent->_pluginURL . '/js/admin.js' );
			wp_print_scripts( 'ithemes-'.$this->_parent->_var.'-admin-js' );
			echo '<link rel="stylesheet" href="'.$this->_parent->_pluginURL . '/css/admin.css" type="text/css" media="all" />';

			if ( ! function_exists( 'get_site_transient' ) ) {
				$this->_parent->alert( 'ERROR: WordPress 2.9.0 or newer is required for PluginBuddy Mobile.', true, '9001' );
			}
			
			echo '<div class="wrap">';
			
			echo '<h2>Mobile Themes <a href="' . admin_url( "admin.php?page={$this->_parent->_var}-themes" ) . '" style="font-size: 12px;">(Theme Home)</a></h2>';

			
			if ( isset( $_GET['action'] ) ) {
				$page = $_GET['action'];
			} else {
				$page = 'default';
			}
			
			
			if ( ( $page == 'default' ) || ( $page == 'set_default' ) ) {
			
				echo '<h3>Devices & Assigned Themes</h3>';
				echo 'Hover over each device for options to select a theme and manage styles & theme settings.<br />';
				?>

				<br />
				<table class="widefat">
					<thead>
						<tr class="thead">
							<th>Device</th>
							<th>Assigned Theme</th>
							<th>Test Link <a class="ithemes_tip" title=" - The test link, in the format ?mobile=devicename, allows you to preview the site in your desktop browser similarly to how it would be viewed on a mobile client.  Note that mobile client screen sizes differ from a desktop and have different browser feature sets.">(?)</a></th>
						</tr>
					</thead>
					<tfoot>
						<tr class="thead">
							<th>Device</th>
							<th>Assigned Theme</th>
							<th>Test Link <a class="ithemes_tip" title=" - The test link, in the format ?mobile=devicename, allows you to preview the site in your desktop browser similarly to how it would be viewed on a mobile client.  Note that mobile client screen sizes differ from a desktop and have different browser feature sets.">(?)</a></th>
						</tr>
					</tfoot>
					<tbody>
					<?php
					$wp_upload_dir = WP_UPLOAD_DIR();
					foreach ( (array) $this->_parent->_options['agents'] as $key => $this_agent) {
						echo '<tr><td><strong>' . $this_agent[1] . '</strong>';
						echo '	<div class="row-actions" style="margin:0; padding:0;">';
						echo '		<span class="edit"><a href="' . admin_url( "admin.php?page={$this->_parent->_var}-themes&action=select&device={$key}" ) . '">Select Theme for Device</a></span>';
						//echo ' | ';
						//echo '		<span class="edit"><a href="' . admin_url( "admin.php?page={$this->_parent->_var}-themes&action=select&device={$key}" ) . '">Unassign Mobile Theme</a></span>';
						echo '	</div>';
						//if ( $this_agent[2] == 'default' ) { $theme_title = '<i>None. Using your default.</i>'; }
						echo '</td><td>';
						if ( $this_agent[2] != '' ) {
							echo $this_agent[2];
							echo '	<div class="row-actions" style="margin:0; padding:0;">';
							echo '		<span class="edit"><a href="' . admin_url( "admin.php?page={$this->_parent->_var}-themes&action=styleman&theme={$this_agent[2]}" ) . '">Style Manager</a></span>';
							if ( file_exists( $wp_upload_dir['basedir'] . '/pluginbuddy_mobile/' . $this_agent[2] . '/settings_definitions.txt' ) ) {
								echo ' | <span class="edit"><a href="' . admin_url( "admin.php?page={$this->_parent->_var}-themes&action=custom_settings&theme={$this_agent[2]}" ) . '">Theme Settings</a></span>';
							}
							echo '	</div>';
						} else {
							echo '<i>None assigned. <a class="ithemes_tip" title=" - No theme is assigned for this device. Users of this device will be shown the normal theme for your site.">(?)</a></i>';
						}
						echo '<td><a href="' . get_option('siteurl') . '?mobile=' . $this_agent[0] . '" target="_blank">?mobile=' . $this_agent[0] . '</a></td>';
						echo '</td></tr>' . "\n";
					}
					?>
					</tbody>
				</table><br />
				Appending ?nomobile to your site URL will disable the mobile version for the extent of the user session.
				<?php
			} elseif ( $page == 'addtheme' ) {
				echo '<h3>Upload New Mobile Theme</h3>';
				echo '<br />';
				echo '<a class="button add-new-h2" id="ithemes-upload_button">Upload New Theme</a>';
			} elseif ( $page == 'select' ) {
				$device = &$this->_parent->_options['agents'][$_GET['device']];
				
				if ( isset( $_GET['unassign'] ) ) {
					$device[2] = '';
					$this->_parent->save();
				}

				if ( isset( $_GET['theme'] ) ) {
					$device[2] = $_GET['theme'];
					$this->_parent->save();
					$this->_showStatusMessage( 'The selected theme for this device has been updated.' );
				}

				echo '<h3>Current Theme for ' . $device[1] . '</h3>';
				
				$wp_upload_dir = WP_UPLOAD_DIR();


				$themes = $this->get_themes( $wp_upload_dir['basedir'] . '/pluginbuddy_mobile' );
				
				
				// If a theme is defined then try to show it here.
				if ( $device[2] == '' ) {
					echo 'No theme is currently defined for this device.  Users of this device will be shown the normal site theme.<br />';
				} else {
					foreach( $themes as $theme_name => $theme ) {
						if ( $theme['Template'] == $device[2] ) {
							$current_theme = $theme_name;
							break;
						}
					}
					
					
					if ( !isset( $current_theme ) ) {
						$this->_showErrorMessage( 'The set theme for this device was not found in the mobile themes folder.' );
					} else {
						$this->print_current_theme( $themes, $current_theme );
					}
				}
				
				
				// LIST ALL AVAILABLE THEMES FOR MOBILE
				echo '<br >';
				echo '<h3>Available Mobile Themes</h3>';
				echo 'Select a theme from the list below to make it the theme for this device.<br /> <!-- <a href="' . admin_url( "admin.php?page={$this->_parent->_var}-themes&action=addtheme&device={$_GET['device']}" ) . '">upload a new mobile theme.</a> -->';
				echo 'Additional mobile themes may be uploaded into ' . $wp_upload_dir['basedir'] . '/pluginbuddy_mobile/';


				$this->print_all_themes( $themes, admin_url( "admin.php?page={$this->_parent->_var}-themes&action=select&device={$_GET['device']}" ) );

			} elseif ( $page == 'custom_settings' ) {
				$this->_parent->load_themeoptions($_GET['theme']);
				
				$wp_upload_dir = WP_UPLOAD_DIR();
				$settings_definitions_file = $wp_upload_dir['basedir'] . '/pluginbuddy_mobile/' . $_GET['theme'] . '/settings_definitions.txt';
				if ( file_exists( $settings_definitions_file ) ) {
					if ( isset( $_POST['save_customsettings'] ) ) {
						//echo '<pre>';
						//print_r( $_POST );
						//echo '</pre>';
						foreach ($_POST as $line_key => $line) {
							$this->_parent->_themeoptions['custom_settings'][str_replace( 'ithemes-mobile-', '', strtolower($line_key) )] = $line;
						}
						
						
						$this->_parent->save();
						
						$this->_showStatusMessage( 'Your theme settings have been successfully updated.' );

					}
				
					$this->_usedInputs=array();
					?>
					<h3>Custom Mobile Theme Settings</h3>
					This mobile theme provides theme-specific settings.  These settings will apply to all devices using this theme.
					<form method="post" action="<?php echo $this->_parent->_selfLink; ?>-themes&action=custom_settings&save_customsettings=true&theme=<?php echo $_GET['theme']; ?>">
					<table class="form-table">
						<?php
							
							
							
							
							$settings_file = explode("\n", file_get_contents( $settings_definitions_file ) );
							foreach ( (array) $settings_file as $item ) {
								if ( strstr( $item, ',' ) ) {
									//echo $item.'wuzhere<br />';
									
									$item = explode( ",", $item );
									$item[0] = strtolower( $item[0] ); // Just in case item var isnt lower case.
									echo '<tr>';
									
									if ( empty( $this->_parent->_themeoptions['custom_settings'][$item[0]] ) ) {
										$custom_val = '';
									} else {
										$custom_val = $this->_parent->_themeoptions['custom_settings'][$item[0]];
									}
									
									if ( $item[0] == '-' ) {
										echo '<td colspan="2"><b>' . $item[1] . '</b></td>';
									} elseif ( $item[1] == 'text' ) {
										echo '<tr><td>' . $item[2];
										if ( isset( $item[3] ) ) {
											echo ' <a class="ithemes_tip" title=" - ' . $item[3] .'">(?)</a>';
										}
										echo '</td><td>';
										$this->_addTextBox( $item[0], array( 'size' => '45', 'maxlength' => '45', 'value' => stripslashes( $custom_val ) ) );
										echo '</td></tr>';
									} elseif ( $item[1] == 'textarea' ) {
										echo '<tr><td valign="top">' . $item[2];
										if ( isset( $item[3] ) ) {
											echo ' <a class="ithemes_tip" title=" - ' . $item[3] .'">(?)</a>';
										}
										echo '</td><td>';
										$this->_addTextArea( $item[0], array( 'rows' => '5', 'cols' => '45', 'maxlength' => '9000', 'value' => stripslashes( $custom_val ) ) );
										echo '</td></tr>';
									} elseif ( $item[1] == 'custom_page' ) {
										echo '<tr><td valign="top">' . $item[2];
										if ( isset( $item[3] ) ) {
											echo ' <a class="ithemes_tip" title=" - ' . $item[3] .'">(?)</a>';
										}
										echo '</td><td>';
										//$this->_addTextArea( $item[0], array( 'rows' => '5', 'cols' => '45', 'maxlength' => '9000', 'value' => $custom_val ) );
										
										$pages = get_pages();
										foreach ( (array) $pages as $page ) {
											$page_array[$page->ID] = $page->post_title;
										}
										$this->_addDropDown( $item[0], array( 'value' => $page_array ) );
										
										echo '</td></tr>';
									} else {
										echo '<td colspan="2">Unknown setting: ' . $item[2] . '</td>';
									}
									
									echo '</tr>';
								}
							}
							unset($settings_file);
							?>
							<tr>
								<td>&nbsp;</td>
								<td>
									<?php $this->_addSubmit( 'save_customsettings', 'Save Settings' ); ?>
									<?php $this->_addUsedInputs(); ?>
									<?php wp_nonce_field( $this->_parent->_var . '-nonce' ); ?>
								</td>
							</tr>
							<?php
							
							
							
					echo '</table><br /><br /><br />';
				} else {
					echo 'Sorry, this theme does not currently offer any custom theme settings.';
				}

			} elseif ( $page == 'styleman' ) {
				wp_enqueue_script( 'thickbox' );
				wp_print_scripts( 'thickbox' );
				wp_print_styles( 'thickbox' );
				
				wp_enqueue_script( 'ithemes-mediabrowser', $this->_parent->_pluginURL . '/lib/mediabrowser/mediabrowser.js' );
				wp_print_scripts( 'ithemes-mediabrowser' );
				
				
				

				$this->_parent->load_themeoptions($_GET['theme']);
				

				
				
				$this->_usedInputs=array();
				
				


?>
				
										<table class="form-table">

								<tr>
									<td colspan="2" style="padding-bottom: 0px; padding-top: 0px; margin-bottom: 0px; margin-top: 0px;">
										<h3 style="padding-bottom: 0px; padding-top: 0px; margin-bottom: 0px; margin-top: 0px;">Header Image <a class="ithemes_tip" title=" - [57x57 pixel PNG image] - Apple iPhone, iPod, and iPad users have the ability to add a bookmark to your website to their homescreen.  This icon will be used for the bookmark.  If not set then a screenshot of your page is used by default.">(?)</a></h3>
									</td>
								</tr>
								<tr>
									<td colspan="2">
										<?php
										$wp_upload_dir = WP_UPLOAD_DIR();
										
										if ( isset( $_GET['save_header'] ) ) {
											if ( isset( $_POST['header'] ) ) {
												$this->_parent->_themeoptions['header'] = htmlentities( $_POST['header'] );
												$this->_parent->save();
												$this->_showStatusMessage( 'Saved updated header image.' );
											}
										}
									
										if ( isset( $this->_parent->_themeoptions['header'] ) ) {
											echo '<img id="ithemes-mobilebuddy-headerimg" src="' . $wp_upload_dir['baseurl'] . '/' . $this->_parent->_themeoptions['header'] . '" />';
										} else {
											echo '<img id="ithemes-mobilebuddy-headerimg" src="' . $wp_upload_dir['baseurl'] . '/pluginbuddy_mobile/' . htmlentities( $_GET['theme'] ) . '/images/header.jpg" />';
										}
										?>
										<br /><br />
										<form method="post" action="<?php echo $this->_parent->_selfLink; ?>-themes&action=styleman&save_header=true&theme=<?php echo $_GET['theme']; ?>">
											&nbsp;Recommended size: 480 x 150 pixels. Remember to <i>save your header after uploading</i>.<br />
											<a class="button-secondary" id="ithemes-mobilebuddy-upload_header">Upload New Header</a>
											<?php //echo '<a href="'.admin_url('admin-ajax.php').'?action=ithemes-mobilebuddy-mediabrowser&TB_iframe=true" class="thickbox button-secondary" title="PluginBuddy Media Browser">Choose from Media Library</a>'; ?>
											<input type="hidden" name="header" id="ithemes-mobilebuddy-header" />
											<input type="hidden" name="baseuploadurl" id="ithemes-mobilebuddy-baseuploadurl" value="<?php echo $wp_upload_dir['baseurl']; ?>" />
											<input type="submit" name="submit" value="Save Header Changes" class="button button-primary" />
										</form>
										<p></p>
									</td>
								</tr>
							</table>
				
				<?php
				
				
				require_once( $this->_parent->_pluginPath . '/lib/styleman/styleman.php' );
				$wp_upload_dir = WP_UPLOAD_DIR();
				$style_definitions_file = $wp_upload_dir['basedir'] . '/pluginbuddy_mobile/' . $_GET['theme'] . '/style_definitions.txt';
				$style_file = $wp_upload_dir['basedir'] . '/pluginbuddy_mobile/' . $_GET['theme'] . '/style.css';
				$custom_style_file = $wp_upload_dir['basedir'] . '/pluginbuddy_mobile/' . htmlentities( $_GET['theme'] ) . '.css';
				// Definitions text file, default styling css file, custom styling css file for overriding, variable to set true or false to on whether to include custom styling
				$pbstyles->styleman( $style_definitions_file, $style_file, $custom_style_file, $this->_parent->_themeoptions['customstyles_enabled'] );
				
				
				
				?>
				
				<!-- <a href="<?php echo $this->_parent->_selfLink; ?>-themes&action=settings&theme=<?php echo htmlentities($_GET['theme']) ?>&developer=true">Display developer CSS array.</a> -->
				<?php
			} else {
				echo 'ERROR #53: Unknown theme action.';
			}


			echo '<p><br /><a href="http://pluginbuddy.com" style="text-decoration: none;"><img src="'.$this->_parent->_pluginURL.'/images/pluginbuddy.png" style="vertical-align: -3px;" /> PluginBuddy.com</a></p>';
			
			echo '</div>';
		}


		
		
		/**
		 * iThemesBackupBuddy::view_information()
		 *
		 * Displays information and getting started.
		 *
		 */		
		function view_information() {
			$this->_parent->load();
			
			if (!empty($_POST['reset_defaults'])) {
				$this->_parent->_options = $this->_parent->_defaults;
				$this->_parent->save();
				$this->_showStatusMessage( 'Plugin settings have been reset to defaults.' );
			}
			
			wp_enqueue_style('dashboard');
			wp_print_styles('dashboard');
			wp_enqueue_script('dashboard');
			wp_print_scripts('dashboard');
			
			echo '<link rel="stylesheet" href="'.$this->_parent->_pluginURL . '/css/admin.css" type="text/css" media="all" />';
			
			
			echo '<div class="postbox-container" style="width:70%;">';
			echo '<div class="wrap">';
			echo '<h2>Getting Started with Mobile</h2>';
			
			if ( ! function_exists( 'get_site_transient' ) ) {
				$this->_parent->alert( 'ERROR: WordPress 2.9.0 or newer is required for PluginBuddy Mobile.', true, '9001' );
			}
			?>
			
			<h3>Overview</h3>
			<ol>
				<li>Select 'Themes & Devices' to manage which device sees which theme and the settings.</li>
				<ol>
					<p>
						&middot; Hover over each device for options to change themes (Fig 1-A) or the settings (Fig 1-B).<br />
						&middot; Select 'Select Theme for Device' to change the theme for this device.<br />
						&middot; Select 'Edit Theme Settings & Styles' to modify this theme's settings.<br />
					</p>
				</ol>
				<li>Select 'Settings' to modify settings that effect all mobile users or to disable the mobile version.</li>
				<ol>
					<p>
						&middot; Append the test link <a class="ithemes_tip" title=" - The test link, in the format ?mobile=devicename, allows you to preview the site in your desktop browser similarly to how it would be viewed on a mobile client.  Note that mobile client screen sizes differ from a desktop and have different browser feature sets.">(?)</a> to your site URL to preview theme settings (Fig 1-C).<br />
					</p>
				</ol>
			</ol>
			
			<h4>Figure 1</h4>
			<img src="<?php echo $this->_parent->_pluginURL; ?>/images/help1.gif" />
			
			<h3>Additional Help</h3>
			&middot; <a href="http://pluginbuddy.com/tutorials/mobile/">Tutorials</a><br />
			&middot; <a href="http://ithemes.com/support/mobile/">Support Forums</a><br />
			
			<br /><br />
			
			<?php
			
			// BEGIN Dustin's useful debugging code.
			echo '<script type="text/javascript">';
			echo '	jQuery(document).ready(function() {';
			echo '		jQuery("#ithemes_debugtoggle").click(function() {';
			echo '			jQuery("#ithemes_debugtoggle_div").slideToggle();';
			echo '		});';
			echo '	});';
			echo '</script>';
			echo '<a id="ithemes_debugtoggle" style="cursor:pointer"><small>&middot; Show Debugging Information</small></a>';
			echo '<div id="ithemes_debugtoggle_div" style="display: none;">';
			echo '<h2>Debugging Information</h2>';
			echo '<textarea rows="7" cols="65">';
			echo 'Plugin Version = '.$this->_parent->_name.' '.$this->_parent->_version.' ('.$this->_parent->_var.')'."\n";
			echo 'WordPress Version = '.get_bloginfo("version")."\n";
			echo 'PHP Version = '.phpversion()."\n";
			global $wpdb;
			echo 'DB Version = '.$wpdb->db_version()."\n";
			echo "\n".serialize($this->_parent->_options);
			echo '</textarea><br /><br /><br />';
			// END debug
			?>
				<form method="post" action="<?php echo $this->_parent->_selfLink; ?>">
					<input type="hidden" name="reset_defaults" value="true" />
					<input type="submit" name="submit" value="Reset Settings & Defaults" id="reset_defaults" class="button secondary-button" onclick="if ( !confirm('WARNING: This will reset all settings associated with this plugin to their defaults. Are you sure you want to do this?') ) { return false; }" />
				</form>
				
			</div>
			<?php
			
			echo '<p><br /><a href="http://pluginbuddy.com" style="text-decoration: none;"><img src="'.$this->_parent->_pluginURL.'/images/pluginbuddy.png" style="vertical-align: -3px;" /> PluginBuddy.com</a></p>';
			
			
			echo '</div>';
			
			
			
			?>
			</div>
			<div class="postbox-container" style="width:20%; margin-top: 35px; margin-left: 15px;">
				<div class="metabox-holder">	
					<div class="meta-box-sortables">
						
						<div id="ithemes-things" class="postbox">
							<div class="handlediv" title="Click to toggle"><br /></div>
							<h3 class="hndle"><span>Things to do...</span></h3>
							<div class="inside">
								<ul class="ithemes-mobilebuddy-nodecor">
									<li>- <a href="http://twitter.com/home?status=<?php echo urlencode('Check out this awesome plugin! ' . $this->_parent->_url . ' @pluginbuddy'); ?>" title="Share on Twitter" onClick="window.open(jQuery(this).attr('href'),'ithemes_popup','toolbar=0,status=0,width=820,height=500,scrollbars=1'); return false;">Tweet about this plugin.</a></li>
									<li>- <a href="http://pluginbuddy.com/purchase/">Check out our other plugins.</a></li>
									<li>- <a href="http://ithemes.com/purchase/">Check out our other themes.</a></li>
									<li>- <a href="http://secure.hostgator.com/cgi-bin/affiliates/clickthru.cgi?id=ithemes">Get HostGator web hosting.</a></li>
								</ul>
							</div>
						</div>

						<div id="ithemes-news" class="postbox">
							<div class="handlediv" title="Click to toggle"><br /></div>
							<h3 class="hndle"><span>Latest news from PluginBuddy</span></h3>
							<div class="inside">
								<p style="font-weight: bold;">PluginBuddy.com</p>
								<?php $this->news();  ?>
								<p style="font-weight: bold;">Twitter @pluginbuddy</p>
								<?php $this->twitter();  ?>
							</div>
						</div>
						
						<div id="ithemes-support" class="postbox">
							<div class="handlediv" title="Click to toggle"><br /></div>
							<h3 class="hndle"><span>Need support?</span></h3>
							<div class="inside">
								<p>If you need any help with this plugin or run into any problems, please visit our <a href="http://ithemes.com/support/mobile/">support forum</a>.</p>
							</div>
						</div>
						
					</div>
				</div>
			</div>
			
			<?php
		}
		
		
		
		





		function news() {
			require_once(ABSPATH.WPINC.'/rss.php');  
			if ( $rss = fetch_rss( 'http://pluginbuddy.com/feed/' ) ) {
				echo '<ul class="ithemes-mobilebuddy-nodecor">';
				$rss->items = array_slice( $rss->items, 0, 4 );
				foreach ( (array) $rss->items as $item ) {
					echo '<li>- <a href="'.clean_url( $item['link'], $protocolls=null, 'display' ).'">'. htmlentities($item['title']) .'</a></li>';
				}
				echo '</ul>';
			} else {
				echo 'Temporarily unable to load news...';
			}
		}


		function twitter() {
			require_once(ABSPATH.WPINC.'/rss.php');  
			if ( $rss = fetch_rss( 'http://twitter.com/statuses/user_timeline/108700480.rss' ) ) {
				echo '<ul class="ithemes-mobilebuddy-nodecor">';
				$rss->items = array_slice( $rss->items, 0, 3 );
				foreach ( (array) $rss->items as $item ) {
					echo '<li>- <a href="'.clean_url( $item['link'], $protocolls=null, 'display' ).'">'. htmlentities( substr($item['title'],12) ) .'</a></li>';
				}
				echo '<li>&nbsp;</li>';
				echo '<li><img src="'.$this->_parent->_pluginURL.'/images/twitter.png" style="vertical-align: -3px;" /> <a href="http://twitter.com/pluginbuddy">Follow @pluginbuddy on Twitter.</a></li>';
				echo '<li><img src="'.$this->_parent->_pluginURL.'/images/feed.png" style="vertical-align: -3px;" /> <a href="http://pluginbuddy.com/feed/">Subscribe to RSS news feed.</a></li>';
				echo '<li><img src="'.$this->_parent->_pluginURL.'/images/email.png" style="vertical-align: -3px;" /> <a href="http://pluginbuddy.com/subscribe/">Subscribe to Email Newsletter.</a></li>';
				echo '</ul>';
			} else {
				echo 'Temporarily unable to load twitter status...';
			}
		}





		function print_current_theme( $themes, $current_theme, $can_unassign = true ) {
			echo '<div id="current-theme" class="has-screenshot" style="margin-bottom: 0px;">';
			if ( $themes[$current_theme]['Screenshot'] ) {
				echo '<img src="' . $themes[$current_theme]['Theme Root URI'] . '/' . $themes[$current_theme]['Stylesheet'] . '/' . $themes[$current_theme]['Screenshot'] . '" alt="' . __('Current theme preview') . '" />';
			}
			echo '<h4>' . sprintf(__('%1$s %2$s by %3$s'), $themes[$current_theme]['Title'], $themes[$current_theme]['Version'], $themes[$current_theme]['Author']) . '</h4>';
			echo '<p><span class="description" style="font-weight: normal;"> &middot; ' . $themes[$current_theme]['Description'] . '</span></p>';
			//echo '<span class="theme-description" style="font-weight: normal;"> &middot; ' . $themes[$current_theme]['Description'] . '</span>';
			//echo '</h4>';
			//echo '<a href="' . admin_url( "admin.php?page={$this->_parent->_var}-themes&action=settings&theme=" . $themes[$current_theme]['Template'] ) . '" class="activatelink" title="Manage this theme\'s settings">Theme Settings</a>';
			if ($themes[$current_theme]['Parent Theme']) {
				echo '<p>' . sprintf(__('The template files are located in <code>%2$s</code>.  The stylesheet files are located in <code>%3$s</code>.  <strong>%4$s</strong> uses templates from <strong>%5$s</strong>.  Changes made to the templates will affect both themes.'), $themes[$current_theme]['Title'], str_replace( WP_CONTENT_DIR, '', $themes[$current_theme]['Template Dir'] ), str_replace( WP_CONTENT_DIR, '', $themes[$current_theme]['Stylesheet Dir'] ), $themes[$current_theme]['Title'], $themes[$current_theme]['Parent Theme']) . '</p>';
			} else {
				echo '<p>' . sprintf(__('All of this theme&#8217;s files are located in <code>%2$s</code>.'), $themes[$current_theme]['Title'], str_replace( WP_CONTENT_DIR, '', $themes[$current_theme]['Template Dir'] ), str_replace( WP_CONTENT_DIR, '', $themes[$current_theme]['Stylesheet Dir'] ) ) . '</p>';
			}
			if ( $themes[$current_theme]['Tags'] ) {
				echo '<p>' . __('Tags:') . ' ' . join(', ', $themes[$current_theme]['Tags']) . '</p>';
			}
			// style="border-bottom: 1px solid;"
			
			//echo '</div>'; moved further down so that buttons wouldn't be out of place.
			echo '<a href="' . admin_url( "admin.php?page={$this->_parent->_var}-themes&action=styleman&theme=" . $themes[$current_theme]['Template'] ) . '" class="button-primary">Style Manager</a>';
			echo ' ';
			
			$wp_upload_dir = WP_UPLOAD_DIR();
			$settings_definitions_file = $wp_upload_dir['basedir'] . '/pluginbuddy_mobile/' . $themes[$current_theme]['Template'] . '/settings_definitions.txt';
			if ( file_exists( $settings_definitions_file ) ) {
				echo '<a href="' . admin_url( "admin.php?page={$this->_parent->_var}-themes&action=custom_settings&theme=" . $themes[$current_theme]['Template'] ) . '" class="button-primary">Settings</a>';
				echo ' ';
			}
			
			
			echo '<a href="' . admin_url( "admin.php?page={$this->_parent->_var}-themes&action=select&device=" . htmlentities( $_GET['device'] ) . '&unassign=true') . '" class="button-secondary">Unassign Theme</a>';
			echo '</div>';
			/*
			if ( $can_unassign ) {
				echo ' <a href="' . admin_url( "admin.php?page={$this->_parent->_var}-themes&action=unassign&theme=" . $themes[$current_theme]['Template'] ) . '" class="button-secondary">Unassign from Device</a>';
			}
			*/
			echo '<div class="clear"></div>';
		}


	
	
		function print_all_themes( $themes, $activate_link ) {
		
			echo '<table id="availablethemes" cellspacing="0" cellpadding="0">';
		
			$style = '';

			$theme_names = array_keys($themes);
			natcasesort($theme_names);

			$table = array();
			$rows = ceil(count($theme_names) / 3);
			for ( $row = 1; $row <= $rows; $row++ ) {
				for ( $col = 1; $col <= 3; $col++ ) {
					$table[$row][$col] = array_shift($theme_names);
				}
			}
					
			foreach ( $table as $row => $cols ) {
				echo '<tr>';

				foreach ( $cols as $col => $theme_name ) {
					$class = array('available-theme');
					if ( $row == 1 ) $class[] = 'top';
					if ( $col == 1 ) $class[] = 'left';
					if ( $row == $rows ) $class[] = 'bottom';
					if ( $col == 3 ) $class[] = 'right';

					echo '<td class="' . join(' ', $class) . '">';
					if ( !empty($theme_name) ) {
						$template = $themes[$theme_name]['Template'];
						$stylesheet = $themes[$theme_name]['Stylesheet'];
						$title = $themes[$theme_name]['Title'];
						$version = $themes[$theme_name]['Version'];
						$description = $themes[$theme_name]['Description'];
						$author = $themes[$theme_name]['Author'];
						$screenshot = $themes[$theme_name]['Screenshot'];
						$stylesheet_dir = $themes[$theme_name]['Stylesheet Dir'];
						$template_dir = $themes[$theme_name]['Template Dir'];
						$parent_theme = $themes[$theme_name]['Parent Theme'];
						$theme_root_uri = $themes[$theme_name]['Theme Root URI'];
						$theme_root = $themes[$theme_name]['Theme Root'];
						$tags = $themes[$theme_name]['Tags'];
						/*
						echo '<pre>';
						print_r($themes[$theme_name]);
						echo '</pre>';
						*/
						//$activate_link = "admin.php?page=mobilepress-themes&amp;action=set_default&amp;action=activate&amp;template=".urlencode($template)."&amp;theme=".urlencode($title);
						$actions = array();
						$actions[] = '<a href="' . $activate_link .  '&theme=' . $template .'" class="activatelink" title="Select this theme"><b>Select Theme</b></a>';
						$actions[] = '<a href="' . admin_url( "admin.php?page={$this->_parent->_var}-themes&action=styleman&theme=" . $template ) . '" class="activatelink" title="Manage this theme\'s settings">Style Manager</a>';

						$wp_upload_dir = WP_UPLOAD_DIR();
						$settings_definitions_file = $wp_upload_dir['basedir'] . '/pluginbuddy_mobile/' . $template . '/settings_definitions.txt';
						if ( file_exists( $settings_definitions_file ) ) {
							$actions[] = '<a href="' . admin_url( "admin.php?page={$this->_parent->_var}-themes&action=custom_settings&theme=" . $template ) . '" class="activatelink" title="Manage this theme\'s settings">Settings</a>';
						}
						
						$actions = apply_filters('theme_action_links', $actions, $themes[$theme_name]);
						$actions = implode ( ' | ', $actions );
						
						echo '<a href="' . $activate_link . '" class="theme screenshot">';
						if ( $screenshot ) {
							echo '<img src="' . $theme_root_uri . '/' . $stylesheet . '/' . $screenshot . '" alt="" />';
						}
						echo '</a>';
						
						echo '<h3>';
						printf(__('%1$s %2$s by %3$s'), $title, $version, $author);
						echo '</h3>';
						
						echo '<p class="description">' . $description . '</p>';
						echo '<span class="action-links">' . $actions . '</span>';
						if ($parent_theme) {
							echo '<p>' . sprintf(__('The template files are located in <code>%2$s</code>.  The stylesheet files are located in <code>%3$s</code>.  <strong>%4$s</strong> uses templates from <strong>%5$s</strong>.  Changes made to the templates will affect both themes.'), $title, str_replace( WP_CONTENT_DIR, '', $template_dir ), str_replace( WP_CONTENT_DIR, '', $stylesheet_dir ), $title, $parent_theme) . '</p>';
						} else {
							echo '<p>' . sprintf(__('All of this theme&#8217;s files are located in <code>%2$s</code>.'), $title, str_replace( WP_CONTENT_DIR, '', $template_dir ), str_replace( WP_CONTENT_DIR, '', $stylesheet_dir ) ) . '</p>';
						}
						if ( $tags ) {
							echo '<p>' . __('Tags:') . ' ' . join(', ', $tags) . '</p>';
						}
					}
					echo '</td>';
				}
				echo '</tr>';
			}
			echo '</table>';
			echo '<br class="clear" />';
		}









function is_wp_version( $is_ver ) {
    $wp_ver = explode( '.', get_bloginfo( 'version' ) );
    $is_ver = explode( '.', $is_ver );
    for( $i=0; $i<=count( $is_ver ); $i++ )
        if( !isset( $wp_ver[$i] ) ) array_push( $wp_ver, 0 );
 
    foreach( $is_ver as $i => $is_val )
        if( $wp_ver[$i] < $is_val ) return false;
    return true;
}





function get_themes( $directory ) {
	$wp_upload_dir = WP_UPLOAD_DIR();


	global $wp_themes, $wp_broken_themes;

	$theme_loc = $theme_root = $directory;
	
	
	
	/* Files in the root of the current theme directory and one subdir down */
	$themes_dir = @ opendir($theme_root);

	if ( !$themes_dir )
		return false;

	while ( ($theme_dir = readdir($themes_dir)) !== false ) {
		if ( is_dir($theme_root . '/' . $theme_dir) && is_readable($theme_root . '/' . $theme_dir) ) {
			if ( $theme_dir{0} == '.' || $theme_dir == 'CVS' )
				continue;

			$stylish_dir = @opendir($theme_root . '/' . $theme_dir);
			$found_stylesheet = false;

			while ( ($theme_file = readdir($stylish_dir)) !== false ) {
				if ( $theme_file == 'style.css' ) {
					$theme_files[$theme_dir] = array( 'theme_file' => $theme_dir . '/' . $theme_file, 'theme_root' => $theme_root );
					$found_stylesheet = true;
					break;
				}
			}
			@closedir($stylish_dir);

			if ( !$found_stylesheet ) { // look for themes in that dir
				$subdir = "$theme_root/$theme_dir";
				$subdir_name = $theme_dir;
				$theme_subdirs = @opendir( $subdir );

				$found_subdir_themes = false;
				while ( ($theme_subdir = readdir($theme_subdirs)) !== false ) {
					if ( is_dir( $subdir . '/' . $theme_subdir) && is_readable($subdir . '/' . $theme_subdir) ) {
						if ( $theme_subdir{0} == '.' || $theme_subdir == 'CVS' )
							continue;

						$stylish_dir = @opendir($subdir . '/' . $theme_subdir);
						$found_stylesheet = false;

						while ( ($theme_file = readdir($stylish_dir)) !== false ) {
							if ( $theme_file == 'style.css' ) {
								$theme_files["$theme_dir/$theme_subdir"] = array( 'theme_file' => $subdir_name . '/' . $theme_subdir . '/' . $theme_file, 'theme_root' => $theme_root );
								$found_stylesheet = true;
								$found_subdir_themes = true;
								break;
							}
						}
						@closedir($stylish_dir);
					}
				}
				@closedir($theme_subdir);
				if ( !$found_subdir_themes )
					$wp_broken_themes[$theme_dir] = array('Name' => $theme_dir, 'Title' => $theme_dir, 'Description' => __('Stylesheet is missing.'));
			}
		}
	}
	if ( is_dir( $theme_dir ) )
		@closedir( $theme_dir );
	

	
	
	
	
	
	
	/*

	if ( !$theme_files = search_theme_directories() )
		return false;

	*/
		
	asort( $theme_files );

	$wp_themes = array();

	foreach ( (array) $theme_files as $theme_file ) {
		$theme_root = $theme_file['theme_root'];
		$theme_file = $theme_file['theme_file'];

		if ( !is_readable("$theme_root/$theme_file") ) {
			$wp_broken_themes[$theme_file] = array('Name' => $theme_file, 'Title' => $theme_file, 'Description' => __('File not readable.'));
			continue;
		}
		$new_theme_file = rtrim($theme_file, '/style.css');
		//$theme_data = wp_get_theme($new_theme_file, $theme_root);

		//$theme_data = get_theme_data("$theme_root/$theme_file");
		
		if ( $this->is_wp_version( '3.4' ) )
			$theme_data = wp_get_theme($new_theme_file, $theme_root);
		else
			$theme_data = get_theme_data("$theme_root/$theme_file");

		$name        = $theme_data['Name'];
		$title       = $theme_data['Title'];
		$description = wptexturize($theme_data['Description']);
		$version     = $theme_data['Version'];
		$author      = $theme_data['Author'];
		$template    = $theme_data['Template'];
		$stylesheet  = dirname($theme_file);
		

		$screenshot = false;
		foreach ( array('png', 'gif', 'jpg', 'jpeg') as $ext ) {
			if (file_exists("$theme_root/$stylesheet/screenshot.$ext")) {
				$screenshot = "screenshot.$ext";
				break;
			}
		}

		if ( empty($name) ) {
			$name = dirname($theme_file);
			$title = $name;
		}

		if ( empty($template) ) {
			if ( file_exists("$theme_root/$stylesheet/index.php") )
				$template = $stylesheet;
			else
				continue;
		}

		$template = trim( $template );

		if ( !file_exists("$theme_root/$template/index.php") ) {
			$parent_dir = dirname(dirname($theme_file));
			if ( file_exists("$theme_root/$parent_dir/$template/index.php") ) {
				$template = "$parent_dir/$template";
				$template_directory = "$theme_root/$template";
			} else {
				/**
				 * The parent theme doesn't exist in the current theme's folder or sub folder
				 * so lets use the theme root for the parent template.
				 */
				if ( isset($theme_files[$template]) && file_exists( $theme_files[$template]['theme_root'] . "/$template/index.php" ) ) {
					$template_directory = $theme_files[$template]['theme_root'] . "/$template";
				} else {
					$wp_broken_themes[$name] = array('Name' => $name, 'Title' => $title, 'Description' => __('Template is missing.'));
					continue;
				}

			}
		} else {
			$template_directory = trim( $theme_root . '/' . $template );
		}

		$stylesheet_files = array();
		$template_files = array();

		$stylesheet_dir = @ dir("$theme_root/$stylesheet");
		if ( $stylesheet_dir ) {
			while ( ($file = $stylesheet_dir->read()) !== false ) {
				if ( !preg_match('|^\.+$|', $file) ) {
					if ( preg_match('|\.css$|', $file) )
						$stylesheet_files[] = "$theme_root/$stylesheet/$file";
					elseif ( preg_match('|\.php$|', $file) )
						$template_files[] = "$theme_root/$stylesheet/$file";
				}
			}
			@ $stylesheet_dir->close();
		}

		$template_dir = @ dir("$template_directory");
		if ( $template_dir ) {
			while ( ($file = $template_dir->read()) !== false ) {
				if ( preg_match('|^\.+$|', $file) )
					continue;
				if ( preg_match('|\.php$|', $file) ) {
					$template_files[] = "$template_directory/$file";
				} elseif ( is_dir("$template_directory/$file") ) {
					$template_subdir = @ dir("$template_directory/$file");
					if ( !$template_subdir )
						continue;
					while ( ($subfile = $template_subdir->read()) !== false ) {
						if ( preg_match('|^\.+$|', $subfile) )
							continue;
						if ( preg_match('|\.php$|', $subfile) )
							$template_files[] = "$template_directory/$file/$subfile";
					}
					@ $template_subdir->close();
				}
			}
			@ $template_dir->close();
		}

		//Make unique and remove duplicates when stylesheet and template are the same i.e. most themes
		$template_files = array_unique($template_files);
		$stylesheet_files = array_unique($stylesheet_files);
			
		$template_dir = dirname($template_files[0]);
		$stylesheet_dir = dirname($stylesheet_files[0]);

		if ( empty($template_dir) )
			$template_dir = '/';
		if ( empty($stylesheet_dir) )
			$stylesheet_dir = '/';

		// Check for theme name collision.  This occurs if a theme is copied to
		// a new theme directory and the theme header is not updated.  Whichever
		// theme is first keeps the name.  Subsequent themes get a suffix applied.
		// The Default and Classic themes always trump their pretenders.
		if ( isset($wp_themes[$name]) ) {
			if ( ('WordPress Default' == $name || 'WordPress Classic' == $name) &&
					 ('default' == $stylesheet || 'classic' == $stylesheet) ) {
				// If another theme has claimed to be one of our default themes, move
				// them aside.
				$suffix = $wp_themes[$name]['Stylesheet'];
				$new_name = "$name/$suffix";
				$wp_themes[$new_name] = $wp_themes[$name];
				$wp_themes[$new_name]['Name'] = $new_name;
			} else {
				$name = "$name/$stylesheet";
			}
		}

		$theme_roots[$stylesheet] = str_replace( WP_CONTENT_DIR, '', $theme_root );
		$wp_themes[$name] = array( 'Name' => $name, 'Title' => $title, 'Description' => $description, 'Author' => $author, 'Version' => $version, 'Template' => $template, 'Stylesheet' => $stylesheet, 'Template Files' => $template_files, 'Stylesheet Files' => $stylesheet_files, 'Template Dir' => $template_dir, 'Stylesheet Dir' => $stylesheet_dir, 'Status' => $theme_data['Status'], 'Screenshot' => $screenshot, 'Tags' => $theme_data['Tags'], 'Theme Root' => $theme_root, 'Theme Root URI' => str_replace( WP_CONTENT_DIR, content_url(), $theme_root ) );
	}

	unset($theme_files);

	/* Store theme roots in the DB */
	/*
	if ( get_site_transient( 'theme_roots' ) != $theme_roots )
	echo 'SETTING TRANSIENT ROOT';
		set_site_transient( 'theme_roots', $theme_roots, 7200 ); // cache for two hours
	unset($theme_roots);
	*/

	/* Resolve theme dependencies. */
	$theme_names = array_keys( $wp_themes );
	foreach ( (array) $theme_names as $theme_name ) {
		$wp_themes[$theme_name]['Parent Theme'] = '';
		if ( $wp_themes[$theme_name]['Stylesheet'] != $wp_themes[$theme_name]['Template'] ) {
			foreach ( (array) $theme_names as $parent_theme_name ) {
				if ( ($wp_themes[$parent_theme_name]['Stylesheet'] == $wp_themes[$parent_theme_name]['Template']) && ($wp_themes[$parent_theme_name]['Template'] == $wp_themes[$theme_name]['Template']) ) {
					$wp_themes[$theme_name]['Parent Theme'] = $wp_themes[$parent_theme_name]['Name'];
					break;
				}
			}
		}
	}

	return $wp_themes;
}










		
		
		
		
		
		
		
		
		
		
		
		
		/////////////////////////////////////////////
		// CHRIS' FORM CREATION FUNCTIONS: //////////
		/////////////////////////////////////////////


		function _saveSettings() {
			check_admin_referer( $this->_parent->_var . '-nonce' );
			
			foreach ( (array) explode( ',', $_POST['used-inputs'] ) as $name ) {
				$is_array = ( preg_match( '/\[\]$/', $name ) ) ? true : false;
				
				$name = str_replace( '[]', '', $name );
				$var_name = preg_replace( '/^' . $this->_parent->_var . '-/', '', $name );
				
				if ( $is_array && empty( $_POST[$name] ) )
					$_POST[$name] = array();
				
				if ( isset( $_POST[$name] ) && ! is_array( $_POST[$name] ) )
					$this->_options[$var_name] = stripslashes( $_POST[$name] );
				else if ( isset( $_POST[$name] ) )
					$this->_options[$var_name] = $_POST[$name];
				else
					$this->_options[$var_name] = '';
			}
			
			$errorCount = 0;
			
			// ERROR CHECKING OF INPUT
			if ( $errorCount < 1 ) {
				if ( $this->_parent->save() )
					$this->_showStatusMessage( __( 'Settings updated', $this->_parent->_var ) );
				else
					$this->_showErrorMessage( __( 'Error while updating settings', $this->_parent->_var ) );
			}
			else {
				$this->_showErrorMessage( __ngettext( 'Please fix the input marked in red below.', 'Please fix the inputs marked in red below.', $errorCount ) );
			}
		}
		
		function _newForm() {
			$this->_usedInputs = array();
		}
		
		function _addSubmit( $var, $options = array(), $override_value = true ) {
			if ( ! is_array( $options ) )
				$options = array( 'value' => $options );
			
			$options['type'] = 'submit';
			$options['name'] = $var;
			$options['class'] = ( empty( $options['class'] ) ) ? 'button-primary' : $options['class'];
			$this->_addSimpleInput( $var, $options, $override_value );
		}
		
		function _addButton( $var, $options = array(), $override_value = true ) {
			if ( ! is_array( $options ) )
				$options = array( 'value' => $options );
			
			$options['type'] = 'button';
			$options['name'] = $var;
			$this->_addSimpleInput( $var, $options, $override_value );
		}
		
		function _addTextBox( $var, $options = array(), $override_value = false ) {
			if ( ! is_array( $options ) )
				$options = array( 'value' => $options );
			
			$options['type'] = 'text';
			$this->_addSimpleInput( $var, $options, $override_value );
		}
		function _addPassBox( $var, $options = array(), $override_value = false ) {
			if ( ! is_array( $options ) )
				$options = array( 'value' => $options );
			
			$options['type'] = 'password';
			$this->_addSimpleInput( $var, $options, $override_value );
		}
		
		function _addTextArea( $var, $options = array(), $override_value = false ) {
			if ( ! is_array( $options ) )
				$options = array( 'value' => $options );
			
			$options['type'] = 'textarea';
			$this->_addSimpleInput( $var, $options, $override_value );
		}
		
		function _addFileUpload( $var, $options = array(), $override_value = false ) {
			if ( ! is_array( $options ) )
				$options = array( 'value' => $options );
			
			$options['type'] = 'file';
			$options['name'] = $var;
			$this->_addSimpleInput( $var, $options, $override_value );
		}
		
		function _addCheckBox( $var, $options = array(), $override_value = false ) {
			if ( ! is_array( $options ) )
				$options = array( 'value' => $options );
			
			$options['type'] = 'checkbox';
			$this->_addSimpleInput( $var, $options, $override_value );
		}
		
		function _addMultiCheckBox( $var, $options = array(), $override_value = false ) {
			if ( ! is_array( $options ) )
				$options = array( 'value' => $options );
			
			$options['type'] = 'checkbox';
			$var = $var . '[]';
			$this->_addSimpleInput( $var, $options, $override_value );
		}
		
		function _addRadio( $var, $options = array(), $override_value = false ) {
			if ( ! is_array( $options ) )
				$options = array( 'value' => $options );
			
			$options['type'] = 'radio';
			$this->_addSimpleInput( $var, $options, $override_value );
		}
		
		function _addDropDown( $var, $options = array(), $override_value = false ) {
			if ( ! is_array( $options ) )
				$options = array();
			else if ( ! isset( $options['value'] ) || ! is_array( $options['value'] ) )
				$options = array( 'value' => $options );
			
			$options['type'] = 'dropdown';
			$this->_addSimpleInput( $var, $options, $override_value );
		}
		
		function _addHidden( $var, $options = array(), $override_value = false ) {
			if ( ! is_array( $options ) )
				$options = array( 'value' => $options );
			
			$options['type'] = 'hidden';
			$this->_addSimpleInput( $var, $options, $override_value );
		}
		
		function _addHiddenNoSave( $var, $options = array(), $override_value = true ) {
			if ( ! is_array( $options ) )
				$options = array( 'value' => $options );
			
			$options['name'] = $var;
			$this->_addHidden( $var, $options, $override_value );
		}
		
		function _addDefaultHidden( $var ) {
			$options = array();
			$options['value'] = $this->defaults[$var];
			
			$var = "default_option_$var";
			$this->_addHiddenNoSave( $var, $options );
		}
		
		function _addUsedInputs() {
			$options['type'] = 'hidden';
			$options['value'] = implode( ',', $this->_usedInputs );
			$options['name'] = 'used-inputs';
			$this->_addSimpleInput( 'used-inputs', $options, true );
		}
		
		function _addSimpleInput( $var, $options = false, $override_value = false ) {
			if ( empty( $options['type'] ) ) {
				echo "<!-- _addSimpleInput called without a type option set. -->\n";
				return false;
			}

			$scrublist['textarea']['value'] = true;
			$scrublist['file']['value'] = true;
			$scrublist['dropdown']['value'] = true;
			$defaults = array();
			$defaults['name'] = $this->_parent->_var . '-' . $var;
			$var = str_replace( '[]', '', $var );
			
			if ( 'checkbox' === $options['type'] )
				$defaults['class'] = $var;
			else
				$defaults['id'] = $var;
			
			$options = $this->_merge_defaults( $options, $defaults );
			
			if ( ( false === $override_value ) && isset( $this->_options[$var] ) ) {
				if ( 'checkbox' === $options['type'] ) {
					if ( $this->_options[$var] == $options['value'] )
						$options['checked'] = 'checked';
				}
				elseif ( 'dropdown' !== $options['type'] )
					$options['value'] = $this->_options[$var];
			}
			
			if ( ( preg_match( '/^' . $this->_parent->_var . '/', $options['name'] ) ) && ( ! in_array( $options['name'], $this->_usedInputs ) ) )
				$this->_usedInputs[] = $options['name'];
			
			$attributes = '';
			
			if ( false !== $options )
				foreach ( (array) $options as $name => $val )
					if ( ! is_array( $val ) && ( ! isset( $scrublist[$options['type']][$name] ) || ( true !== $scrublist[$options['type']][$name] ) ) )
						if ( ( 'submit' === $options['type'] ) || ( 'button' === $options['type'] ) )
							$attributes .= "$name=\"$val\" ";
						else
							$attributes .= "$name=\"" . htmlspecialchars( $val ) . '" ';
			
			if ( 'textarea' === $options['type'] )
				echo '<textarea ' . $attributes . '>' . $options['value'] . '</textarea>';
			elseif ( 'dropdown' === $options['type'] ) {
				echo "<select $attributes>\n";
				foreach ( (array) $options['value'] as $val => $name ) {
					$selected = ( $this->_parent->_themeoptions['custom_settings']['mobile_blogpage'] == $val ) ? ' selected="selected"' : '';
					echo "<option value=\"$val\"$selected>$name</option>\n";
				}
				
				echo "</select>\n";
			}
			else
				echo '<input ' . $attributes . '/>';
		}
		
		function _merge_defaults( $values, $defaults, $force = false ) {
			if ( ! $this->_is_associative_array( $defaults ) ) {
				if ( ! isset( $values ) ) {
					return $defaults;
				}
				if ( false === $force ) {
					return $values;
				}
				if ( isset( $values ) || is_array( $values ) )
					return $values;
				return $defaults;
			}
			
			foreach ( (array) $defaults as $key => $val ) {
				if ( ! isset( $values[$key] ) ) {
					$values[$key] = null;
				}
				$values[$key] = $this->_merge_defaults($values[$key], $val, $force );
			}
			return $values;
		}
		
		function _is_associative_array( &$array ) {
			if ( ! is_array( $array ) || empty( $array ) ) {
				return false;
			}
			$next = 0;
			foreach ( $array as $k => $v ) {
				if ( $k !== $next++ ) {
					return true;
				}
			}
			return false;
		}
		
		// admin DISPLAY OF MESSAGES ////////////////////////
		
		function _showStatusMessage( $message ) {
			echo '<div id="message" class="updated fade"><p><strong>'.$message.'</strong></p></div>';			
		}
		function _showErrorMessage( $message ) {
			echo '<div id="message" class="error"><p><strong>'.$message.'</strong></p></div>';
		}
		
		// SORTING FUNCTION(S) //////////////////////////////////
		
		function _sortGroupsByName( $a, $b ) {
			if ( $this->_options['groups'][$a]['name'] < $this->_options['groups'][$b]['name'] )
				return -1;
			
			return 1;
		}

		
		/////////////////////////////////////////////
		// END CHRIS' FUNCTIONS /////////////////////
		/////////////////////////////////////////////
		
		
    } // End class
	
	$iThemesMobileBuddy_admin = new iThemesMobileBuddy_admin($this); // Create instance
}
