<?php

// Public side of the blog.
if ( !class_exists( "iThemesMobileBuddy_public" ) ) {
    class iThemesMobileBuddy_public {
		function iThemesMobileBuddy_public(&$parent) {
			$this->_parent = &$parent;
			$this->_parent->load();

			if ( $this->_parent->_options['enabled'] ) {
				$this->wp_upload_dir = WP_UPLOAD_DIR();
				
				// If custom page template is set for this page then hook in to change the page template.
				if ( !empty( $this->_parent->_themeoptions['custom_settings']['mobile_blogpage'] ) ) {
					//echo 'filtering';
					add_filter( 'page_template', array( &$this, 'set_home_template_blog' ) );
				}
				
				add_filter( 'theme_root', array( &$this, 'set_theme_root' ) );
				add_filter( 'stylesheet', array( &$this, 'set_stylesheet' ) );
				add_filter( 'theme_root_uri', array( &$this, 'set_theme_root_uri' ) );
				add_filter( 'template', array( &$this, 'set_template' ) );
				
			
				if ( isset( $this->_parent->_options['blogname'] ) && ( $this->_parent->_options['blogname'] != '') ) {
					add_filter( 'option_blogname', array( &$this, 'set_blogname' ) );
				}
				
				if ( isset( $this->_parent->_options['blogdescription'] ) && ( $this->_parent->_options['blogdescription'] != '') ) {
					add_filter( 'option_blogdescription', array( &$this, 'set_blogdescription' ) );
				}
				
				
			}
		}
		
		// Handles changing the template to blog on the blog page.
		function set_home_template_blog( $template ) {
			if ( is_page( $this->_parent->_themeoptions['custom_settings']['mobile_blogpage'] ) ) {
				$template = str_replace( 'index.php', 'blog.php', $template );
				$template = str_replace( 'page.php', 'blog.php', $template );
				return $template;
			} else {
				return $template;
			}
		}
		
		
		function set_template() {
			if ( ! function_exists( 'get_site_transient' ) ) {
				$this->_parent->alert( 'ERROR: WordPress 2.9.0 or newer is required for PluginBuddy Mobile.', true, '9001' );
				//die( 'ERROR #9001: WordPress 2.9.0 is required for PluginBuddy Mobile.' );
				die();
			}
			$this->theme_roots = get_site_transient( 'theme_roots' );
			
			// If cached theme roots doesnt exist, generate it and include mobile theme root in it.
			if ( $this->theme_roots == '' ) {
				// We need to set the theme root to be normal before doing this!
				$this->original_root = true; // Tell root hook to return original theme since get_themes() will call it.
				get_themes(); // Trigger settings of theme roots transient.
				$this->theme_roots = get_site_transient( 'theme_roots' ); // Load the just set theme roots transient.
				$this->theme_roots[$this->_parent->_themeoptions['dir']] = false; // Add blank mobile theme root as a placeholder to avoid missing index until hook kicks in.
				$this->original_root = false; // get_themes() is done so dont need the original roots to be returns anymore.
				set_site_transient( 'theme_roots', $this->theme_roots, 7200 ); // cache for two hours
				
				// Reset theme roots into $wp_theme_directories.  The following handles stuff for THIS page load...
				get_theme_root(false);
				global $wp_theme_directories;
				$wp_theme_directories = $this->wp_upload_dir['basedir'] . '/pluginbuddy_mobile';
			} else { // Cached theme roots exist...
				// If mobile not in cached theme roots, add it.
				if ( !isset( $this->theme_roots[$this->_parent->_themeoptions['dir']] ) ) {
					$this->theme_roots[$this->_parent->_themeoptions['dir']] = false; // Add blank mobile theme root as a placeholder to avoid missing index until hook kicks in.
					set_site_transient( 'theme_roots', $this->theme_roots, 7200 ); // cache for two hours
				}
			}
			
			add_action('wp_print_styles', array( &$this, 'add_styles' ) );
			return $this->_parent->_themeoptions['dir'];
		}		
		function set_theme_root($theme_root) {
			// Following if block needed since get_themes() in set_template() will call this hook if transient theme_roots doesnt exist.
			if ( ( isset( $this->original_root ) && $this->original_root == true ) ) {
				return $theme_root;
			}
			
			return $this->wp_upload_dir['basedir'] . '/pluginbuddy_mobile';
		}
		function set_theme_root_uri() {
			return $this->wp_upload_dir['baseurl'] . '/pluginbuddy_mobile';
		}
		function set_stylesheet() {
			return $this->_parent->_themeoptions['dir'];
		}
		function set_blogname() {
			return $this->_parent->_options['blogname'];
		}
		function set_blogdescription() {
			return $this->_parent->_options['blogdescription'];
		}
		
		// Hooked for setting custom styles.
		function add_styles() {
			// If style manager in use for this, then hook into printing styles to call function to enqueue stylesheet file.
			if ( isset( $this->_parent->_themeoptions['customstyles_enabled'] ) && ( $this->_parent->_themeoptions['customstyles_enabled'] == true ) ) {
				wp_enqueue_style( 'ithemes-mobilebuddy-custom', $this->wp_upload_dir['baseurl'] . '/pluginbuddy_mobile/' . $this->_parent->_themeoptions['dir'] . '.css' );
			}
			
			// If a custom header image is defined, use it.
			if ( isset( $this->_parent->_themeoptions['header'] ) ) {
				$header = $this->wp_upload_dir['baseurl'] . '/' . $this->_parent->_themeoptions['header'];
			} else {
				$header = $this->wp_upload_dir['baseurl'] . '/pluginbuddy_mobile/' . $this->_parent->_themeoptions['dir'] . '/images/header.jpg'; // default header. %s is theme dir uri
			}

			define('MOBILE_HEADER_IMAGE', $header);

			
			if ( $this->_parent->_options['regular_link'] == '1' ) {
				define( 'MOBILEBUDDY_FULL_SITE_LINK', true );
			}

			// Set custom theme settings value variables if they exist.
			if ( isset( $this->_parent->_themeoptions['custom_settings'] ) ) {
				foreach ( (array) $this->_parent->_themeoptions['custom_settings'] as $key => $this_setting) {
					define( strtoupper( $key ), stripslashes( $this_setting ) );
				}
				/*
				if ( empty( $this->_parent->_themeoptions['custom_settings']['mobile_blogpage'] ) ) {
					echo 'cheese';
					add_filter( 'template', array( &$this, 'mobile_blog_template' ) );
				}
				*/
			}
			
		}
		
		/*
		function mobile_blog_template( $template ) {
			return 'yop' . $template;
		}
		*/
		

	}
}
$iThemesMobileBuddy_public = new iThemesMobileBuddy_public($this);
?>