<?php
/**
 *
 * Plugin Name: PluginBuddy Mobile
 * Plugin URI: http://pluginbuddy.com/purchase/mobile/
 * Description: Create custom mobile versions of your site for mobile platforms.
 * Version: 1.1.20
 * Author: The PluginBuddy Team
 * Author URI: http://pluginbuddy.com/
 *
 * Installation:
 * 
 * 1. Download and unzip the latest release zip file.
 * 2. If you use the WordPress plugin uploader to install this plugin skip to step 4.
 * 3. Upload the entire plugin directory to your `/wp-content/plugins/` directory.
 * 4. Activate the plugin through the 'Plugins' menu in WordPress Administration.
 * 
 * Usage:
 * 
 * 1. Navigate to the Mobile menu in the Wordpress Administration Panel.
 * 2. Select Getting Started
 * 3. !!!
 *
 */

if (!class_exists("iThemesMobileBuddy")) {
    class iThemesMobileBuddy {
		var $_version = '1.1.20';
		var $_updater = '1.0.8';
		var $_url = 'http://pluginbuddy.com/purchase/mobile/';
		var $_var = 'ithemes-mobile';
		var $_name = 'mobile';
		var $_timeformat = '%b %e, %Y, %l:%i%p';	// mysql time format
		var $_timestamp = 'M j, Y, g:iA';			// php timestamp format
		var $_usedInputs = array();
		var $_pluginPath = '';
		var $_pluginRelativePath = '';
		var $_pluginURL = '';
		var $_selfLink = '';
		var $_defaults = array(
			'enabled'		=> 1,
			'regular_link'		=> 1,
			'mobile_link'		=> 1,
			'agents'		=> Array(
							//	User agent text to search for, Device description, default theme, sort level (0=popular, 1=less popular, 2=custom agent)
							Array( 'Android', 'Android Device', 'Typewriter', 0 ),
							Array( 'iPad', 'Apple iPad', '', 0 ),
							Array( 'iPhone', 'Apple iPhone', 'Banner', 0 ),
							Array( 'iPod', 'Apple iPod, Touch', 'Banner', 0 ),
							Array( 'BlackBerry', 'BlackBerry Device', 'Typewriter', 1 ),
							Array( 'lg-', 'LG Phones', 'Typewriter', 1),
							Array( 'motorola', 'Motorola Phones', 'Typewriter', 1),
							Array( 'Nintendo DS', 'Nintendo DS', 'Typewriter', 1),
							Array( 'Wii', 'Nintendo Wii', 'Typewriter', 1),
							Array( 'Nokia', 'Nokia Phones', 'Typewriter', 1),
							Array( 'Opera Mini', 'Opera Mini Device', 'Typewriter', 1),
							Array( 'webOS', 'Palm Device', 'Typewriter', 1 ),
							Array( 'sonyericsson', 'Sony Ericson Phones', 'Typewriter', 1),
							Array( 'Samsung', 'Samsung Phones', 'Typewriter', 1),
							Array( 'PSP', 'Sony Playstation Portable', 'Typewriter', 1 ),
							Array( 'Playstation 3', 'Sony Playstation 3', 'Typewriter', 1),
							Array( 'IEMobile', 'Windows CE Device, Mobile IE', 'Typewriter', 1 ),
							
							Array( 'Safari', 'Apple Safari (desktop; for development)', '', 1 ),
							Array( 'Chrome', 'Google Chrome (desktop; for development)', '', 1 ),
							Array( 'MSIE', 'Microsoft Internet Explorer (desktop; for development)', '', 1 ),
							Array( 'Firefox', 'Mozilla Firefox (desktop; for development)', '', 1 ),
							Array( 'Opera', 'Opera (desktop; for development)', '', 1 ),
						),
			'default_theme'		=> 'Typewriter',
			'themeoptions'		=> Array(),
			'upgrade_themes'	=> 1,
		);
		var $_theme_defaults = array(
			'customstyles_enabled'		=> 0,
		);
		var $_options = array();
		
		/**
		 * iThemesMobileBuddy()
		 *
		 * Default Constructor
		 *
		 */
        function iThemesMobileBuddy() {
			//$this->_parent = &$parent;
			
			$this->_pluginPath = dirname( __FILE__ );
			$this->_pluginRelativePath = ltrim( str_replace( '\\', '/', str_replace( rtrim( ABSPATH, '\\\/' ), '', $this->_pluginPath ) ), '\\\/' );
			$this->_pluginURL = get_option( 'siteurl' ) . '/' . $this->_pluginRelativePath;
			if ( isset( $_SERVER['HTTPS'] ) && $_SERVER['HTTPS'] == 'on' ) {
				$this->_pluginURL = str_replace( 'http://', 'https://', $this->_pluginURL );
			}
			$this->_selfLink = array_shift( explode( '?', $_SERVER['REQUEST_URI'] ) ) . '?page=' . $this->_var;
			
			/*
			if ( function_exists( 'add_theme_support' ) ) {
				// Add 3.0+ menu support
				//add_theme_support( 'menus' ); Automatically added by register_nav_menu
				if ( function_exists( 'register_nav_menu' ) ) {
					register_nav_menu( 'pluginbuddy_mobile', 'PluginBuddy Mobile Navigation Menu' );
				}
			}
			*/
			if ( function_exists( 'register_nav_menu' ) ) {
				register_nav_menu( 'pluginbuddy_mobile', 'PluginBuddy Mobile Navigation Menu' );
			}
			
			// Admin.
			if ( is_admin() ) {
				add_action( 'init', array( &$this, 'upgrader_register' ), 50 );
				add_action( 'init', array( &$this, 'upgrader_select' ), 100 );
				add_action( 'init', array( &$this, 'upgrader_instantiate' ), 101 );
				register_activation_hook(__FILE__, array(&$this, 'activate'));
				
				require_once(dirname( __FILE__ ).'/classes/admin.php');
				require_once(dirname( __FILE__ ).'/lib/updater/updater.php');				
				
				
			} else { // Non-Admin.
				//$this->activate();
			
				$this->load();
				$agent = '';
				if ( isset ( $_GET['mobile'] ) ) {
					if ( $_GET['mobile'] == '' ) { // If empty then forcing natural mobile version so clear nomobile cookies.
						unset( $_COOKIE['nomobile'] );
						unset( $_GET['nomobile'] );
						setcookie ( 'nomobile', '', time() - 3600);
					} else {
						$agent = htmlentities( $_GET['mobile'] );
					}
				}
				if ( !isset( $_COOKIE['nomobile'] ) ) { // If nomobile cookie isnt set then continue
					if ( isset ( $_GET['nomobile'] ) ) { // If nomobile is in query string, set its cookie, else see if we need to run mobile theme
						setcookie( 'nomobile', 'true' );
					} else {
						//unset( $_GET['mobile'] );
						$this->determine_theme( $agent );
						if ( isset( $this->_themeoptions ) ) {  // If we are changing theme, run public code.
							require_once(dirname( __FILE__ ).'/classes/public.php');
						}
					}
				}
				
				if ( isset( $_COOKIE['nomobile'] ) || isset( $_GET['nomobile'] ) ) {
					if ( isset( $this->_options['mobile_link'] ) && ( $this->_options['mobile_link'] == '1') ) {
						add_filter( 'wp_footer', array( &$this, 'footer' ) );
					}
				}
			}
        }
		/**
		 *	alert()
		 *
		 *	Displays a message to the user at the top of the page when in the dashboard.
		 *
		 *	$message		string		Message you want to display to the user.
		 *	$error			boolean		OPTIONAL! true indicates this alert is an error and displays as red. Default: false
		 *	$error_code		int			OPTIONAL! Error code number to use in linking in the wiki for easy reference.
		 */
		function alert( $message, $error = false, $error_code = '' ) {
			echo '<div id="message" class="';
			if ( $error == false ) {
				echo 'updated fade';
			} else {
				echo 'error';
			}
			if ( $error_code != '' ) {
				$message .= '<p><a href="http://ithemes.com/codex/page/' . $this->_name . ':_Error_Codes#' . $error_code . '" target="_new"><i>' . $this->_name . ' Error Code ' . $error_code . ' - Click for more details.</i></a></p>';
			}
			echo '"><p><strong>'.$message.'</strong></p></div>';
		}		
		function footer() {
			echo '<a href="' . add_query_arg( 'mobile', '', str_replace( 'nomobile', '', $_SERVER['REQUEST_URI'] ) ) . '" style="font-weight: bolder;">View Mobile Site</a>';
		}

		
		/**
		 * iThemesMobileBuddy::_activate()
		 *
		 * Run on plugin activation.
		 *
		 */
		function activate() {
		
			// If old var has data, migrate it.
			if ( get_option( 'ithemes-mobilebuddy' ) !== false ) {
				$options = get_option( 'ithemes-mobilebuddy' );
				
				add_option($this->_var, $options, '');
				update_option($this->_var, $options);
				
				$this->load();
				
				delete_option( 'ithemes-mobilebuddy' );
			}
		
		
			// Loop through themes in plugin's folder.  For each, move theme_name directory into uploads/pluginbuddy_mobile/theme_name
			$wp_upload_dir = WP_UPLOAD_DIR();
			$dir_handle = @opendir( $this->_pluginPath . '/themes/' ) or die( 'Error #3443: Unable to open plugin theme directory source.' );
			if ( !file_exists( $wp_upload_dir['basedir'] . '/pluginbuddy_mobile/' ) ) {
				mkdir( $wp_upload_dir['basedir'] . '/pluginbuddy_mobile/' );
			}
			while ($file = readdir($dir_handle)) {
				if ( ( $file != '.' ) && ( $file != '..' ) && ( $file != '..' ) && ( $file != 'README - DO NOT EDIT THEMES HERE.txt' ) ) {
					// If theme isnt already copied, copy it over.
					if ( !file_exists( $wp_upload_dir['basedir'] . '/pluginbuddy_mobile/' . $file ) ) {
						$this->recursive_copy( $this->_pluginPath . '/themes/' . $file, $wp_upload_dir['basedir'] . '/pluginbuddy_mobile/' . $file );
					} else { // Theme already exists. Delete it and replace it with upgraded version if upgrades on themes is enabled.
						$this->load();
						if ( $this->_options['upgrade_themes'] == '1' ) {
							@unlink( $this->_pluginPath . '/themes/' . $file );
							$this->recursive_copy( $this->_pluginPath . '/themes/' . $file, $wp_upload_dir['basedir'] . '/pluginbuddy_mobile/' . $file );
						}
					}
				}
			}
			closedir($dir_handle);
		}
		
		function recursive_copy($src,$dst) {
			$dir = opendir($src);
			@mkdir($dst);
			while(false !== ( $file = readdir($dir)) ) {
				if (( $file != '.' ) && ( $file != '..' )) {
					if ( is_dir($src . '/' . $file) ) {
						$this->recursive_copy($src . '/' . $file,$dst . '/' . $file);
					}
					else {
						copy($src . '/' . $file,$dst . '/' . $file);
					}
				}
			}
			closedir($dir);
		}
		
		/**
		 * iThemesMobileBuddy::init_admin()
		 *
		 * Run on admin load.
		 *
		 */
		function init_admin() {
		}

		
		/**
		 * iThemesMobileBuddy::init_public()
		 *
		 * Run on on public load.
		 *
		 */
		function init_public() {
		}		


		function load_themeoptions($theme) {
			if ( !isset( $this->_options['themeoptions'][$theme] ) ) {
				$this->_options['themeoptions'][$theme] = $this->_theme_defaults;
				$this->save();
			}
			$this->_themeoptions = &$this->_options['themeoptions'][$theme];
			
			//global $this->_parent->mobile;
			//$this->_parent->mobile = &$this->_options['themeoptions'][$theme];
			//echo 'sup'.$this->_parent->mobile;

		}
		
		function determine_theme( $agent = '' ) {
			if ( $agent == '' ) { // If no agent title is passed just user the browser-passed agent.
				$agent = $_SERVER['HTTP_USER_AGENT'];
			}
			
			//echo 'agent: ' .$agent;
		
			foreach ( (array) $this->_options['agents'] as $key => $this_agent) {
				//echo 'thisagent:'.$this_agent[0].'<br />';
				if( stristr( $agent, $this_agent[0] ) ) {
					//$this->_themeoptions = &$this->_options['themeoptions'][$this_agent[0]];
					if ( $this_agent[2] == '' ) {
						break;
					}
					$this->load_themeoptions( $this_agent[2] );
					//$this->_options['themeoptions'][$this_agent[0]]['dir'] = $this_agent[2];
					
					$this->_themeoptions['dir'] = $this_agent[2];
					break; // Break out of loop.
				}
			}

						
			// If a theme was found for this agent...
			if ( isset( $this->_themeoptions ) ) {
				$wp_upload_dir = WP_UPLOAD_DIR();
				//echo $wp_upload_dir['basedir'] . '/pluginbuddy_mobile/' . $this->_themeoptions['dir'] . '/';
				if ( ! file_exists( $wp_upload_dir['basedir'] . '/pluginbuddy_mobile/' . $this->_themeoptions['dir'] . '/' ) ) { // If this theme is not found in the theme directory then resort to the default theme.
					if ( file_exists( $wp_upload_dir['basedir'] . '/pluginbuddy_mobile/Typewriter/' ) ) { // If the default theme exists then use it, else report public error and dont use a mobile theme.
						// change theme to default
						unset( $this->_themeoptions );
						$this->_options['themeoptions']['Typewriter']['dir'] = 'Typewriter'; // Set directory.
						//echo '<pre>';
						//print_r($this->_options['themeoptions']);
						//echo '</pre>';
						$this->_themeoptions = &$this->_options['themeoptions']['Typewriter']; // Update pointer. TODO: is this needed??
						echo 'Error #693: Mobile useragent found but selected mobile theme (' . $this->_themeoptions['dir'] . ') missing. Using default.';
					} else { // Selected theme AND default theme missing.
						
						
						echo 'ERROR #742: Selected theme (' . $this->_themeoptions['dir'] . ') AND default theme were missing. Contact the site owner.';
					}
				}
			}
		}

		
		// OPTIONS STORAGE //////////////////////
		
		
		function save() {
			add_option($this->_var, $this->_options, '');
			update_option($this->_var, $this->_options);
			return true;
		}
		
		
		function load() {
			$this->_options=get_option($this->_var);
			$options = array_merge( $this->_defaults, (array)$this->_options );
			
			// Merge any new user agents for mobile - BUGGY
			//$options['agents'] = array_merge( $this->_defaults['agents'], (array)$this->_options['agents'] );

			if ( $options !== $this->_options ) {
				// Defaults existed that werent already in the options so we need to update their settings to include some new options.
				$this->_options = $options;
				$this->save();
			}

			return true;
		}
		//Register the updater version
		function upgrader_register() {
			$GLOBALS['pb_classes_upgrade_registration_list'][$this->_var] = $this->_updater;
		} //end register_upgrader
		//Select the greatest version
		function upgrader_select() {
			if ( !isset( $GLOBALS[ 'pb_classes_upgrade_registration_list' ] ) ) {
				//Fallback - Just include this class
				require_once( $this->_pluginPath . '/lib/updater/updater.php' );
				return;
			}
			//Go through each global and find the highest updater version and the plugin slug
			$updater_version = 0;
			$plugin_var = '';
			foreach ( $GLOBALS[ 'pb_classes_upgrade_registration_list' ] as $var => $version) {
				if ( version_compare( $version, $updater_version, '>=' ) ) {
					$updater_version = $version;
					$plugin_var = $var;
				}
			}
			//If the slugs match, load this version
			if ( $this->_var == $plugin_var ) {
				require_once( $this->_pluginPath . '/lib/updater/updater.php' );
			}
		} //end upgrader_select
		function upgrader_instantiate() {
			
			$pb_product = strtolower( $this->_var );
			$pb_product = str_replace( 'ithemes-', '', $pb_product );
			$pb_product = str_replace( 'pluginbuddy-', '', $pb_product );
			$pb_product = str_replace( 'pluginbuddy_', '', $pb_product );
			$pb_product = str_replace( 'pb_thumbsup', '', $pb_product );
			
			$args = array(
				'parent' => $this, 
				'remote_url' => 'http://updater2.ithemes.com/index.php',
				'version' => $this->_version,
				'plugin_slug' => $this->_var,
				'plugin_path' => plugin_basename( __FILE__ ),
				'plugin_url' => $this->_pluginURL,
				'product' => $pb_product,
				'time' => 43200,
				'return_format' => 'json',
				'method' => 'POST',
				'upgrade_action' => 'check' );
			$this->_pluginbuddy_upgrader = new iThemesPluginUpgrade( $args );

		} //end upgrader_instantiate`


				
    } // End class

	
	
	$iThemesMobileBuddy = new iThemesMobileBuddy(); // Create instance
}
?>
