<?php

if ( false === ( $group = &pb_slides::get_group( 'groups#' . $_GET['edit'] ) ) ) {
	pb_slides::alert( 'Error: Invalid group ID `' . htmlentities( $_GET['edit'] ) . '`', true );
	return;
}


pb_slides::$ui->title( 'Group Settings for "' . stripslashes( $group['title'] ) . '" (<a href="' . pb_slides::page_url() . '">group list</a>)</h2>' );


$settings_form = new pb_slides_settings('group_settings', 'groups#' . $_GET['edit'], 'edit=' . htmlentities( $_GET['edit'] ) );

$settings_form->add_setting( array(
	'type'		=>		'text',
	'name'		=>		'title',
	'title'		=>		'Group title',
	'tip'		=>		'Title of the group. This is for internal reference only.',
	'rules'		=>		'required|string[1-255]',
) );
$settings_form->add_setting( array(
	'type'		=>		'select',
	'name'		=>		'slide_effect',
	'title'		=>		'Slide effect',
	'options'	=>		array( 'slide' => 'Slide', 'fade' => 'Fade' ),
	'css'		=>		'',
	'tip'		=>		'Set effect, slide or fade, for slide animation.',
	'rules'		=>		'required',
) );
$settings_form->add_setting( array(
	'type'		=>		'text',
	'name'		=>		'fade_speed',
	'title'		=>		'Fade speed',
	'tip'		=>		'Set the speed of the fading animation in milliseconds',
	'css'		=>		'text-align: right; width: 50px;',
	'after'		=>		'ms',
	'rules'		=>		'required|int[0-9999999]',
) );
$settings_form->add_setting( array(
	'type'		=>		'text',
	'name'		=>		'slide_speed',
	'title'		=>		'Slide speed',
	'tip'		=>		'Set the speed of the sliding animation in milliseconds',
	'css'		=>		'text-align: right; width: 50px;',
	'after'		=>		'ms',
	'rules'		=>		'required|int[0-9999999]',
) );
$settings_form->add_setting( array(
	'type'		=>		'text',
	'name'		=>		'start_number',
	'title'		=>		'Slide start number',
	'tip'		=>		'Set which slide you would like to start with.',
	'css'		=>		'text-align: right; width: 50px;',
	'rules'		=>		'required|int[0-9999999]',
) );
$settings_form->add_setting( array(
	'type'		=>		'text',
	'name'		=>		'auto_play',
	'title'		=>		'Auto play delay',
	'tip'		=>		'Autoplay slideshow, a positive number will set to true and be the time between slide animation in milliseconds.',
	'css'		=>		'text-align: right; width: 50px;',
	'after'		=>		'ms',
	'rules'		=>		'required|int[0-9999999]',
) );
$settings_form->add_setting( array(
	'type'		=>		'checkbox',
	'name'		=>		'auto_height',
	'title'		=>		'Auto height',
	'options'	=>		array( 'unchecked' => 'false', 'checked' => 'true'), 
	'tip'		=>		'Check to have slides auto adjust height',
	'css'		=>		'',
	'rules'		=>		'required',
) );
$settings_form->add_setting( array(
	'type'		=>		'text',	
	'name'		=>		'auto_height_speed',
	'title'		=>		'Auto height speed',
	'tip'		=>		'Set auto height animation time in milliseconds.',
	'css'		=>		'text-align: right; width: 50px;',
	'after'		=>		'ms',
	'rules'		=>		'required|int[0-9999999]',
) );
$settings_form->add_setting( array(
	'type'		=>		'checkbox',
	'name'		=>		'preload',
	'options'	=>		array( 'unchecked' => 'false', 'checked' => 'true' ),
	'title'		=>		'Preload images',
	'tip'		=>		'Check to preload images',
	'rules'		=>		'required',
) );
$settings_form->add_setting( array(
	'type'		=>		'checkbox',
	'name'		=>		'pagination',
	'options'	=>		array( 'unchecked' => 'false', 'checked' => 'true' ),
	'title'		=>		'Enable pagination',
	'tip'		=>		'Check to enable pagination',
	'css'		=>		'',
	'after'		=>		'',
	'rules'		=>		'required',
) );
$settings_form->add_setting( array(
	'type'		=>		'checkbox',
	'name'		=>		'crossfade',
	'options'	=>		array( 'unchecked' => 'false', 'checked' => 'true' ),
	'title'		=>		'Enable crossfade',
	'tip'		=>		'Check to enable crossfade',
	'css'		=>		'',
	'after'		=>		'',
	'rules'		=>		'required',
) );
$settings_form->add_setting( array(
	'type'		=>		'checkbox',
	'name'		=>		'randomize',
	'options'	=>		array( 'unchecked' => 'false', 'checked' => 'true' ),
	'title'		=>		'Randomize slides',
	'tip'		=>		'Check to randomize slides.',
	'css'		=>		'',
	'after'		=>		'',
	'rules'		=>		'required',
) );
$settings_form->add_setting( array(
	'type'		=>		'checkbox',
	'name'		=>		'hover_pause',
	'options'	=>		array( 'unchecked' => 'false', 'checked' => 'true' ),
	'title'		=>		'Hover pause',
	'tip'		=>		'When enabled, hovering over the slideshow will pause it. ',
	'css'		=>		'',
	'after'		=>		'',
	'rules'		=>		'required',
) );
$settings_form->add_setting( array(
	'type'		=>		'checkbox',
	'name'		=>		'big_target',
	'options'	=>		array( 'unchecked' => 'false', 'checked' => 'true' ),
	'title'		=>		'Big target',
	'tip'		=>		'When enabled, the whole slide will link to next slide on click.',
	'css'		=>		'',
	'after'		=>		'',
	'rules'		=>		'required',
) );
$settings_form->add_setting( array(
	'type'		=>		'checkbox',
	'name'		=>		'stop_after_last',
	'options'	=>		array( 'unchecked' => 'false', 'checked' => 'true' ),
	'title'		=>		'Stop after last slide',
	'tip'		=>		'When enabled, slides will stop after the last slide is displayed.',
	'css'		=>		'',
	'after'		=>		'',
	'rules'		=>		'required',
) );
/*$settings_form->add_setting( array(
	'type'		=>		'checkbox',
	'name'		=>		'hide_after_last',
	'options'	=>		array( 'unchecked' => 'false', 'checked' => 'true' ),
	'title'		=>		'Hide pagination and navigation after last slide',
	'tip'		=>		'This will only hide the pagination and navigation after the last slide. Note: for this to function "Stop after last slide" should be enabled as well.',
	'css'		=>		'',
	'after'		=>		'',
	'rules'		=>		'required',
) ); */
$settings_form->add_setting( array(
	'type'		=>		'title',
	'name'		=>		'title_1',
	'title'		=>		'Style settings',
) );
$settings_form->add_setting( array(
	'type'		=>		'text',
	'name'		=>		'entity_width',
	'title'		=>		'Entity width',
	'tip'		=>		'This controls the width of the Pluginbuddy Slides entity.',
	'css'		=>		'text-align: right; width: 50px;',
	'after'		=>		'px',
	'rules'		=>		'required|int[0-9999999]',
) );
$settings_form->add_setting( array(
	'type'		=>		'text',
	'name'		=>		'entity_height',
	'title'		=>		'Entity height',
	'tip'		=>		'This controls the height of the Pluginbuddy Slides entity',
	'css'		=>		'text-align: right; width: 50px;',
	'after'		=>		'px',
	'rules'		=>		'required|int[0-9999999]',
) );
$settings_form->add_setting( array(
	'type'		=>		'color',
	'name'		=>		'back_color',
	'title'		=>		'Slider background color',
	'tip'		=>		'This controls the background color of the slideshow.',
	'css'		=>		'text-align: left; width: 70px;',
	'rules'		=>		'required',
) );
$settings_form->add_setting( array(
	'type'		=>		'color',
	'name'		=>		'border_color',
	'title'		=>		'Slider border color',
	'tip'		=>		'This controls the color of the Slides border',
	'css'		=>		'text-align: left; width: 70px;',
	'rules'		=>		'required',
) );
$settings_form->add_setting( array(
	'type'		=>		'color',
	'name'		=>		'pagination_color',
	'title'		=>		'Slider pagination color',
	'tip'		=>		'This controls the color of the pagination',
	'css'		=>		'text-align: left; width: 70px;',
	'rules'		=>		'required',
) );

$settings_form->process(); // Handles processing the submitted form (if applicable).

$data['settings_form'] = &$settings_form; // For use in view.



 // For use in view.

// Load view.
pb_slides::load_view( '_settings-edit', $data );
?>
