<?php
if ( false === ( $group = &pb_slides::get_group( 'groups#' . $_GET['group'] ) ) ) {
	pb_slides::alert( 'Error: Invalid group ID `' . htmlentities( $_GET['group'] ) . '`', true );
	return;
}
pb_slides::$ui->title( 'Slide layout settings for "' . stripslashes( $group['title'] ) . '" (<a href="' . pb_slides::page_url() . '">group list</a>)</h2>' );
if ( pb_slides::_GET( 'edit_slide' ) != '' ) { // Editing (I'm so sorry if anyone ever looks at this and gets confused with these - Dustin)
	$edited_slide = pb_slides::_GET( 'edit_slide' );
} else { // adding (normal)
	$edited_slide = '';
}

$this_default2 = pb_slides::$options['groups'][pb_slides::_GET( 'group')]['slides']['slide_layout'];

$settings_form = new pb_slides_settings('slide_settings', false, 'group=' . htmlentities( $_GET['group'] ) . '&edited_slide=' . $edited_slide );

$this_default = '';

if ( pb_slides::_GET( 'edit_slide' ) != '' ) { // Editing
	$this_default = htmlentities(pb_slides::$options['groups'][pb_slides::_GET( 'group' )]['slides'][pb_slides::_GET( 'edit_slide' )]['image']);
}
else  { // not in edit mode
	$this_default = pb_slides::$options['groups'][pb_slides::_GET( 'group')]['image'];
}

$settings_form->add_setting( array(
	'type'		=>		'hidden', // NOTE: Set to text to help debugging image / javscript image selector.
	'name'		=>		'image',
	'title'		=>		'',
	'default'	=>		$this_default,
) );
if ( pb_slides::_GET( 'edit_slide' ) != '' ) { // Editing
	$this_default = pb_slides::$options['groups'][pb_slides::_GET( 'group' )]['slides'][pb_slides::_GET( 'edit_slide' )]['image_size'];
}
else  { // not in edit mode
	$this_default = pb_slides::$options['groups'][pb_slides::_GET( 'group')]['image_size'];
}

$settings_form->add_setting( array(
	'type'		=>		'select',
	'name'		=>		'image_size',
	'title'		=>		'Image size',
	'options'	=>		array( 'thumbnail' => 'Small', 'medium' => 'Medium', 'large' => 'Large', 'full' => 'Full'),
	//'css'		=>		'margin-left: 20px;',
	'tip'		=>		'Select your image size here for your slide. These are the default WordPress image sizes.',
	'rules'		=>		'required',
	'default'	=>		$this_default,
) );

if ( pb_slides::_GET( 'edit_slide' ) != '' ) { // Editing
	$this_default = pb_slides::$options['groups'][pb_slides::_GET( 'group' )]['slides'][pb_slides::_GET( 'edit_slide' )]['slide_layout'];
}
else  { // not in edit mode
	$this_default = pb_slides::$options['groups'][pb_slides::_GET( 'group')]['slide_layout'];
}
$layout_image_path = pb_slides::plugin_url	() . '/images/';
$settings_form->add_setting( array(
	'type'		=>		'radio',
	'name'		=>		'slide_layout',
	'title'		=>		'Slide layout',
	'options'	=>		array( 
							'left' => '<img src="' . $layout_image_path .  'image-left.png" style="vertical-align: -7px;">', 
							'right' => '<img src="' . $layout_image_path .  'image-right.png" style="vertical-align: -7px;">', 
							'top' => '<img src="' . $layout_image_path .  'image-top.png"  style="vertical-align: -7px;">', 
							'bottom' => '<img src="' . $layout_image_path .  'image-bottom.png" style="vertical-align: -7px;">', 
							'full' => '<img src="' . $layout_image_path .  'full-image.png" style="vertical-align: -7px;">', 
							'text' => '<img src="' . $layout_image_path .  'text-only.png" style="vertical-align: -7px;">'
							),
	'css'		=>		'margin-left: 20px;',
	'tip'		=>		'Choose the layout of your slide here.',
	'rules'		=>		'required',
	'default'	=>		$this_default,
) );

$args = array ( 'media_buttons' => false, 'textarea_rows' => '4',); // Args for wp_editor(). 
if ( pb_slides::_GET( 'edit_slide' ) != '' ) { // Editing
	$this_default = pb_slides::$options['groups'][pb_slides::_GET( 'group' )]['slides'][pb_slides::_GET( 'edit_slide' )]['slide_content'];
}
else  { // not in edit mode
	$this_default = pb_slides::$options['groups'][pb_slides::_GET( 'group')]['slide_content'];
}

$settings_form->add_setting( array(
       'type'          =>              'wysiwyg',
       'name'          =>              'slide_content',
       'title'         =>              '',
       'tip'           =>              '',
       'settings'      =>              $args,
	   'default'		=>				$this_default,
) );

$form_result = $settings_form->process();
if ( isset( $form_result['data'] ) && ( count( $form_result['errors'] ) == 0 ) )  {
	if ( pb_slides::_GET( 'edited_slide' ) == '' ) { // adding
		$new_group_options = pb_slides::settings( 'slide_defaults' ); // Gets defaults from pb_slides::$_settings['group_defaults'] which is set up in init.php.
		$new_group_options['slide_content'] = $form_result['data']['slide_content'];
		$new_group_options['slide_layout'] = $form_result['data']['slide_layout'];
		$new_group_options['image_size'] = 	$form_result['data']['image_size'];	
		$new_group_options['image'] = unserialize( $form_result['data']['image'] ); 
		$new_group_options['image'] = $new_group_options['image']['attachment_id'];
		array_push( pb_slides::$options['groups'][$_GET['group']]['slides'], $new_group_options ); // Push into  existing groups array.
		pb_slides::save(); // Save.
		
		pb_slides::alert( 'Slide has been added.' );
	} else { // assume editing
		$editing_group = &pb_slides::get_group( 'groups#' . $_GET['group'] . '#slides#' . pb_slides::_GET( 'edited_slide' ) );
		$editing_group['slide_content'] = $form_result['data']['slide_content'];
		$editing_group['slide_layout'] = $form_result['data']['slide_layout'];
		$editing_group['image_size'] = $form_result['data']['image_size'];  	
		
		if ( is_serialized( $form_result['data']['image'] ) === true ) { // serialized; user selected a new image so must grab ID from it.
			$editing_group['image'] = unserialize( $form_result['data']['image'] );
			$editing_group['image'] = $editing_group['image']['attachment_id'];
		} else { // Not serialized. User left image alone. Keep as is.
			$editing_group['image'] = $form_result['data']['image'];
		}
		pb_slides::save();
		
		pb_slides::alert( 'Slide has been updated.' );
	}
	$settings_form->clear_values();
}

$data['settings_form'] = &$settings_form; // For use in view.

// Bulk deletion.

if ( ( pb_slides::_POST( 'bulk_action' ) == 'delete_images' ) && ( pb_slides::_POST( 'save_order' ) == '' ) ) { // If action to delete is set. 
	pb_slides::verify_nonce(); // Security verification.
	$deleted_images = 0;
	foreach ( (array) pb_slides::_POST( 'items' ) as $id ) { // Iterate through each item to delete.
		$deleted_images++;
		unset( pb_slides::$options['groups'][ $_GET['group'] ]['slides'][$id] );
	}
	pb_slides::save();
	pb_slides::alert( 'Removed ' . $deleted_images . ' images from this group.' );
}

// Re-orders the array of images; index order matches the user selected order.
if ( !empty( $_POST['save_order'] ) ) {
	pb_slides::verify_nonce();
	
	if ( pb_slides::_POST( 'order' ) == '' ) {
		pb_slides::alert( 'No changes made to order.' );
	} else {
		$new_order = explode( ',', pb_slides::_POST( 'order' ) );
		
		$live_array = &pb_slides::get_group( 'groups#' . $_GET['group'] . '#slides' ); // Get live working array of items.
		//echo '<pre>' . print_r( $live_array, true ) . '</pre>';
		$new_array = array(); // Temporary storage for the new reordered array.
		foreach( $new_order as $id ) { // Loop through the new order.
			$new_array[] = $live_array[$id]; // Update the new array with the value from the live working array.
		}
		$live_array = $new_array; // Copy over changes.
		//echo '<pre>' . print_r( $live_array, true ) . '</pre>';
		pb_slides::save();
		pb_slides::alert( __( 'The order has been updated.', 'it-l10n-slides' ) );
	}
}
// Prepare data for table listing.
$slide_list = array();
foreach( $group['slides'] as $slide_id => $slide ) {
$shortnd_content = substr($slide['slide_content'], 0, 45);
if ($shortnd_content != $slide['slide_content'] ) {
	$shortnd_content .= ' ...';
}
$rest = substr("abcdef", -1);  
$list_image = wp_get_attachment_image_src( $slide['image'] );
if ( empty( $list_image[0])) {
	$my_image = '<i>No Image</i>';
}
else {
$my_image = '<img src="' . $list_image[0] . '" width="100" height="100" style="float: left; margin-right: 10px;" />';
}
//$pretty_layout = pb_slides::$format->prettify($slide['slide_layout'], array('left' => 'Left', 'right' => 'Right', 'top' => 'Top', 'bottom' => 'Bottom', 'full' => 'Full', 'text' => 'Text')); TODO: Make slide_layout pretty in table
	$slide_list[$slide_id] = array( 
						$my_image,
						htmlentities( $shortnd_content ), 
						$slide['slide_layout'] 
						);
}
$settings_form->process(); // Handles processing the submitted form (if applicable).
$data['slide_list'] = $slide_list;

pb_slides::load_script( 'thickbox' );
pb_slides::load_style( 'thickbox' );
pb_slides::load_script( 'media-upload' ); // Needed for resizing thickbox.
pb_slides::load_style( 'media-upload' );
pb_slides::load_script('tablednd.js');

pb_slides::load_view( '_settings-slides', $data);
?>
