<?php
if ( isset( $_GET['edit'] ) ) { // If editing pass to edit controller.
	self::load_controller( '_settings-edit' );
} 
elseif ( isset( $_GET['group'] ) ) { // If editing pass to edit controller.
	self::load_controller( '_settings-slides' );
}
else {
	pb_slides::$ui->title( pb_slides::settings( 'name' ) . 'Settings' );

	// ########## BEGIN SUBMISSION PROCESSING ##########


// Prepare data for group creation form. Add form before processing submitted data for it.
	$add_group_form = new pb_slides_settings('add_group', false );
	$add_group_form->add_setting( array(
		'type'		=>		'text',
		'name'		=>		'group_name',
		'title'		=>		'Group name',
		'tip'		=>		'Internal group name for your reference. This may be whatever you like.',
		'rules'		=>		'required|string[1-255]',
	) );
	
	
	$data['add_group_form'] = $add_group_form;
	
	$form_result = $add_group_form->process();
	if ( isset( $form_result['data'] ) && ( count( $form_result['errors'] ) == 0 ) )  {
		$new_group_options = pb_slides::settings( 'group_defaults' ); // Gets defaults from pb_slides::$_settings['group_defaults'] which is set up in init.php.
		$new_group_options['title'] = htmlentities( $form_result['data']['group_name'] ); // Set new title.
		
		array_push( pb_slides::$options['groups'], $new_group_options ); // Push into  existing groups array.
		pb_slides::save(); // Save.
		
		pb_slides::alert( 'Group "' . htmlentities( $form_result['data']['group_name'] ) . '" has been added.  Hover over the newly added group in the table below for settings links.' );
	}
	// ********** End Add Group **********
	
	// Delete group(s).
	if ( pb_slides::_POST( 'do_bulk_action' ) != '' ) {
		$deleted_groups = '';
		
		foreach ( (array) $_POST['items'] as $id ) {
			if ( isset( pb_slides::$options['groups'][$id] ) ) { // Does this exist?
				$deleted_groups .= ' "' . pb_slides::$options['groups'][$id]['title'] . '",'; // Note it.
				unset( pb_slides::$options['groups'][$id] ); // Delete it!
			}
		}
		
		pb_slides::save();
		pb_slides::alert( 'Deleted group(s) ' . trim( $deleted_groups, ',' ) . '.' );
	}


	// ########## END SUBMISSION PROCESSING ##########
	
	
	
	// Prepare data for groups listing.
	$groups = array();
	
	foreach ( (array) pb_slides::$options['groups'] as $id => $group ) {
		$groups[$id] = 	array( $group['title'], count($group['slides']), '[pb_slides group="' . $id . '"]'  );
	}
	$data['groups'] = $groups;
	//$data['groups'] = array('title', 5, 3 );
	
	
	// Prepare data for plugin settings form.
	if ( current_user_can( 'activate_plugins' ) ) {
		$settings_form = new pb_slides_settings('settings', '' );
		
		$settings_form->add_setting( array(
			'type'		=>		'select',
			'name'		=>		'access',
			'title'		=>		'Plugin access limits',
			'options'	=>		array( 'manage_network' => 'Network Administrator', 'activate_plugins' => 'Administrator', 'moderage_comments' => 'Editor', 'edit_published_posts' => 'Author', 'edit_posts' => 'Contributor' ),
			'tip'		=>		'[Default: administrator] - Determine which user roles are allowed to have access to all plugin features. WARNING: This will allow other roles access to configure plugin settings and content and could be a security risk if you are not careful and use caution.',
			'rules'		=>		'required',
		) );
		
		$data['settings_form'] = $settings_form;
	}
	$settings_form->process(); // Handles processing the submitted form (if applicable).
	
	
	
	// Load view.
	pb_slides::load_view( 'settings', $data );
}
?>