<?php
/**
 *
 *	Plugin Name: Slides
 *	Plugin URI: http://pluginbuddy.com/
 *	Description: DisplayBuddy Series - Slides allows users to build custom slides then display them.
 *	Version: 1.0.13
 *	Author: The Pluginbuddy Team
 *	Author URI: http://pluginbuddy.com/
 *
 *	Installation:
 * 
 *	1. Download and unzip the latest release zip file.
 *	2. If you use the WordPress plugin uploader to install this plugin skip to step 4.
 *	3. Upload the entire plugin directory to your `/wp-content/plugins/` directory.
 *	4. Activate the plugin through the 'Plugins' menu in WordPress Administration.
 * 
 *	Usage:
 * 
 *	1. Navigate to the new plugin menu in the Wordpress Administration Panel.
 *
 *	NOTE: DO NOT EDIT THIS OR ANY OTHER PLUGIN FILES. NO USER-CONFIGURABLE OPTIONS WITHIN.
 */




$pluginbuddy_settings = array(
				'slug'				=>		'slides',
				'wp_minimum'		=> 		'3.2.1',
				'series'			=>		'DisplayBuddy',
				'default_options'	=>		array(
												'groups'			=> array(),
												'access'			=>	'activate_plugins',
											),
				'group_defaults'	=>		array( 
												'slides'			=>	array(),
												'title'				=>	'',	
												'slide_effect'		=> 	'slide',
												'entity_width'		=>	'400',
												'entity_height'		=>	'400',
												'fade_speed'		=>	350,
												'slide_speed'		=>	350,
												'start_number'		=> 	1,
												'auto_play'			=>	0,
												'pause'				=>	0,
												'auto_height'		=>	'true',
												'auto_height_speed'	=>	350,
												'preload' 			=>	'false',
												'pagination'		=> 	'true',
												'crossfade'			=>	'false',
												'randomize'			=>	'false',
												'hover_pause'		=>	'false',
												'big_target'		=>	'false',
												'stop_after_last'	=>	'false',
												'entity_layout'		=>	'default',
												'back_color'		=>	'#FFFFFF',
												'border_color'		=>	'#CCCCCC',
												'pagination_color' 	=>	'#CCCCCC',
												'slide_content'		=>	'',
												'slide_layout'		=>	'left',
												'image'				=>	'',
												'image_size' 		=>	'thumbnail'
				),	
				'slide_defaults'	=>		array(
												'slide_content'		=>	'',
												'slide_layout'		=>	'left',
												'image'				=>	'',
												'image_size' 		=>	'small',
				),
				'widget_defaults'	=>		array(
												'group'					=>		array(),
											),
				'modules'			=>		array(
												'downsizer'			=>		false,			// Load thumbnail image downsizer.
												'filesystem'		=>		false,			// File system helper methods.
												'format'			=>		false,			// Text / data formatting helper methods.
												'updater'			=>		true,			// Load PluginBuddy automatic upgrades.
											)
				
			);



// $settings is expected to be populated prior to including PluginBuddy framework. Do not edit below.
require( dirname( __FILE__ ) . '/pluginbuddy/_pluginbuddy.php' );
?>
