<div class="wrap">
	<h2><?php _e( 'Edit Voting Groups', 'it-l10n-thumbsup' ); ?> <a class="button add-new-h2" href="<?php echo esc_url( admin_url( 'admin.php?page=pluginbuddy_thumbsup-addnew' ) ); ?>"><?php _e( 'Add New Voting Group', 'it-l10n-thumbsup' ); ?></a></h2>
<div id="output1"></div>

<?php
	$action = isset( $_REQUEST['action'] ) ? $_REQUEST['action'] : '';
	switch( $action ) {
		case 'edit':
			$post_id = isset( $_REQUEST['post'] ) ? absint( $_REQUEST['post'] ) : 0;
			$post = get_post( $post_id );
			
			//Nonce and post check
			if ( !$post || !current_user_can( 'administrator' ) ) /*|| !( wp_verify_nonce( isset( $_REQUEST['_thumbsup'] ) ? $_REQUEST['_thumbsup'] : '', 'thumbs-up_add-new' ) || wp_verify_nonce( isset( $_REQUEST['_wpnonce'] ) ? $_REQUEST['_wpnonce'] : '', 'thumbs-up_edit-group' ) ) */  {
				echo "<p>Item not found.</p>";
				break;
			}
			//Get post variables
			$post_content_to_edit = stripslashes( format_to_edit( apply_filters( 'content_edit_pre', $post->post_content ) ) );
			$post_content = stripslashes( apply_filters( 'pb_the_content', $post->post_content ) );
			$post_title_to_edit = stripslashes( format_to_edit( apply_filters( 'title_edit_pre', $post->post_title ) ) );
			$post_title = stripslashes( apply_filters( 'the_title', $post->post_title ) );
			$expiration = get_post_meta( $post->ID, 'expiration_timestamp', true );
			$has_expiration = get_post_meta( $post->ID, 'expires', true );
			$media_type = get_post_meta( $post->ID, 'media_type', true );

			$time = $date = false;
			if ( $expiration ) {
				$time = date( 'G:i', $expiration );
				$date = date( 'm/d/Y', $expiration );
				$expiration = date( get_option('date_format'), $expiration ) . ' at ' . date( get_option('time_format'), $expiration );
			}
			//Output preview and quick edit interface
			?>
            <div style="width: 80%; min-width: 750px;" class="postbox-container">
                <div class="metabox-holder">
                    <div class="meta-box-sortables ui-sortable">
                        <div class="postbox" style="display: block;">
                            <div title="Click to toggle" class="handlediv"><br></div><!--/.handlediv-->
                            <h3 class="hndle"><span><?php _e( 'Voting Group', 'it-l10n-thumbsup' ); ?></span></h3>
                            <div class="inside">
                            <div id='group_preview'>
                                <h4 id="group_preview_title"><?php echo $post_title; ?></h4>
                                <div id='group_preview_content'>
                                    <?php echo strip_tags( $post_content ); ?>
                                </div>
                                <ul>
                                    <li><strong><?php _e( 'Media Type', 'it-l10n-thumbsup' ); ?>:</strong> <?php echo ucfirst( $media_type ); ?></li>
                                    <li><strong><?php _e( 'Expiration', 'it-l10n-thumbsup' ); ?>:</strong> <span id='group_preview_expiration'><?php echo $expiration && $has_expiration ? $expiration : "No expiration"; ?></span></li>
                                </ul>
                                <p><input class='button-primary' id='group_edit' type="button" name="group_edit" value="<?php _e('Edit', 'it-l10n-thumbsup' ) ?>" /></p>
                            </div><!--/group_preview-->
                            <div id='group_quick_edit' style='display: none'>
                                <form id="voting_group_form" method="post" action="<?php echo esc_url( admin_url( 'admin.php?page=pluginbuddy_thumbsup-edit' ) ); ?>">
                                 
                                <table class="form-table">
                                    <tbody>
                                        <tr valign="top">
                                            <th scope="row"><label for='group_title'><?php _e( 'Group Title', 'it-l10n-thumbsup' ); ?></label> <span class='required'>*</span></th>
                                            <td>
                                                <input type='text' name='group_title' id='group_title' value='<?php echo esc_attr( $post_title_to_edit ); ?>' /> 
                                                <p class='error hidden' id='group_title_error' ><?php _e( 'This field is required', 'it-l10n-thumbsup' ); ?></p>
                                            </td>
                                        </tr>
                                        <tr valign="top">
                                            <th scope="row"><label for='group_description'><?php _e( 'Group Description', 'it-l10n-thumbsup' ); ?></label></th>
                                            <td>
                                                <textarea rows='5' cols='40'  id='group_description' name='group_description'><?php echo esc_html( $post_content_to_edit ); ?></textarea>
                                            </td>
                                        </tr>
                                        <tr valign="top">
                                            <th scope="row"><?php _e( 'Voting Expiration', 'it-l10n-thumbsup' ); ?></th>
                                            <td>
                                                <p><?php _e( 'Would you like the voting to automatically expire?', 'it-l10n-thumbsup' ); ?></p>
                                               <p> <label for='voting_expire_yes'><?php _e( 'Yes', 'it-l10n-thumbsup' ); ?></label><input type='radio' name='voting_expire' id='voting_expire_yes' value='true' <?php checked( $has_expiration, true ); ?>  />&nbsp;&nbsp;&nbsp;<label for='voting_expire_no'><?php _e( 'No', 'it-l10n-thumbsup' ); ?></label><input type='radio' name='voting_expire' id='voting_expire_no' <?php checked( $has_expiration, false ); ?> value='false' /></p>
                                               <div id="date_time_picker" class="hidden">
                                                   <p><label for='timepicker'><?php _e( 'Time', 'it-l10n-thumbsup' ); ?></label>: <input type='text' size='20' id='timepicker' name='time' value='<?php echo $time; ?>' /></p>
                                                   <p><label for='datepicker'><?php _e( 'Date', 'it-l10n-thumbsup' ); ?></label>: <input type='text' size='20' id='datepicker' name='date' value='<?php echo $date; ?>' /></p>
                                               </div> <!--/date_time_picker-->
                                            </td>
                                        </tr>
                                    </tbody>
                                </table>
                                <?php wp_nonce_field('thumbs-up_add-new', '_thumbsup' ) ?>
                                <input type='hidden' name='media_type' value="<?php echo esc_attr( $media_type ); ?>" />
                                <input type='hidden' name='post' id='post_id' value="<?php echo esc_attr( $post_id ); ?>" />
                                <input type='hidden' name='action' value='save' />
                                <input class='button-primary' id='save_group' type="submit" name="save_group" value="<?php _e('Save', 'it-l10n-thumbsup' ) ?>" /><input class='button-secondary' type="button" id="close_group" name="close_group" value="<?php _e('Cancel Edit', 'it-l10n-thumbsup' ) ?>" /><img class='hidden' id='save_ajax_loader' src='<?php echo $this->get_plugin_url( 'images/ajax-loader.gif' ); ?>' alt='Ajax Loader' width="16" height="16" />
                                <p class='hidden' id='add_new_status'>&nbsp;</p>
                                </form>
                            </div><!--/group_quick_edit-->
                            </div><!--/.inside-->
                        </div><!--/.postbox-->
                        <!--start voting items edit -->
                        <div class="postbox" style="display: block;">
                            <div title="Click to toggle" class="handlediv"><br></div><!--/.handlediv-->
                            <h3 class="hndle"><span><?php _e( 'Edit Voting Items', 'it-l10n-thumbsup' ); ?></span></h3>
                            <div class="inside">   
                             	 <div id='group_item_preview'>
                                    <ul id='group_items'>
                                    <?php
                                 
                                    	
                                        $group_items =  get_posts( 
                                        	array( 
                                        		'numberposts' => -1, 
                                        		'posts_per_page' => -1, 
                                        		'post_parent' => $post_id, 
                                        		'post_type' => 'it_voting_group_item', 
                                        		'orderby' => 'menu_order', 
                                        		'order' => 'ASC',
                                        		'post_status' => 'any' 
                                        	) 
                                        );
                                        $group_item_count = 0;
                                        if ( $group_items ) {
                                            $group_item_count = count( $group_items );
                                            foreach ( $group_items as $item ) {
                                            		//Get HTML for individual item
                                               	$attachment_id = $media_type == 'images' ? get_post_meta( $item->ID, '_thumbnail_id', true ) : false;
                                               	$video_embed_html = $media_type == 'videos' ? wp_oembed_get( trim( $item->post_content ) ) : false;
                                               	$title = stripslashes( apply_filters( 'the_title', $item->post_title ) );
                                               	
                                            		echo $this->build_item_view_html( $media_type, $title, $item->ID, $attachment_id, $video_embed_html );
                                          	} //end foreach
                                        } //end if !group_items
                                    ?>
                                    </ul>
                                </div><!--/group_item_preview-->
                             </div><!--/.inside-->
                        </div><!--/.postbox-->
                        <!--end voting items edit -->
                         <!--start voting items Add -->
                        <div class="postbox" style="display: block;">
                            <div title="Click to toggle" class="handlediv"><br></div><!--/.handlediv-->
                            <h3 class="hndle"><span id="add_voting_item"><?php _e( 'Add Voting Item', 'it-l10n-thumbsup' ); ?></span></h3>
                            <div class="inside">   
                             	<div id='group_item_add'>
										<?php
                                        if ( $media_type == 'images' ) :
                                            ?>
                                            <form id="thumbnail_upload" method="post" action="<?php echo admin_url( 'admin-ajax.php?action=upload_item_thumbnail' ); ?>" enctype="multipart/form-data" >
                                                <input type="file" name="thumbnail" id="thumbnail">
                                                <input type='hidden' value='<?php echo wp_create_nonce( 'pb_upload_item_thumb' ); ?>' name='_ajax_nonce' />
                                                <input type='hidden' name='item_post_parent' value='<?php echo $post_id; ?>' />
                                                <input type='hidden' name='menu_order' value='<?php echo esc_attr( $group_item_count ); ?>' />
                                                <input id="submit_ajax" class='button-secondary' name="submit_ajax" type="submit" value="<?php _e( 'Upload Image', 'it-l10n-thumbsup' ); ?>">
                                            </form>
                                            <?php
                                            //Start outputting form for image saving
                                            ?>
                                            <form id="voting_group_item" method="post" action="<?php echo esc_url( admin_url( 'admin-ajax.php' ) ); ?>" style="display: none;" >
                                            <table class="form-table">
                                                    <tbody>
                                                        <tr valign="top">
                                                            <th scope="row"><label for='item_title'><?php _e( 'Item Title', 'it-l10n-thumbsup' ); ?></label> <span class='required'>*</span></th>
                                                            <td>
                                                            <input type='text' name='item_title'  size='50' id='item_title' value='' /> 
                                                            <p class='error hidden' id='item_title_error' ><?php _e( 'This field is required', 'it-l10n-thumbsup' ); ?></p>
                                                            </td>
                                                        </tr>
                                                        <tr valign="top">
                                                            <th scope="row"><label for='image_caption'><?php _e( 'Image', 'it-l10n-thumbsup' ); ?></label></th>
                                                            <td id='item_image_thumbnail'>
                                                            </td>
                                                        </tr>
                                                        <tr valign="top">
                                                            <th scope="row"><label for='image_caption'><?php _e( 'Image Caption', 'it-l10n-thumbsup' ); ?></label></th>
                                                            <td>
                                                            <input type='text' name='image_caption'  size='50' id='image_caption' value='' /> 
                                                            </td>
                                                        </tr>
                                                        <tr valign="top">
                                                            <th scope="row"><label for='image_description'><?php _e( 'Image Description', 'it-l10n-thumbsup' ); ?></label></th>
                                                            <td>
                                                            <textarea rows='5' cols='30' name='image_description' id='image_description'></textarea>
                                                            </td>
                                                        </tr>
                                                    </tbody>
                                                </table>
                                            <?php
                                        endif; //end if images
                                        
                                        if ( $media_type == 'topics' ):
                                            ?>
                                            <form id="voting_group_item" method="post" action="<?php echo esc_url( admin_url( 'admin-ajax.php' ) ); ?>">
                                            <table class="form-table">
                                                    <tbody>
                                                        <tr valign="top">
                                                            <th scope="row"><label for='item_title'><?php _e( 'Item Title', 'it-l10n-thumbsup' ); ?></label> <span class='required'>*</span></th>
                                                            <td>
                                                            <input type='text' name='item_title'  size='50' id='item_title' value='' />
                                                            <p class='error hidden' id='item_title_error' ><?php _e( 'This field is required', 'it-l10n-thumbsup' ); ?></p>
                                                            </td>
                                                        </tr>
                                                        <tr valign="top">
                                                        	<th scope="row"><label for='item_description'><?php _e( 'Item Description', 'it-l10n-thumbsup' ); ?></label></th>
                                                        	<td>
                                                        	<p><?php _e( 'Insert your text, HTML, or shortcodes here.', 'it-l10n-thumbsup' ); ?></p>
                                                        	<textarea rows="5" cols="45" name="item_description" id="item_description"></textarea>
                                                        	</td>
                                                        </tr>
                                                    </tbody>
                                                </table>
                                            <?php
                                        endif; //end topics
                                        if ( $media_type == 'videos' ) :
                                            ?>
                                            <form id="voting_group_item" method="post" action="<?php echo esc_url( admin_url( 'admin-ajax.php' ) ); ?>">
                                            <table class="form-table">
                                                    <tbody>
                                                        <tr valign="top">
                                                            <th scope="row"><label for='item_title'><?php _e( 'Item Title', 'it-l10n-thumbsup' ); ?></label> <span class='required'>*</span></th>
                                                            <td>
                                                            <input type='text' name='item_title'  size='50' id='item_title' value='' /> 
                                                            <p class='error hidden' id='item_title_error' ><?php _e( 'This field is required', 'it-l10n-thumbsup' ); ?></p>
                                                            </td>
                                                        </tr>
                                                        <tr valign="top">
                                                            <th scope="row"><label for='item_video_url'><?php _e( 'Video URL', 'it-l10n-thumbsup' ); ?></label> <span class='required'>*</span></th>
                                                            <td>
                                                            <input type='text' name='item_video_url' size='50' id='item_video_url' value='' /> <p><?php printf( __( "You can paste in a video URL from <a href='%s'>YouTube</a>, <a href='%s'>Vimeo</a>, <a href='%s'>Flickr</a>, and any other providers that support <a href='%s'>oEmbed</a>", 'it-l10n-thumbsup' ), 'http://www.youtube.com', 'http://www.vimeo.com', 'http://www.flickr.com', 'http://codex.wordpress.org/Embeds' ); ?></p>
                                                            <p class='error hidden' id='item_video_url_error' ><?php _e( 'This field is required', 'it-l10n-thumbsup' ); ?></p>
                                                            </td>
                                                        </tr>
                                                    </tbody>
                                                </table>
                                            <?php
                                        endif; //end videos
                                        ?>
                                        <?php wp_nonce_field('thumbs-up_add-new-item', '_thumbsupitem' ) ?>
                                        <input type='hidden' name='post_status' value='publish' id='post_status' />
                                        <input type='hidden' name='media_type' value="<?php echo esc_attr( $media_type ); ?>" />
                                        <input type='hidden' name='item_id' id='item_id' value="0" />
                                        <input type='hidden' name='attachment_id' id='attachment_id' value="0" />
                                        <input type='hidden' name='updating' id='updating' value="0" />
                                        <input type='hidden' name='parent_id' id='parent_id' value="<?php echo esc_attr( $post_id ); ?>" />
                                        <input type='hidden' name='menu_order' id='menu_order' value='<?php echo esc_attr( $group_item_count ); ?>' />
                                        <input type='hidden' name='action' value='save' />
                                        <input class='button-primary' id='save_item' type="submit" name="save_item" value="<?php _e('Add New Item', 'it-l10n-thumbsup' ) ?>" /><img class='hidden' id='save_ajax_item_loader' src='<?php echo $this->get_plugin_url( 'images/ajax-loader.gif' ); ?>' alt='Ajax Loader' width="16" height="16" />
                                        <input class='button-secondary hidden' id='cancel_save_item' type="button" name="cancel_save_item" value="<?php _e('Cancel Edit', 'it-l10n-thumbsup' ) ?>" onclick="jQuery.pb_thumbsup.cancel_edit(); return false;" />
                                        <p class='hidden' id='add_new_item_status'>&nbsp;</p>
                                    </form>
                                </div><!--/group_item_add-->
                             </div><!--/.inside-->
                        </div><!--/.postbox-->
                        <!--end voting items Add -->
                    </div><!--/.meta-box-sortables ui-sortable -->
                </div><!--/.metabox-holder-->
            </div><!--/.postbox-container-->
              
            
           
            
            <?php
			break;
		case 'delete':
			check_admin_referer( 'thumbs-up_delete-group' );
			$post_id = isset( $_REQUEST['post'] ) ? absint( $_REQUEST['post'] ) : 0;
			
			//Get child posts and delete them
			//todo - may not delete all children if under moderation
			$children = get_posts( array( 'numberposts' => -1, 'posts_per_page' => 1000, 'post_parent' => $post_id, 'post_type' => 'it_voting_group_item' ) );
			foreach ( $children as $child ) {
				wp_delete_post( $child->ID, true );
			}
			
			//Delete the parent post
			wp_delete_post( $post_id, true );
			?>
            <div class='updated'><p><strong><?php _e( 'Item Removed', 'it-l10n-thumbsup' ); ?></strong></p></div>
            <?php
			//no break here so we can continue displaying items
		default:
			/* Filter Content for Displaying */
			function pluginbuddy_column_filter( $columns ) {
				$columns = array(
					'post_title' => __( 'Title', 'it-l10n-thumbsup' ),
					'post_content' => __( 'Description', 'it-l10n-thumbsup' ),
					'media_type' => __( 'Media Type', 'it-l10n-thumbsup' ),
					'post_date' => __( 'Created on', 'it-l10n-thumbsup' ),
					'expires' => __( 'Expires on', 'it-l10n-thumbsup' )
				);
				return $columns;
			} //end pluginbuddy_column_filter
			add_filter( 'pb_posttype_columns', 'pluginbuddy_column_filter' );
			function pluginbuddy_column_item_filter( $content, $type, $post ) {
				switch ( $type ) {
					case 'post_content':
						$content = stripslashes( strip_tags( apply_filters( 'pb_the_content', $post->post_content ) ) );
						break;
					case 'post_title':
						$content = stripslashes( apply_filters( 'the_title', $post->post_title ) );
						$edit_url = wp_nonce_url( add_query_arg( array( 'post' => $post->ID, 'action' => 'edit', 'page' => $_REQUEST['page'] ) , admin_url( 'admin.php' ) ), 'thumbs-up_edit-group' );
						$delete_url = wp_nonce_url( add_query_arg( array( 'post' => $post->ID, 'action' => 'delete', 'page' => $_REQUEST['page'] ) , admin_url( 'admin.php' ) ), 'thumbs-up_delete-group' );
						$content .= sprintf( "<br /><a href='%s'>Edit</a> | <a href='%s'>Delete</a>", esc_url( $edit_url ), esc_url( $delete_url ) );
						break;
					case 'media_type':
						$content = ucfirst( get_post_meta( $post->ID, 'media_type', true ) );
						break;
					case 'expires':
						if ( true == ( $expires = get_post_meta( $post->ID, 'expires', true ) ) && false != ( $timestamp = get_post_meta( $post->ID, 'expiration_timestamp', true ) ) ) {
							$content = date( get_option('date_format'), $timestamp ) . ' at ' . date( get_option('time_format'), $timestamp );
						} else {
							$content = 'No expiration';
						}
					default:	
						break;
				} //end switch column type
				return $content;
			} //end pluginbuddy_column_item_filter
			add_filter( 'pb_posttype_column', 'pluginbuddy_column_item_filter', 3, 11 );
			require_once( 'class.postdisplay.php' );
			$pb_list_table = new pluginbuddy_posttype_display( array( 'post_type' => 'it_voting_group' ) );
			$pb_list_table->display();
			break;
	} //end switch action
	
?>
</div><!--/wrap-->