<?php

// If they clicked the button to reset plugin defaults...
if (!empty($_POST['reset_defaults'])) {
	$this->parent->save_admin_options( $this->parent->get_plugin_defaults() );
	$this->alert( __( 'Plugin settings have been reset to defaults.', 'it-l10n-thumbsup' ) );
}
?>

<div class="wrap">
	<div class="postbox-container" style="width:70%;">
		<?php $this->title( __( 'Getting Started with ', 'it-l10n-thumbsup' ) . $this->get_plugin_info( 'name' ) . ' v' . $this->get_plugin_info( 'version' ) ); ?>
		
		
		
		
		
		<p>
			ThumbsUp, from the <a href='http://www.pluginbuddy.com'>PluginBuddy</a> team at <a href='http://www.ithemes.com'>iThemes</a>, is a WordPress plugin that allows your users to rank items (i.e., topics, videos, images) by clicking a Thumbs Up or Thumbs Down image.
		</p>
        <h3>Main Features</h3>
        <ul class='pluginbuddy-nodecor'>
            <li> - There are three media types to choose from (topics, videos, and images).</li>
            <li> - You can set an expiration time for when votes are no longer counted.</li>
            <li> - A voting group (i.e., a group of items to vote on) can be inserted on a post or page via a shortcode.</li>
            <li> - Three widgets allow you to insert a voting group into a widgetized area.</li>
            <li> - When displaying the voting group, you can change the sort order, and customize what items to display (e.g., title, description).</li>
        </ul>
		<object width="480" height="385"><param name="movie" value="http://www.youtube.com/p/FD88A2394C740EA9?hl=en_US&fs=1"></param><param name="allowFullScreen" value="true"></param><param name="allowscriptaccess" value="always"></param><embed src="http://www.youtube.com/p/FD88A2394C740EA9?hl=en_US&fs=1" type="application/x-shockwave-flash" width="480" height="385" allowscriptaccess="always" allowfullscreen="true"></embed></object>
        <p>View more information about ThumbsUp at the <a href='http://ithemes.com/codex/page/ThumbsUp'>ThumbsUp Codex</a>.</p>
		
		
		
		<br />
		<h3><?php _e( 'Version History', 'it-l10n-thumbsup' ); ?></h3>
		<textarea rows="7" cols="70"><?php readfile( $this->get_plugin_dir( '/history.txt' ) ); ?></textarea>
		<br /><br />
		<script type="text/javascript">
			jQuery(document).ready(function() {
				jQuery("#pluginbuddy_debugtoggle").click(function() {
					jQuery("#pluginbuddy_debugtoggle_div").slideToggle();
				});
			});
		</script>
		
		<a id="pluginbuddy_debugtoggle" class="button secondary-button"><?php _e( 'Debugging Information', 'it-l10n-thumbsup' ); ?></a>
		<div id="pluginbuddy_debugtoggle_div" style="display: none;">
			<h3><?php __( 'Debugging Information', 'it-l10n-thumbsup' ); ?></h3>
			<?php
			echo '<textarea rows="7" cols="65">';
			echo 'Plugin Version = '. $this->get_plugin_info( 'name' ) . ' ' . $this->get_plugin_info( 'version' ) .' ('. $this->get_plugin_info( 'slug' ) .')'."\n";
			echo 'WordPress Version = '.get_bloginfo("version")."\n";
			echo 'PHP Version = '.phpversion()."\n";
			global $wpdb;
			echo 'DB Version = '.$wpdb->db_version()."\n";
			echo "\n". var_export( $this->parent->get_admin_options() ) . '';
			echo '</textarea>';
			?>
			<p>
			<form method="post" action="<?php esc_url( $_SERVER['REQUEST_URI'] ); ?>">
				<input type="hidden" name="reset_defaults" value="true" />
				<input type="submit" name="submit" value="<?php esc_attr_e( 'Reset Plugin Settings & Defaults', 'it-l10n-thumbsup' ); ?>" id="reset_defaults" class="button secondary-button" onclick="if ( !confirm('<?php _e( "WARNING: This will reset all settings associated with this plugin to their defaults. Are you sure you want to do this?", 'it-l10n-thumbsup' ); ?>') ) { return false; }" />
			</form>
			</p>
		</div>
		<br /><br /><br />
		<a href="http://pluginbuddy.com" style="text-decoration: none;"><img src="<?php echo esc_url( $this->get_plugin_url( '/images/pluginbuddy.png' ) ); ?>" style="vertical-align: -3px;" /> PluginBuddy.com</a><br /><br />
	</div>
	<div class="postbox-container" style="width:20%; margin-top: 35px; margin-left: 15px;">
		<div class="metabox-holder">	
			<div class="meta-box-sortables">
				
				<div id="breadcrumbslike" class="postbox">
					<div class="handlediv" title="<?php _e( 'Click to toggle', 'it-l10n-thumbsup' ); ?>"><br /></div>
					<h3 class="hndle"><span><?php _e( 'Things to do...', 'it-l10n-thumbsup' ); ?></span></h3>
					<div class="inside">
						<ul class="pluginbuddy-nodecor">
							<li>- <a href="http://twitter.com/home?status=<?php echo urlencode( __( 'Check out this awesome plugin, ', 'it-l10n-thumbsup' ) . $this->get_plugin_info( 'name' ) . '! ' . $this->get_plugin_info( 'url' ) . ' @pluginbuddy'); ?>" title="<?php _e( 'Share on Twitter', 'it-l10n-thumbsup' ); ?>" onClick="window.open(jQuery(this).attr('href'),'ithemes_popup','toolbar=0,status=0,width=820,height=500,scrollbars=1'); return false;"><?php _e( 'Tweet about this plugin.', 'it-l10n-thumbsup' ); ?></a></li>
							<li>- <a href="http://pluginbuddy.com/purchase/"><?php _e( 'Check out PluginBuddy plugins.', 'it-l10n-thumbsup' ); ?></a></li>
							<li>- <a href="http://pluginbuddy.com/purchase/"><?php _e( 'Check out iThemes themes.', 'it-l10n-thumbsup' ); ?></a></li>
							<li>- <a href="http://secure.hostgator.com/cgi-bin/affiliates/clickthru.cgi?id=ithemes"><?php _e( 'Get HostGator web hosting.', 'it-l10n-thumbsup' ); ?></a></li>
						</ul>
					</div>
				</div>

				<div id="breadcrumsnews" class="postbox">
					<div class="handlediv" title="<?php _e( 'Click to toggle', 'it-l10n-thumbsup' ); ?>"><br /></div>
					<h3 class="hndle"><span><?php _e( 'Latest news from PluginBuddy', 'it-l10n-thumbsup' ); ?></span></h3>
					<div class="inside">
						<p style="font-weight: bold;">PluginBuddy.com</p>
						<?php $this->get_feed( 'http://pluginbuddy.com/feed/', 5 );  ?>
						<p style="font-weight: bold;">Twitter @pluginbuddy</p>
						<?php
						$twit_append = '<li>&nbsp;</li>';
						$twit_append .= sprintf( '<li><img src="%s" style="vertical-align: -3px;" /> <a href="http://twitter.com/pluginbuddy/">Follow @pluginbuddy on Twitter.</a></li>', esc_url( $this->get_plugin_url( '/images/twitter.png' ) ) );
						$twit_append .= sprintf( '<li><img src="%s" style="vertical-align: -3px;" /> <a href="http://pluginbuddy.com/feed/">%s</a></li>', esc_url( $this->get_plugin_url( '/images/feed.png ' ) ), __( 'Subscribe to RSS news feed.', 'it-l10n-thumbsup' ) );
						$twit_append .= sprintf( '<li><img src="%s" style="vertical-align: -3px;" /> <a href="http://pluginbuddy.com/subscribe/">%s</a></li>', esc_url( $this->get_plugin_url( '/images/email.png' ) ), __( 'Subscribe to Email Newsletter.', 'it-l10n-thumbsup' ) );
						$this->get_feed( 'http://twitter.com/statuses/user_timeline/108700480.rss', 5, $twit_append, 'pluginbuddy: ' );
						?>
					</div>
				</div>
				
				<div id="breadcrumbssupport" class="postbox">
					<div class="handlediv" title="Click to toggle"><br /></div>
					<h3 class="hndle"><span><?php _e( 'Need support?', 'it-l10n-thumbsup' ); ?></span></h3>
					<div class="inside">
						<p><?php printf( __( 'See our <a href="%s">tutorials &amp; videos</a> or visit our <a href="%s">support forum</a> for additional information and help.</p>', 'it-l10n-thumbsup' ), 'http://pluginbuddy.com/tutorials/', 'http://pluginbuddy.com/support/' ); ?>
					</div>
				</div>
				
			</div>
		</div>
	</div>
</div>