<?php
	global $pb_thumbsup;
	if ( isset( $_POST[ 'update' ] ) ) {
		check_admin_referer( 'thumbs-up_save-post-settings' );
		$saved_post_types = isset( $_POST[ 'post_types' ] ) ? $_POST[ 'post_types' ] : array();
		$voting_display = isset( $_POST[ 'post_voting_display' ] ) ? sanitize_text_field( $_POST[ 'post_voting_display' ] ) : 'both';
		$voting_text = isset( $_POST[ 'post_voting_text' ] ) ? sanitize_text_field( $_POST[ 'post_voting_text' ] ) : '';
		if ( !is_array( $saved_post_types ) ) $saved_post_types = array();
		$pb_thumbsup->save_admin_options( array( 'post_types' => $saved_post_types, 'post_voting_text' => $voting_text, 'post_voting_display' => $voting_display ) );
		?>
        <div class='updated'><p><strong><?php _e( 'Settings Saved', 'it-l10n-thumbsup' ); ?></strong></p></div>
        <?php
	} 
?>
<div class="wrap">
	<?php $this->title( __( 'Settings', 'it-l10n-thumbsup' ) ); ?>

<div style="width: 80%; min-width: 750px;" class="postbox-container">
    <div class="metabox-holder">
        <div class="meta-box-sortables ui-sortable">
            <div class="postbox" style="display: block;">
                <div title="Click to toggle" class="handlediv"><br></div><!--/.handlediv-->
                <h3 class="hndle"><span><?php _e( 'Post Settings', 'it-l10n-thumbsup' ); ?></span></h3>
                <div class="inside">
                	 <form method="post" action="<?php echo esc_attr( $_SERVER["REQUEST_URI"] ); ?>">
					<?php wp_nonce_field( 'thumbs-up_save-post-settings' ) ?>
                	<table class="form-table">
                        <tbody>
                            <tr valign='top'>
                                <th scope="row"><?php _e( 'Post Types', 'it-l10n-thumbsup' ); ?></th>
                                <td  valign='middle'>
                                <p><?php esc_html_e( 'Globally display ThumbsUp for these post types.', 'it-l10n-thumbsup' ); ?></p>
                                <?php
                                	$post_types = get_post_types( array(
                                		'publicly_queryable' => true,
                                		'show_ui' => true,
                                		'public' => true
                                	), 'objects' );
                                	if ( $post_types ) {
								ob_start();
								foreach ( $post_types as $key => $type ) {
									$label = isset( $type->labels->name ) ? $type->labels->name : $key;				
									?>
									<li><input id='pb_<?php echo esc_attr( $key ); ?>' type='checkbox' name='post_types[]' value='<?php echo esc_attr( $key ); ?>' <?php checked( true, in_array( $key, $pb_thumbsup->get_admin_option( 'post_types' ) ) ); ?>/>&nbsp;&nbsp;<label for='pb_<?php echo esc_attr( $key ); ?>'><?php echo esc_html( $label ); ?></label></li>
									<?php
								} //end foreach post types
								$list_items = ob_get_clean();
								?>
								<ul><?php echo $list_items; ?></ul>
								<?php                                	
                                	} //end if post types
                                ?>
                                </td>
                            </tr>
                            <tr valign='top'>
                                <th scope="row"><label for='post_voting_display'><?php _e( 'Voting Display', 'it-l10n-thumbsup' ); ?></label></th>
                                <td  valign='middle'>
                               	<select name='post_voting_display' id='post_voting_display'>
                                        		<option value='both' <?php selected( $pb_thumbsup->get_admin_option( 'post_voting_display' ), 'both' ); ?>><?php _e( 'Thumbs Up and Thumbs Down', 'it-l10n-thumbsup' ); ?></option>
                                        		<option value='up' <?php selected( $pb_thumbsup->get_admin_option( 'post_voting_display' ), 'up' ); ?>><?php _e( 'Thumbs Up Only', 'it-l10n-thumbsup' ); ?></option>
                                                <option value='down' <?php selected( $pb_thumbsup->get_admin_option( 'post_voting_display' ), 'down' ); ?>><?php _e( 'Thumbs Down Only', 'it-l10n-thumbsup' ); ?></option>
                                        </select>
                                </td>
                            </tr>
                            <tr valign='top'>
                                <th scope="row"><label for='post_voting_text'><?php _e( 'Voting Text', 'it-l10n-thumbsup' ); ?></label></th>
                                <td  valign='middle'>
                               	<input type='text' name='post_voting_text' id='post_voting_text' value='<?php echo esc_attr( $pb_thumbsup->get_admin_option( 'post_voting_text' ) ); ?>' />
                                </td>
                            </tr>
                        </tbody>
                    </table>
                    <div class="submit">
                      <input class='button-primary' type="submit" name="update" value="<?php esc_attr_e('Save Settings', 'it-l10n-thumbsup' ) ?>" />
                    </div><!--/.submit-->
                  </form>
                 </div><!--/.inside-->
            </div><!--/.postbox-->
            <!--end voting items Add -->
        </div><!--/.meta-box-sortables ui-sortable -->
    </div><!--/.metabox-holder-->
</div><!--/.postbox-container-->