<div class="wrap">
	<h2><?php _e( 'ThumbsUp Stats', 'it-l10n-thumbsup' ); ?></h2>
	<form method="post" action="<?php echo esc_attr( $_SERVER["REQUEST_URI"] ); ?>">
	<?php wp_nonce_field( 'thumbs-up_view-stats' ) ?>
	<table class="form-table">
         <tbody>
             <tr valign='top'>
                 <th scope="row"><?php _e( 'Post Type', 'it-l10n-thumbsup' ); ?></th>
                 <td  valign='middle'>
				<?php
				$post_types = get_post_types( array(
			                 		'publicly_queryable' => true,
			                 		'show_ui' => true,
			                 		'public' => true
			                 	), 'objects' );
			     if ( $post_types ) {
			          ob_start();
			          foreach ( $post_types as $key => $post_type ) {
			          	$label = isset( $post_type->labels->name ) ? $post_type->labels->name : $key;	
			          	?>
			          	<option value='<?php echo esc_attr( $key ); ?>' <?php selected( isset( $_POST[ 'post_type' ] ) ? $_POST[ 'post_type' ] : false, $key); ?>><?php echo esc_html( $label ); ?></option>
			          	<?php
			          } //end foreach post_types
			          $select = ob_get_clean();
			          ?>
			          <select  id="post_type" name="post_type">
			          <?php echo $select; ?>
			          </select>
			     <?php
			     }
			     ?>
                 </td>
             </tr>
         </tbody>
     </table>
     <p><?php _e( 'Display the top 30 items for a post type.', 'it-l10n-thumbsup' ); ?></p>
     <div class="submit">
       <input class='button-primary' type="submit" name="update" value="<?php esc_attr_e('View Stats', 'it-l10n-thumbsup' ) ?>" />
     </div><!--/.submit-->
     </form>
<?php
	if ( isset( $_POST[ 'update' ] ) ) :
	check_admin_referer( 'thumbs-up_view-stats' );
	global $current_user, $current_blog, $post, $wpdb;
	$post_type = $_POST[ 'post_type' ];
	$site_id = $blog_id = 1;
	if ( is_multisite() ) {
		$site_id = $current_blog->site_id;
		$blog_id = $current_blog->blog_id;
	}
	$tablename = $this->parent->get_tablename();
	$sql = "select * from {$tablename} where site_id = {$site_id} and blog_id = {$blog_id} and post_type = '{$post_type}' ORDER BY rating DESC limit 30";
	$results = $wpdb->get_results( $wpdb->prepare( $sql ) );
	$post_ids = array();
	foreach ( $results as $key => $data ) {
		array_push( $post_ids, $data->content_id );
	}
	$posts = get_posts( array(
		'post_type' => $post_type,
		'post__in' => $post_ids,
	) );
	update_post_cache( $posts );
	//Now go through the results again
	if ( count( $post_ids ) > 0 ) :
	?>
	 <table cellspacing="0" class="wp-list-table widefat fixed posts">
	<thead>
	<tr>
		<th><?php esc_html_e( 'Title', 'it-l10n-thumbsup' ); ?></th>
		<th><?php esc_html_e( 'Up Votes', 'it-l10n-thumbsup' ); ?></th>
		<th><?php esc_html_e( 'Down Votes', 'it-l10n-thumbsup' ); ?></th>
		<th><?php esc_html_e( 'Rating', 'it-l10n-thumbsup' ); ?></th>
	</tr>
	</thead>
	<tbody>
	<?php
	foreach ( $results as $key => $data ) {
		$post = get_post( $data->content_id );
		setup_postdata( $post );
		$up_votes = $data->up_votes;
		$down_votes = $data->down_votes;
		$rating = $data->rating;
		?>
		<tr>
			<td><a href='<?php echo esc_url( get_permalink() ); ?>'><?php the_title(); ?></a></td>
			<td><?php echo number_format( $up_votes ); ?></td>
			<td><?php echo number_format( $down_votes ); ?></td>
			<td><?php echo esc_html( round( $rating, 2 ) ); ?></td>
		</tr>	
		<?php
	}
	
	?>
	</tbody>
	<tfoot>
	<tr>
		<th><?php esc_html_e( 'Title', 'it-l10n-thumbsup' ); ?></th>
		<th><?php esc_html_e( 'Up Votes', 'it-l10n-thumbsup' ); ?></th>
		<th><?php esc_html_e( 'Down Votes', 'it-l10n-thumbsup' ); ?></th>
		<th><?php esc_html_e( 'Rating', 'it-l10n-thumbsup' ); ?></th>
	</tr>
	</tfoot>
	</table>
	<?php
	else:
	?>
	<p><?php esc_html_e( 'No stats to display', 'it-l10n-thumbsup' ); ?></p>
	<?php
	endif; //posts
	endif; //update $_POST
?>
</div><!--/wrap-->