<?php
	global $pb_thumbsup;
	if ( isset( $_POST[ 'update' ] ) ) {
		check_admin_referer( 'thumbs-up_save-settings' );
		$thumb_style = $_POST[ 'pb_thumb_style' ];
		if ( $thumb_style != 'light' && $thumb_style != 'dark' ) {
			$thumb_style = 'light';
		}
		$disable_styles = $_POST[ 'pb_enable_styles' ];
		if ( $disable_styles != 'true' && $disable_styles != 'false' ) {
			$disable_styles = 'false';
		}
		$email_notifications = $_POST[ 'pb_enable_notifications' ];
		if ( $email_notifications != 'true' && $email_notifications != 'false' ) {
			$email_notifications = 'true';
		}
		$pb_thumbsup->save_admin_options( array( 'thumbs_up_style' => $thumb_style, 'disable_styles' => $disable_styles, 'email_notifications' => $email_notifications ) );
		?>
        <div class='updated'><p><strong><?php _e( 'Settings Saved', 'it-l10n-thumbsup' ); ?></strong></p></div>
        <?php
	} 
?>
<div class="wrap">
	<?php $this->title( __( 'Settings', 'it-l10n-thumbsup' ) ); ?>

<div style="width: 80%; min-width: 750px;" class="postbox-container">
    <div class="metabox-holder">
        <div class="meta-box-sortables ui-sortable">
            <div class="postbox" style="display: block;">
                <div title="Click to toggle" class="handlediv"><br></div><!--/.handlediv-->
                <h3 class="hndle"><span><?php _e( 'Thumb Styles', 'it-l10n-thumbsup' ); ?></span></h3>
                <div class="inside">
                	 <form method="post" action="<?php echo esc_attr( $_SERVER["REQUEST_URI"] ); ?>">
					<?php wp_nonce_field( 'thumbs-up_save-settings' ) ?>
                	<table class="form-table">
                        <tbody>
                            <tr valign='top'>
                                <th scope="row"><?php _e( 'Choose a thumb style', 'it-l10n-thumbsup' ); ?></th>
                                <td  valign='middle'>
                                <div class='pb_settings_thumbs'>
                                	<input <?php checked( $pb_thumbsup->get_admin_option( 'thumbs_up_style' ), 'light' ); ?> type='radio' name='pb_thumb_style'  id='pb_thumb_style_light' value='light' /> 
                                	<label for='pb_thumb_style_light'><span class='pb_thumbsup_light'></span></label>
                                	
                                </div>
                                <div class='pb_settings_thumbs'>
                                	<input <?php checked( $pb_thumbsup->get_admin_option( 'thumbs_up_style' ), 'dark' ); ?> type='radio' name='pb_thumb_style'  id='pb_thumb_style_dark' value='dark' />
                             		<label for='pb_thumb_style_dark'><span class='pb_thumbsup_dark'></span></label>
                                    
                                </div>
                                </td>
                            </tr>
                            <tr valign='top'>
                                <th scope="row"><?php _e( 'Disable styles', 'it-l10n-thumbsup' ); ?></th>
                                <td>
                                <p><?php _e( "You can disable this plugin's styles and implement your own to match your theme.", 'it-l10n-thumbsup' ); ?></p>
                                	<input  <?php checked( $pb_thumbsup->get_admin_option( 'disable_styles' ), 'true' ); ?> type='radio' name='pb_enable_styles'  id='pb_enable_styles_yes' value='true' /> 
                                	<label for='pb_enable_styles_yes'><?php _e( 'Yes', 'it-l10n-thumbsup' ); ?></span></label>
                                	
                               
                                	<input <?php checked( $pb_thumbsup->get_admin_option( 'disable_styles' ), 'false' ); ?> type='radio' name='pb_enable_styles'  id='pb_enable_styles_no' value='false' />
                             		<label for='pb_enable_styles_no'><?php _e( 'No (default)', 'it-l10n-thumbsup' ); ?></span></label>
                                    
                                </td>
                            </tr>
                             <tr valign='top'>
                                <th scope="row"><?php _e( 'E-mail Notifications', 'it-l10n-thumbsup' ); ?></th>
                                <td>
                                <p><?php _e( "You can disable e-mail notifications when someone suggests a topic", 'it-l10n-thumbsup' ); ?></p>
                                	<input  <?php checked( $pb_thumbsup->get_admin_option( 'email_notifications' ), 'true' ); ?> type='radio' name='pb_enable_notifications'  id='pb_enable_notifications_yes' value='true' /> 
                                	<label for='pb_enable_notifications_yes'><?php _e( 'Yes (default)', 'it-l10n-thumbsup' ); ?></span></label>
                                	
                               
                                	<input <?php checked( $pb_thumbsup->get_admin_option( 'email_notifications' ), 'false' ); ?> type='radio' name='pb_enable_notifications'  id='pb_enable_notifications_no' value='false' />
                             		<label for='pb_enable_notifications_no'><?php _e( 'No ', 'it-l10n-thumbsup' ); ?></span></label>
                                    
                                </td>
                            </tr>
                        </tbody>
                    </table>
                    <div class="submit">
                      <input class='button-primary' type="submit" name="update" value="<?php esc_attr_e('Save Settings', 'it-l10n-thumbsup' ) ?>" />
                    </div><!--/.submit-->
                  </form>
                 </div><!--/.inside-->
            </div><!--/.postbox-->
            <!--end voting items Add -->
        </div><!--/.meta-box-sortables ui-sortable -->
    </div><!--/.metabox-holder-->
</div><!--/.postbox-container-->