<div class="wrap">
	<h2><?php _e( 'ThumbsUp Stats', 'it-l10n-thumbsup' ); ?></h2>

<?php
	global $pb_thumbsup, $post_id;
	$action = isset( $_REQUEST['action'] ) ? $_REQUEST['action'] : '';
	$post_id = isset( $_REQUEST['post'] ) ? absint( $_REQUEST['post'] ) : 0;
	if ( $action == 'view' ) {		
		//Nonce and post check
		check_admin_referer( 'thumbs-up_view-stats' );
		$post = get_post( $post_id );
		if ( $post ) {
			printf( '<h3>%s</h3>', stripslashes( apply_filters( 'the_title', $post->post_title ) ) );
		}
		function pluginbuddy_column_filter( $columns ) {
			$columns = array(
				'post_title' => __( 'Item Title', 'it-l10n-thumbsup' ),
				'rank' => __( 'Item Rank', 'it-l10n-thumbsup' ),
				'up_votes' => __( 'Up Votes', 'it-l10n-thumbsup' ),
				'down_votes' => __( 'Down Votes', 'it-l10n-thumbsup' ),
				'total_votes' => __( 'Total Votes', 'it-l10n-thumbsup' ),
			);
			return $columns;
		} //end pluginbuddy_column_filter
		add_filter( 'pb_posttype_columns', 'pluginbuddy_column_filter' );
		function pluginbuddy_post_args( $args = array() ) {
			global $post_id;
			$args['orderby'] = 'meta_value_num';
			$args['meta_key'] = 'pb_thumbsup_score';
			$args['order'] = 'DESC';
			$args['post_parent'] = $post_id;
			return $args;
		} //end pluginbuddy_post_args
		add_filter( 'pb_posttype_args', 'pluginbuddy_post_args' );
		function pluginbuddy_column_item_filter( $content, $type, $post ) {
			global $pb_thumbsup;
			$ratings = $pb_thumbsup->get_ratings( array(), $post->post_parent );
			switch ( $type ) {
				case 'post_title':
					$content = stripslashes( apply_filters( 'the_title', $post->post_title ) );
					break;
				case 'up_votes':
					$content = isset( $ratings->items[ $post->ID ][ 'up_votes' ] ) ? number_format( $ratings->items[ $post->ID ][ 'up_votes' ] ) : 0; 
					break;
				case 'down_votes':
					$content = isset( $ratings->items[ $post->ID ][ 'down_votes' ] ) ? number_format( $ratings->items[ $post->ID ][ 'down_votes' ] ) : 0; 
					break;
				case 'total_votes':
					$content = isset( $ratings->items[ $post->ID ][ 'total_votes' ] ) ? number_format( $ratings->items[ $post->ID ][ 'total_votes' ] ) : 0; 
					break;
				case 'rank':
					$content = isset( $ratings->items[ $post->ID ][ 'rank' ] ) ? round( $ratings->items[ $post->ID ][ 'rank' ], 2) : 0; 
					break;
				default:	
					break;
			} //end switch column type
			return $content;
		} //end pluginbuddy_column_item_filter
		add_filter( 'pb_posttype_column', 'pluginbuddy_column_item_filter', 3, 11 );
		require_once( 'class.postdisplay.php' );
		$pb_list_table = new pluginbuddy_posttype_display( array( 'post_type' => 'it_voting_group_item' ) );
		$pb_list_table->display();
	} else if ( $action == 'random' ) {
		check_admin_referer( 'thumbs-up_random-stats' );
		
		//Get the item IDs
		$item_args = array( 
			'numberposts' => -1,
			'posts_per_page' => -1, 
			'post_parent' => $post_id, 
			'post_type' => 'it_voting_group_item',
		);
		$items = get_posts( $item_args );
		if ( !$items ) $items = array();
		$item_ids = array();
		foreach ( $items as $item ) {
			array_push( $item_ids, $item->ID );
		}
		//Get the ratings and randomize the items
		$ratings = $pb_thumbsup->get_ratings( $item_ids, $post_id );
		foreach ( $ratings->items as $item_id => &$item ) {
			$item['up_votes'] = rand( 5, 100 );
			$item['down_votes'] = rand( 0, 200 );
		}
		//Save the items
		if ( count( $item_ids ) > 0 ) {
			$pb_thumbsup->calculate_ratings( array( 'ratings' => $ratings, 'item_id' => $item_ids[0], 'parent_id' => $post_id ) );
			//Delete transients
			global $wpdb;
			$sql = $wpdb->prepare( "delete from {$wpdb->options} where option_name like '%s' or option_name like '%s'",  "_transient_pb_{$post_id}%", "_transient_timeout_pb_{$post_id}%" );
			$wpdb->query( $sql );
			?>
            <div class='updated'><p><strong><?php _e( 'Stats Are Now Randomized', 'it-l10n-thumbsup' ); ?></strong></p></div>
            <?php
		} else {
			?>
			<div class='error'><p><strong><?php _e( 'Stats Could Not Be Randomized - Are there any items?', 'it-l10n-thumbsup' ); ?></strong></p></div>
			<?php
		}
	} else if ( $action == 'clear' ) {
		check_admin_referer( 'thumbs-up_clear-stats' );
		//Delete transients
		global $wpdb;
		$sql = $wpdb->prepare( "delete from {$wpdb->options} where option_name like '%s' or option_name like '%s'",  "_transient_pb_{$post_id}%", "_transient_timeout_pb_{$post_id}%" );
		$wpdb->query( $sql );
		//Delete ratings
		delete_post_meta( $post_id, 'pb_thumbsup_ratings' );
		?>
		<div class='updated'><p><strong><?php _e( 'Stats Are Now Cleared', 'it-l10n-thumbsup' ); ?></strong></p></div>
        <?php		
	}
	
	if ( $action != 'view' ) :		
		/* Filter Content for Displaying */
		function pluginbuddy_column_filter( $columns ) {
			$columns = array(
				'post_title' => __( 'Title', 'it-l10n-thumbsup' ),
				'post_content' => __( 'Description', 'it-l10n-thumbsup' ),
				'media_type' => __( 'Media Type', 'it-l10n-thumbsup' ),
				'post_date' => __( 'Created On', 'it-l10n-thumbsup' ),
				'expires' => __( 'Expires On', 'it-l10n-thumbsup' ),
				'total_votes' => __( 'Total Votes', 'it-l10n-thumbsup' )
			);
			return $columns;
		} //end pluginbuddy_column_filter
		add_filter( 'pb_posttype_columns', 'pluginbuddy_column_filter' );
		function pluginbuddy_column_item_filter( $content, $type, $post ) {
			switch ( $type ) {
				case 'post_content':
						$content = stripslashes( strip_tags( apply_filters( 'pb_the_content', $post->post_content ) ) );
						break;
				case 'post_title':
					$content = stripslashes( apply_filters( 'the_title', $post->post_title ) );
					$view_url = wp_nonce_url( add_query_arg( array( 'post' => $post->ID, 'action' => 'view', 'page' => $_REQUEST['page'] ) , admin_url( 'admin.php' ) ), 'thumbs-up_view-stats' );
					$clear_url = wp_nonce_url( add_query_arg( array( 'post' => $post->ID, 'action' => 'clear', 'page' => $_REQUEST['page'] ) , admin_url( 'admin.php' ) ), 'thumbs-up_clear-stats' );
					$random_url = wp_nonce_url( add_query_arg( array( 'post' => $post->ID, 'action' => 'random', 'page' => $_REQUEST['page'] ) , admin_url( 'admin.php' ) ), 'thumbs-up_random-stats' );
					
					$content .= sprintf( "<br /><a href='%s'>%s</a> | <a href='%s'>%s</a> | <a href='%s'>%s</a>", esc_url( $view_url ), __( 'View', 'it-l10n-thumbsup' ), esc_url( $clear_url ), __( 'Clear', 'it-l10n-thumbsup' ), esc_url( $random_url ), __( 'Randomize (for testing)', 'it-l10n-thumbsup' ) );
					break;
				case 'media_type':
					$content = ucfirst( get_post_meta( $post->ID, 'media_type', true ) );
					break;
				case 'expires':
					$timestamp = get_post_meta( $post->ID, 'expiration_timestamp', true );
					if ( $timestamp ) {
						$content = date( get_option('date_format'), $timestamp ) . ' at ' . date( get_option('time_format'), $timestamp );
					} else {
						$content = __( 'No expiration', 'it-l10n-thumbsup' );
					}
					break;
				case 'total_votes':
					global $pb_thumbsup;
					$ratings = $pb_thumbsup->get_ratings( array(), $post->ID );
					$content = $ratings ? number_format( $ratings->total_votes ) : 0;
					break;
				default:	
					break;
			} //end switch column type
			return $content;
		} //end pluginbuddy_column_item_filter
		add_filter( 'pb_posttype_column', 'pluginbuddy_column_item_filter', 3, 11 );
		require_once( 'class.postdisplay.php' );
		$pb_list_table = new pluginbuddy_posttype_display( array( 'post_type' => 'it_voting_group' ) );
		$pb_list_table->display();
	endif;
?>
</div><!--/wrap-->