<?php
//VOTING GROUP WIDGETS
class pb_thumbsup_topics_widget	 extends WP_Widget {		
			var $parent = false;
			function pb_thumbsup_topics_widget(){ 
				global $pb_thumbsup;
				$this->parent = $pb_thumbsup;
				
				//Widget init
				$widget_ops = array('description' => __( 'Allows you to rank topics.' , 'it-l10n-thumbsup' ) );
				//Create widget
				$this->WP_Widget('pb_thumbsup_topics', __( 'ThumbsUp Topics', 'it-l10n-thumbsup' ), $widget_ops);
			} //end constructor
						
			// widget - Displays the widget
			public function widget($args, $instance) {
				extract($args, EXTR_SKIP);
				if ( !is_int( $instance[ 'group_id' ] ) ) return;
				
				
				echo $before_widget;
				$title = empty($instance['title']) ? __( 'Thumbs Up', 'it-l10n-thumbsup' ) : apply_filters('widget_title', $instance['title']);
				
				if ( !empty( $title ) ) {
					echo $before_title . $title . $after_title;
				};
				
				//Get Items
				$instance[ 'is_widget' ] = true;
				$display = pb_thumbsup_display( $instance );
				if ( is_wp_error( $display ) ) return;
				
				echo $display;
				echo $after_widget;
			} //end widget
			
			
			//Updates widget options
			public function update( $new, $old ) {
				$instance = pb_thumbsup_widget_validate( $new );
				return $instance;
			}
						
			//Widget form
			public function form($instance) {
				$defaults = pb_thumbsup_getwidget_defaults();

				$instance = wp_parse_args( (array)$instance, $defaults );
				if ( empty( $instance['title'] ) ) $instance['title'] = $defaults['title'];
               
			    pb_thumbsup_widget_output( $this, $instance, 'topics' );
			}//End function form
			
}//End pb_thumbsup_topics_widget
add_action('widgets_init', create_function('', 'return register_widget("pb_thumbsup_topics_widget");') );

class pb_thumbsup_images_widget extends WP_Widget {		
			var $parent = false;
			function pb_thumbsup_images_widget(){ 
				global $pb_thumbsup;
				$this->parent = $pb_thumbsup;
				
				//Widget init
				$widget_ops = array('description' => __( 'Allows you to rank images.', 'it-l10n-thumbsup' ) );
				//Create widget
				$this->WP_Widget('pb_thumbsup_images', __( 'ThumbsUp Images', 'it-l10n-thumbsup' ), $widget_ops);
			} //end constructor
						
			// widget - Displays the widget
			public function widget($args, $instance) {
				extract($args, EXTR_SKIP);
				if ( !is_int( $instance[ 'group_id' ] ) ) return;
				
				
				echo $before_widget;
				$title = empty($instance['title']) ? __( 'Thumbs Up', 'it-l10n-thumbsup' ) : apply_filters('widget_title', $instance['title']);
				
				if ( !empty( $title ) ) {
					echo $before_title . $title . $after_title;
				};
				
				//Get Items
				$instance[ 'is_widget' ] = true;
				$display = pb_thumbsup_display( $instance );
				if ( is_wp_error( $display ) ) return;
				
				echo $display;
				echo $after_widget;
			}
			
			
			//Updates widget options
			public function update($new, $old) {
				$instance = pb_thumbsup_widget_validate( $new );
				return $instance;
			}
						
			//Widget form
			public function form($instance) {
				$defaults = pb_thumbsup_getwidget_defaults();

				$instance = wp_parse_args( (array)$instance, $defaults );
				if ( empty( $instance['title'] ) ) $instance['title'] = $defaults['title'];
               
			    pb_thumbsup_widget_output( $this, $instance, 'images' );
			}//End function form
			
}//End class pb_thumbsup_images_widget
add_action('widgets_init', create_function('', 'return register_widget("pb_thumbsup_images_widget");') );

class pb_thumbsup_videos_widget extends WP_Widget {		
			var $parent = false;
			function pb_thumbsup_videos_widget(){ 
				global $pb_thumbsup;
				$this->parent = $pb_thumbsup;
				
				//Widget init
				$widget_ops = array('description' => __( 'Allows you to rank videos on a post or page.', 'it-l10n-thumbsup' ) );
				//Create widget
				$this->WP_Widget('pb_thumbsup_videos', __( 'ThumbsUp Videos', 'it-l10n-thumbsup' ), $widget_ops);
			} //end constructor
						
			// widget - Displays the widget
			public function widget($args, $instance) {
				extract($args, EXTR_SKIP);
				if ( !is_int( $instance[ 'group_id' ] ) ) return;
				
				
				echo $before_widget;
				$title = empty($instance['title']) ? __( 'Thumbs Up', 'it-l10n-thumbsup' ) : apply_filters('widget_title', $instance['title']);
				
				if ( !empty( $title ) ) {
					echo $before_title . $title . $after_title;
				};
				
				//Get Items
				$instance[ 'is_widget' ] = true;
				$display = pb_thumbsup_display( $instance );
				if ( is_wp_error( $display ) ) return;
				
				echo $display;
				echo $after_widget;
			}
			
			
			//Updates widget options
			public function update($new, $old) {
				$instance = pb_thumbsup_widget_validate( $new );
				return $instance;
			}
						
			//Widget form
			public function form($instance) {
				$defaults = pb_thumbsup_getwidget_defaults();
				$instance = wp_parse_args( $instance, $defaults );
				if ( empty( $instance['title'] ) ) $instance['title'] = $defaults['title'];
               
			    pb_thumbsup_widget_output( $this, $instance, 'videos' );
			}//End function form
			
}//End class pb_thumbsup_videos_widget
add_action('widgets_init', create_function('', 'return register_widget("pb_thumbsup_videos_widget");') );


function pb_thumbsup_widget_output( $widget, &$instance, $media_type = 'topics' ) {
	global $pb_thumbsup;
	//Get voting groups
	$group_args = array( 
		'numberposts' => -1,
		'posts_per_page' => -1, 
		'post_type' => 'it_voting_group',
		'order' => 'ASC',
		'orderby' => 'title',
		'meta_key' => 'media_type',
		'meta_value' => $media_type,
		'meta_compare' => '='
	);
	$voting_groups = get_posts( $group_args );
	if ( !$voting_groups || count( $voting_groups ) == 0 ) :
		?>
		<p><?php _e( 'There is nothing to add yet.', 'it-l10n-thumbsup' ); ?></p>
		<?php
	else:
	?>
		<h3><?php esc_html_e( 'Group Options', 'it-l10n-thumbsup' ); ?></h3>
		 <p>
		  <label for="<?php echo $widget->get_field_id( 'title' ); ?>"><?php esc_html_e( 'Widget Title', 'it-l10n-thumbsup' ); ?></label> <br />
		  <input class="widefat" id="<?php echo $widget->get_field_id( 'title' ); ?>" name="<?php echo $widget->get_field_name( 'title' ); ?>" type="text" value="<?php echo esc_attr( $instance[ 'title' ] ); ?>" />
		</p>

		<select id="<?php echo esc_attr($widget->get_field_id( 'group_id' ) ); ?>" name="<?php echo esc_attr($widget->get_field_name( 'group_id' ) ); ?>">
			<option value="">  <?php _e("Select a Voting Group to Add", 'it-l10n-thumbsup' ); ?>  </option>
			<?php
				foreach($voting_groups as $group) {
					?>
					<option  <?php selected( $instance[ 'group_id' ], $group->ID ); ?> rel="<?php echo esc_attr( get_post_meta( $group->ID, 'media_type', 1 ) ); ?>" value="<?php echo absint( $group->ID ) ?>"><?php echo esc_html( stripslashes( apply_filters( 'get_the_title', $group->post_title ) ) ) ?></option>
					<?php
				} //end foreach groups
			?>
		</select> <br/>

	<!--Global Options-->
	<div id='<?php echo esc_attr($widget->get_field_id( 'pb_thumbsup_options' ) ); ?>'>
		<p>Display:
		<select name='<?php echo esc_attr($widget->get_field_name( 'display' ) ); ?>' id='<?php echo esc_attr($widget->get_field_id( 'display' ) ); ?>'>
          		<option value='both' <?php selected( $instance[ 'display'] ,'both' ); ?>><?php _e( 'Thumbs Up and Thumbs Down', 'it-l10n-thumbsup' ); ?></option>
          		<option value='up' <?php selected( $instance[ 'display'] ,'up' ); ?>><?php _e( 'Thumbs Up Only', 'it-l10n-thumbsup' ); ?></option>
                  <option value='down' <?php selected( $instance[ 'display'] ,'down' ); ?>><?php _e( 'Thumbs Down Only', 'it-l10n-thumbsup' ); ?></option>
          </select>
		
		</p>
		<p>Sort by:
			<select name='<?php echo esc_attr($widget->get_field_name( 'orderby' ) ); ?>' id='<?php echo esc_attr($widget->get_field_id( 'orderby' ) ); ?>'>
					<option value='date' <?php selected( $instance[ 'orderby'] ,'date' ); ?>><?php _e( 'Date Added', 'it-l10n-thumbsup' ); ?></option>
					<option value='menu_order' <?php selected( $instance[ 'orderby'] ,'menu_order' ); ?>><?php _e( 'Menu Order', 'it-l10n-thumbsup' ); ?></option>
					<option value='rand' <?php selected( $instance[ 'orderby'] ,'rand' ); ?>><?php _e( 'Random', 'it-l10n-thumbsup' ); ?></option>
					<option value='rating' <?php selected( $instance[ 'orderby'] ,'rating' ); ?>><?php _e( 'Rating', 'it-l10n-thumbsup' ); ?></option>
			</select> 
		</p>
		<p><?php _e( 'Order by:', 'it-l10n-thumbsup' ); ?>
		<select name='<?php echo esc_attr($widget->get_field_name( 'order' ) ); ?>'>
				<option value='ASC' <?php selected( $instance[ 'order'] ,'ASC' ); ?>><?php _e( 'Low to High (ASC)', 'it-l10n-thumbsup' ); ?></option>
				<option value='DESC' <?php selected( $instance[ 'order'] ,'DESC' ); ?>><?php _e( 'High to Low (DESC)', 'it-l10n-thumbsup' ); ?></option>
		</select>
		</p>
		<p><?php _e( 'Show Group Title', 'it-l10n-thumbsup' ); ?><br />
			<label for='<?php echo esc_attr($widget->get_field_id( 'show_group_title_yes' ) ); ?>'><?php _e( 'Yes', 'it-l10n-thumbsup' ); ?></label>
			<input <?php checked( $instance[ 'show_group_title'] ,'1' ); ?> type='radio' name='<?php echo esc_attr($widget->get_field_name( 'show_group_title' ) ); ?>'  id='<?php echo esc_attr($widget->get_field_id( 'show_group_title_yes' ) ); ?>' value='1'  checked="checked" />&nbsp;<label for='<?php echo esc_attr($widget->get_field_id( 'show_group_title_no' ) ); ?>'><?php _e( 'No', 'it-l10n-thumbsup' ); ?></label><input <?php checked( $instance[ 'show_group_title'] ,'0' ); ?> type='radio' name='<?php echo esc_attr($widget->get_field_name( 'show_group_title' ) ); ?>' id='<?php echo esc_attr($widget->get_field_id( 'show_group_title_no' ) ); ?>' value='0' />
		</p>
		<p><?php _e( 'Show Group Description', 'it-l10n-thumbsup' ); ?><br />
			<label for='<?php echo esc_attr( $widget->get_field_id( 'show_group_desc_yes' ) ); ?>'><?php _e( 'Yes', 'it-l10n-thumbsup' ); ?></label>
			<input  <?php checked( $instance[ 'show_group_desc'] ,'1' ); ?> type='radio' name='<?php echo esc_attr($widget->get_field_name( 'show_group_desc' ) ); ?>'  id='<?php echo esc_attr($widget->get_field_id( 'show_group_desc_yes' ) ); ?>' value='1'  />&nbsp;<label for='<?php echo esc_attr($widget->get_field_id( 'show_group_desc_no' ) ); ?>'><?php _e( 'No', 'it-l10n-thumbsup' ); ?></label><input <?php checked( $instance[ 'show_group_desc'] ,'0' ); ?> type='radio' name='<?php echo esc_attr($widget->get_field_name( 'show_group_desc' ) ); ?>'  id='<?php echo esc_attr($widget->get_field_id( 'show_group_desc_no' ) ); ?>' value='0' />
		</p>
        <?php if ( $media_type == "topics" ) : ?>
        	<input type='hidden' name='<?php echo esc_attr($widget->get_field_name( 'show_item_title' ) ); ?>'  id='<?php echo esc_attr($widget->get_field_id( 'show_item_title_yes' ) ); ?>' value='1'  />
        <?php else: ?>
        <p><?php _e( 'Show Item Title', 'it-l10n-thumbsup' ); ?><br />
            <label for='<?php echo esc_attr($widget->get_field_id( 'show_item_title_yes' ) ); ?>'><?php _e( 'Yes', 'it-l10n-thumbsup' ); ?></label>
            <input <?php checked( $instance[ 'show_item_title'] ,'1' ); ?> type='radio' name='<?php echo esc_attr($widget->get_field_name( 'show_item_title' ) ); ?>'  id='<?php echo esc_attr($widget->get_field_id( 'show_item_title_yes' ) ); ?>' value='1'  checked="checked" />&nbsp;<label for='<?php echo esc_attr($widget->get_field_id( 'show_item_title_no' ) ); ?>'><?php _e( 'No', 'it-l10n-thumbsup' ); ?></label><input <?php checked( $instance[ 'show_item_title'] ,'0' ); ?>type='radio' name='<?php echo esc_attr($widget->get_field_name( 'show_item_title' ) ); ?>'   id='<?php echo esc_attr($widget->get_field_id( 'show_item_title_no' ) ); ?>' value='0' />
       </p>
       <?php endif; ?>
	</div><!--/pb_thumbsup_options-->
	
	<!--Videos-->
	<?php if ( $media_type == "videos" ) : ?>
	<div id='<?php echo esc_attr($widget->get_field_id( 'pb_thumbsup_videos' ) ); ?>'>
		<h3><?php _e( 'Video Options', 'it-l10n-thumbsup' ); ?></h3>
		<p><label for='<?php echo esc_attr($widget->get_field_id( 'video_max_width' ) ); ?>'><?php _e( 'Video Max Width', 'it-l10n-thumbsup' ); ?></label><br />
			<input type='text' name='<?php echo esc_attr($widget->get_field_name( 'video_max_width' ) ); ?>'  size='10' id='<?php echo esc_attr($widget->get_field_id( 'video_max_width' ) ); ?>' value='<?php echo esc_attr( absint( $instance[ 'video_max_width' ] ) ); ?>' />
		</p>
		<p><label for='<?php echo esc_attr($widget->get_field_id( 'video_max_height' ) ); ?>'><?php _e( 'Video Max Height', 'it-l10n-thumbsup' ); ?></label><br />
			<input type='text' name='<?php echo esc_attr($widget->get_field_name( 'video_max_height' ) ); ?>'  size='10' id='<?php echo esc_attr($widget->get_field_id( 'video_max_height' ) ); ?>' value='<?php echo esc_attr( absint( $instance[ 'video_max_height' ] ) ); ?>' />
		</p>
	
	</div><!--/#pb_thumbsup_videos-->
    <?php endif; ?>
	<!--/Videos-->
    <?php if ( $media_type == "images" ) : ?>

	<!--Images-->
	
	<div id='<?php echo esc_attr($widget->get_field_id( 'pb_thumbsup_images' ) ); ?>'>
		<h3><?php _e( 'Image Options', 'it-l10n-thumbsup' ); ?></h3>
		<p><label for='<?php echo esc_attr($widget->get_field_id( 'thumb_width' ) ); ?>'><?php _e( 'Image Max Width', 'it-l10n-thumbsup' ); ?></label><br />
			<input type='text' name='<?php echo esc_attr($widget->get_field_name( 'thumb_width' ) ); ?>'  size='10' id='<?php echo esc_attr($widget->get_field_id( 'thumb_width' ) ); ?>' value='<?php echo esc_attr( absint( $instance[ 'thumb_width' ] ) ); ?>' />
		</p>
		<p><label for='<?php echo esc_attr($widget->get_field_id( 'thumb_height' ) ); ?>'><?php _e( 'Image Max Height', 'it-l10n-thumbsup' ); ?></label><br />
			<input type='text' name='<?php echo esc_attr($widget->get_field_name( 'thumb_height' ) ); ?>'  size='10' id='<?php echo esc_attr($widget->get_field_id( 'thumb_height' ) ); ?>' value='<?php echo esc_attr( absint( $instance[ 'thumb_height' ] ) ); ?>' />
	   </p>
		<p><?php _e( 'Show Image Caption', 'it-l10n-thumbsup' ); ?><br />
			<label for='<?php echo esc_attr($widget->get_field_id( 'show_image_caption_yes' ) ); ?>'><?php _e( 'Yes', 'it-l10n-thumbsup' ); ?></label>
			<input <?php checked( $instance[ 'show_image_caption'] ,'1' ); ?>  type='radio' name='<?php echo esc_attr($widget->get_field_name( 'show_image_caption' ) ); ?>'  id='<?php echo esc_attr($widget->get_field_id( 'show_image_caption_yes' ) ); ?>' value='1'  />&nbsp;<label for='<?php echo esc_attr($widget->get_field_id( 'show_image_caption_no' ) ); ?>'><?php _e( 'No', 'it-l10n-thumbsup' ); ?></label><input <?php checked( $instance[ 'show_image_caption'] ,'0' ); ?> type='radio' name='<?php echo esc_attr($widget->get_field_name( 'show_image_caption' ) ); ?>'  id='<?php echo esc_attr($widget->get_field_id( 'show_image_caption_no' ) ); ?>' value='0' />
		</p>
		<p><?php _e( 'Show Image Description', 'it-l10n-thumbsup' ); ?><br />
			<label for='<?php echo esc_attr($widget->get_field_id( 'show_image_desc_yes' ) ); ?>'><?php _e( 'Yes', 'it-l10n-thumbsup' ); ?></label>
			<input <?php checked( $instance[ 'show_image_desc'] ,'1' ); ?> type='radio' name='<?php echo esc_attr($widget->get_field_name( 'show_image_desc' ) ); ?>'  id='<?php echo esc_attr($widget->get_field_id( 'show_image_desc_yes' ) ); ?>' value='1'   />&nbsp;<label for='<?php echo esc_attr($widget->get_field_id( 'show_image_desc_no' ) ); ?>'><?php _e( 'No', 'it-l10n-thumbsup' ); ?></label><input <?php checked( $instance[ 'show_image_desc'] ,'0' ); ?> type='radio' checked="checked" name='<?php echo esc_attr($widget->get_field_name( 'show_image_desc' ) ); ?>'   id='<?php echo esc_attr($widget->get_field_id( 'show_image_desc_no' ) ); ?>' value='0' />
		 </p>
	
	</div><!--/#pb_thumbsup_videos-->
	<!--/Images-->
    <?php
	endif;
	endif;
} //end pb_thumbsup_widget_output
function pb_thumbsup_widget_validate( $instance ) {

	$instance[ 'title' ] = strip_tags( $instance[ 'title' ] );
	$instance[ 'group_id' ] = isset( $instance[ 'group_id' ] ) ? absint( $instance[ 'group_id' ] ) : 0;
	$instance[ 'thumb_width' ] = isset( $instance[ 'thumb_width' ] ) ? absint( $instance[ 'thumb_width' ] ) : 200;
	$instance[ 'thumb_height' ] = isset( $instance[ 'thumb_height' ] ) ? absint( $instance[ 'thumb_height' ] ) : 200;

	$instance[ 'video_max_height' ] = isset( $instance[ 'video_max_height' ] ) ? absint( $instance[ 'video_max_height' ] ) : 300;
	$instance[ 'video_max_width' ] = isset( $instance[ 'video_max_width' ] ) ? absint( $instance[ 'video_max_width' ] ) : 300;
	$instance[ 'show_item_title' ] = isset( $instance[ 'show_item_title' ] ) ? absint( $instance[ 'show_item_title' ] ) : 1;
	$instance[ 'show_group_title' ] = isset( $instance[ 'show_group_title' ] ) ? absint( $instance[ 'show_group_title' ] ) : 1;
		
	$instance[ 'show_group_desc' ] = isset( $instance[ 'show_group_desc' ] ) ? absint( $instance[ 'show_group_desc' ] ) : 0;
	
	$instance[ 'show_image_caption' ] = isset( $instance[ 'show_image_caption' ] ) ? absint( $instance[ 'show_image_caption' ] ) : 0;
	$instance[ 'show_image_desc' ] = isset( $instance[ 'show_image_desc' ] ) ? absint( $instance[ 'show_image_desc' ] ) : 0;
	
	//Validate booleans
	$bools = array( 'show_item_title', 'show_group_title', 'show_group_desc', 'show_image_caption', 'show_image_desc' );
	foreach ( $bools as $key ) {
		if ( $key != 1 && $key != 0 ) {
			$instance[ $key ] = 0;
		}
	}

	
	//Validate orderby
	$instance[ 'orderby' ] = isset( $instance[ 'orderby' ] ) ? strip_tags( $instance[ 'orderby' ] ) : 'menu_order';
	$orderby = array( 'menu_order', 'rating', 'rand', 'date' );
	if ( !in_array( $instance['orderby'], $orderby ) ) $instance[ 'orderby' ] = 'menu_order';
	
	//Validate order
	$instance[ 'order' ] = isset( $instance[ 'order' ] ) ? strip_tags( $instance[ 'order' ] ) : 'DESC';
	$order = array( 'ASC', 'DESC' );
	if ( !in_array( $instance['order'], $order ) ) $instance[ 'order' ] = 'DESC';
		
	return $instance;
}
function pb_thumbsup_getwidget_defaults() {
	return array(
					'display' => 'both',
					'group_id' => 0,
					'title' => 'Thumbs Up',
					'thumb_width' => 200,
					'thumb_height' => 200,
					'video_max_height' => 300,
					'video_max_width' => 300,
					'show_item_title' => 1,
					'show_group_title' => 1,
					'show_group_desc' => 0,
					'show_image_caption' => 0,
					'show_image_desc' => 0,
					'orderby' => 'menu_order',
					'order' => 'DESC'
				);
} //end pb_thumbsup_getwidget_defaults

//POST TYPE THUMBSUP WIDGETS
class pb_thumbsup_posts_widget	 extends WP_Widget {		
			var $parent = false;
			function pb_thumbsup_posts_widget(){ 
				global $pb_thumbsup;
				$this->parent = $pb_thumbsup;
				
				//Widget init
				$widget_ops = array('description' => __( 'Allows you to show popular posts.' , 'it-l10n-thumbsup' ) );
				//Create widget
				$this->WP_Widget('pb_thumbsup_posts', __( 'ThumbsUp Posts', 'it-l10n-thumbsup' ), $widget_ops);
			} //end constructor
						
			// widget - Displays the widget
			public function widget($args, $instance) {
				extract($args, EXTR_SKIP);				
				
				echo $before_widget;
				$title = empty($instance['title']) ? __( 'Popular Posts', 'it-l10n-thumbsup' ) : apply_filters('widget_title', $instance['title']);
				$post_type = empty( $instance[ 'post_type' ] ) ? 'post' : $instance[ 'post_type' ];
				$limit = empty( $instance[ 'limit' ] ) ? 10 : absint( $instance[ 'limit' ] );
				
				if ( !empty( $title ) ) {
					echo $before_title . $title . $after_title;
				};
				
				//Get Posts and show them!
				global $current_user, $current_blog, $post, $wpdb;
				$site_id = $blog_id = 1;
				if ( is_multisite() ) {
					$site_id = $current_blog->site_id;
					$blog_id = $current_blog->blog_id;
				}
				$tablename = $this->parent->get_tablename();
				
				$sql = "select * from {$tablename} where site_id = {$site_id} and blog_id = {$blog_id} and post_type = '{$post_type}' ORDER BY rating DESC limit {$limit}";
				$results = $wpdb->get_results( $sql );
				if ( $results ) {
					$post_ids = array();
					$post_stats = array();
					foreach ( $results as $key => $data ) {
						array_push( $post_ids, $data->content_id );
						$post_stats[ $data->content_id ] = array(
							'up_votes' => $data->up_votes,
							'down_votes' => $data->down_votes
						);
					}
					global $post;
					$temp_post = is_object( $post ) ? $post : false;
					$posts = get_posts( array(
						'post_type' => $post_type,
						'post__in' => $post_ids,
					) );
					update_post_cache( $posts );
					//We use this to cache the posts, but they're not sorted correctly.
					//Since they're cached, we can use get_post( id ) without doing anymore queries
					echo "<ul>";
					foreach ( $post_ids as $id ) {
						$post = get_post( $id );
						setup_postdata( $post );
						$up_votes = $post_stats[ get_the_ID() ][ 'up_votes' ];
						?>
						<li><a href='<?php echo esc_url( get_permalink() ); ?>'><?php the_title(); ?></a> - <?php echo number_format( $up_votes ); echo ' ' . _n( 'Vote', 'Votes', $up_votes, 'it-l10n-thumbsup' );?>
						</li>
						<?php
					}
					if ( $temp_post ) {
						$post = $temp_post;
						setup_postdata( $post );
					}
					echo "</ul>";
				} else {
					_e( 'No results.', 'it-l10n-thumbsup' );
				}
				
				echo $after_widget;
			} //end widget
			
			private function get_defaults() {
				return array(
					'title' => 'Popular Posts',
					'limit' => '10',
					'post_type' => 'post'
				);
			} //end get_defaults
			
			//Updates widget options
			public function update( $new, $old ) {
				$instance = $new;
				$instance[ 'title' ] = strip_tags( $instance[ 'title' ] );
				$instance[ 'limit' ] = absint( $instance[ 'limit' ] );
				$instance[ 'post_type' ] = strip_tags( $instance[ 'post_type' ] );
				return $instance;
			} //end update
						
			//Widget form
			public function form($instance) {
				$defaults = $this->get_defaults();

				$instance = wp_parse_args( (array)$instance, $defaults );
				if ( empty( $instance['title'] ) ) $instance['title'] = $defaults['title'];
				if ( empty( $instance['limit'] ) ) $instance[ 'limit' ] = $defaults[ 'limit' ];
               	?>
				<p>
				<label for="<?php echo $this->get_field_id( 'title' ); ?>">Widget Title</label> <br />
				<input class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo esc_attr( $instance[ 'title' ] ); ?>" />
				</p>
				<p>
				<label for="<?php echo $this->get_field_id( 'limit' ); ?>">Post Limit</label> <br />
				<input class="widefat" id="<?php echo $this->get_field_id( 'limit' ); ?>" name="<?php echo $this->get_field_name( 'limit' ); ?>" type="text" value="<?php echo esc_attr( $instance[ 'limit' ] ); ?>" />
				</p>
				<p>
				<label for="<?php echo $this->get_field_id( 'post_type' ); ?>">Post Type</label> <br />
				<?php
				$post_types = get_post_types( array(
                                		'publicly_queryable' => true,
                                		'show_ui' => true,
                                		'public' => true
                                	), 'objects' );
                    if ( $post_types ) {
	                    ob_start();
	                    foreach ( $post_types as $key => $post_type ) {
	                    	$label = isset( $post_type->labels->name ) ? $post_type->labels->name : $key;	
	                    	?>
	                    	<option value='<?php echo esc_attr( $key ); ?>' <?php selected( $instance[ 'post_type' ], $key ); ?>><?php echo esc_html( $label ); ?></option>
	                    	<?php
	                    } //end foreach post_types
	                    $select = ob_get_clean();
	                    ?>
	                    <select  id="<?php echo $this->get_field_id( 'post_type' ); ?>" name="<?php echo $this->get_field_name( 'post_type' ); ?>">
	                    <?php echo $select; ?>
	                    </select>
	               <?php
	               }
	               ?>
				</p>
               	<?php
			    //ouput form
			}//End function form
			
}//End pb_thumbsup_posts_widget
add_action('widgets_init', create_function('', 'return register_widget("pb_thumbsup_posts_widget");') );

//Start Suggest Widget
//POST TYPE THUMBSUP WIDGETS
class pb_thumbsup_suggest_widget	 extends WP_Widget {		
			var $parent = false;
			function pb_thumbsup_suggest_widget(){ 
				global $pb_thumbsup;
				$this->parent = $pb_thumbsup;
				
				//Widget init
				$widget_ops = array('description' => __( 'Allows you to allow users to suggest topics.' , 'it-l10n-thumbsup' ) );
				//Create widget
				$this->WP_Widget('pb_thumbsup_suggest', __( 'ThumbsUp Suggest', 'it-l10n-thumbsup' ), $widget_ops);
				
				if ( is_active_widget(false, false, $this->id_base, true) ) {
					$pb_thumbsup->add_post_scripts( true );
				}
			} //end constructor
						
			// widget - Displays the widget
			public function widget($args, $instance) {
				extract($args, EXTR_SKIP);				
				
				echo $before_widget;
				$title = empty($instance['title']) ? __( 'Suggest a Topic', 'it-l10n-thumbsup' ) : apply_filters('widget_title', $instance['title']);
							
				if ( !empty( $title ) ) {
					echo $before_title . $title . $after_title;
				};
				$widget_id = esc_attr( $this->id . '-form' ); 
				$ajax_args = array(
					'action' => 'pb_thumbsup_suggest',
					'_ajax_nonce' => wp_create_nonce( 'pb_thumbsup_suggest_add' ),
					'widget_id' => $widget_id
				);
				$ajax_url = add_query_arg( $ajax_args, admin_url( 'admin-ajax.php' ) );
				if ( isset( $instance[ 'group_id' ] ) && $instance[ 'group_id' ] > 0 ) :
				
				?>
<div id='<?php echo $widget_id; ?>'>
<form action='<?php echo esc_url( $ajax_url ); ?>' method='post' onsubmit='jQuery.pb_thumbsup.suggest( this ); return false;'>
<p>
		<input type='hidden' name='thumbsup_group_id'  value='<?php echo esc_attr( absint( $instance[ 'group_id' ] ) ); ?>' />
		<label for='<?php echo esc_attr( $this->get_field_id( 'text_topic' ) ); ?>'><?php esc_attr_e( 'Topic', 'it-l10n-thumbsup' ); ?></label>&nbsp;&nbsp;
		<input type='text' class='field' id='' name='thumbsup_suggest_topic' /></p>
<p><input type='submit' value='<?php esc_attr_e( 'Suggest', 'it-l10n-thumbsup' ); ?>' name='thumbsup_submit' /></p>
</form>
</div>
				
											
				<?php
				endif; //group id check
				
				
				
				echo $after_widget;
			} //end widget
			
			private function get_defaults() {
				return array(
					'title' => 'Suggest a Topic',
					'group_id' => 0,
					'logged_in' => "true",
				);
			} //end get_defaults
			
			//Updates widget options
			public function update( $new, $old ) {
				$instance = wp_parse_args( $new, $this->get_defaults() );
				
				$instance[ 'title' ] = strip_tags( $instance[ 'title' ] );
				$suggest_widgets = $this->parent->get_admin_option( 'suggest_widgets' );
				if ( !is_array( $suggest_widgets ) ) $suggest_widgets = array();
				$suggest_widgets[ $this->id ] = $instance;
				$this->parent->save_admin_option( 'suggest_widgets', $suggest_widgets );
				return $instance;
			} //end update
						
			//Widget form
			public function form($instance) {
				global $pb_thumbsup;
				$defaults = $this->get_defaults();

				$instance = wp_parse_args( (array)$instance, $defaults );
				if ( empty( $instance['title'] ) ) $instance['title'] = $defaults['title'];
				?>
				<?php if ( $instance[ 'group_id' ] == 0 ) : ?>
				<div style="background-color: #FFEBE8; border: 1px solid #CC0000; border-radius: 3px; margin: 5px 0 15px; padding: 0 0.6em;" ><p style='margin: 0.5em 0; padding: 2px;'><strong><?php esc_html_e( 'You must select a voting group for the widget to display.', 'it-l10n-thumbsup' ); ?></strong></p></div>
				<?php endif; ?>

				<p>
				<label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php esc_html_e( 'Widget Title', 'it-l10n-thumbsup' ); ?></label> <br />
				<input class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo esc_attr( $instance[ 'title' ] ); ?>" />
				</p>
				<p><?php _e( 'Select a voting group', 'it-l10n-thumbsup' ); ?></p>
               	<?php
               	$group_args = array( 
					'numberposts' => -1,
					'posts_per_page' => -1, 
					'post_type' => 'it_voting_group',
					'order' => 'ASC',
					'orderby' => 'title',
					'meta_key' => 'media_type',
					'meta_value' => 'topics',
					'meta_compare' => '='
				);
				$voting_groups = get_posts( $group_args );
				if ( !$voting_groups || count( $voting_groups ) == 0 ) :
					?>
					<p><?php _e( 'There is nothing to add yet.', 'it-l10n-thumbsup' ); ?></p>
					<?php
				else:
				?>
				
								<select id="<?php echo esc_attr($this->get_field_id( 'group_id' ) ); ?>" name="<?php echo esc_attr($this->get_field_name( 'group_id' ) ); ?>">
					<option value="">  <?php _e("Select a Voting Group to Add", 'it-l10n-thumbsup' ); ?>  </option>
					<?php
						foreach($voting_groups as $group) {
							?>
							<option  <?php selected( $instance[ 'group_id' ], $group->ID ); ?> rel="<?php echo esc_attr( get_post_meta( $group->ID, 'media_type', 1 ) ); ?>" value="<?php echo absint( $group->ID ) ?>"><?php echo esc_html( stripslashes( apply_filters( 'get_the_title', $group->post_title ) ) ) ?></option>
							<?php
						} //end foreach groups
					?>
				</select>
				<p><?php _e( 'Logged in Users Only?', 'it-l10n-thumbsup' ); ?></p>
				<select id="<?php echo esc_attr( $this->get_field_id( 'logged_in' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'logged_in' ) ); ?>" >
					<option value='true' <?php selected( $instance[ 'logged_in' ], 'true' ); ?>>Yes</option>
					<option value='false' <?php selected( $instance[ 'logged_in' ], 'false' ); ?>>No</option>
				</select>
		<?php
			    //ouput form
			    endif;
			}//End function form
			
}//End pb_thumbsup_posts_widget
add_action('widgets_init', create_function('', 'return register_widget("pb_thumbsup_suggest_widget");') );

?>
