jQuery(document).ready(function() {
	
	var $ = jQuery;
	//Initialize date/time picker
	$('#timepicker').timepicker();
	$( "#datepicker" ).datepicker({ minDate: +1 });
	
	/******** ADD NEW GROUP **********/
	//Initialize add_new events
	//Voting expiration radio group
	if ( $( '#voting_expire_yes' ).is( ':checked' ) ) {
		$( "#date_time_picker" ).removeClass( "hidden" );
	}
	$( 'input[name="voting_expire"]' ).bind( 'click', function() {
		var val = $(this).val();
		if ( val == 'false' ) {
			$( "#date_time_picker" ).addClass( "hidden" );
		} else {
			$( "#date_time_picker" ).removeClass( "hidden" );
		}
	} );
	//Capture form data
	$( "form#voting_group_form" ).bind( "submit", function() {
		//Disable save button
		$( "#save_group" ).val( pb_thumbsup.saving ).attr( "disabled", "disabled" );
		
		//Clear errors and hide elements
		$( "#save_ajax_loader" ).removeClass( "hidden" );
		$( "#group_title, p#add_new_status" ).removeClass( 'error' );
		$( "#group_title_error, p#add_new_status" ).addClass( 'hidden' );
		
		//Get into Ajax format
		var form_data = $( this ).serializeArray();
		form_data = $.param(form_data);	
		
		//Do ajax
		$.post( ajaxurl, { action: 'submit_voting_group', ajax_form_data: form_data, _ajax_nonce: $('#_thumbsup').val() },
			function( response ){
				if ( typeof response.validation_error != 'undefined' ) {
					$( "#group_title" ).addClass( 'error' );
					$( "#group_title_error" ).removeClass( 'hidden' );
					$( "#save_ajax_loader" ).addClass( "hidden" );
					$( "#save_group" ).val( pb_thumbsup.save ).removeAttr( "disabled" );
				} else if ( typeof response.save_error != 'undefined' ) {
					$( "p#add_new_status" ).html( response.save_error ).addClass( "error" ).removeClass( "hidden" );
					$( "#save_ajax_loader" ).addClass( "hidden" );
					$( "#save_group" ).val( pb.thumbsup.save ).removeAttr( "disabled" );
				} else if ( response.action == 'edit' ) {
					//We just created a new group - re-submit the form to move to the edit screen
					$( "#post_id" ).val( response.post_id );
					$( "form#voting_group_form" ).unbind( "submit" ).submit();
				} else {
					//We're saving the form after editing	
					$( "#save_ajax_loader" ).addClass( "hidden" );
					$( "#save_group" ).val( pb_thumbsup.save ).removeAttr( "disabled" );
					//Update and show preview fields
					$( "#group_preview_title").html( response.title );
					$( "#group_preview_content").html( response.content );
					$( "#group_preview_expiration").html( response.expiration_display );
					$( '#group_quick_edit' ).fadeOut( 'slow', function() {
						$( '#group_preview, input#group_edit' ).removeClass( 'hidden' );
					} );
				}
				
			} //end ajax response
		,'json' ); //end ajax
		
		return false;
	}); //end form submission
	/******** END ADD NEW GROUP **********/
	/************************************************/
	/************************************************/
	
	
	/******** EDIT GROUP ************/
	//Show quick edit screen
	$( 'input#group_edit' ).bind( 'click', function() {
		$( '#group_preview, input#group_edit' ).addClass( 'hidden' );
		$( '#group_quick_edit' ).fadeIn();
	} );
	//Close button for quick edit screen
	$( 'input#close_group ').bind( 'click', function() {
		$( '#group_quick_edit' ).fadeOut( 'slow', function() {
			$( '#group_preview, input#group_edit' ).removeClass( 'hidden' );
		} );												 
	} );
	/******** END EDIT GROUP *****/
	
	/******** ADD NEW ITEM *****************/
	//Capture form data
	$( "form#voting_group_item" ).bind( "submit", function() {
		//Disable save button
		$( "#save_item" ).val( pb_thumbsup.saving ).attr( "disabled", "disabled" );
		
		//Clear errors and hide elements
		$( "#save_ajax_item_loader" ).removeClass( "hidden" );
		$( "#item_title, p#add_new_item_status, #item_video_url" ).removeClass( 'error' );
		$( "#item_title_error, p#add_new_item_status, p#item_video_url_error" ).addClass( 'hidden' );
		
		//Get into Ajax format
		var form_data = $( this ).serializeArray();
		form_data = $.param(form_data);	
		
		//Do ajax
		$.post( ajaxurl, { action: 'submit_voting_item', ajax_form_data: form_data, _ajax_nonce: $('#_thumbsupitem').val() },
			function( response ){
				if ( typeof response.errors != 'undefined' ) {
					$.each( response.errors, function() {
						$( "#"  + this.field ).addClass( 'error' );
						$( "#" + this.field + "_error" ).html( this.message );
						$( "#" + this.field + "_error" ).removeClass( 'hidden' );							  
					} );
					$( "#save_ajax_item_loader" ).addClass( "hidden" );
					$( "#save_item" ).val( pb_thumbsup.save ).removeAttr( "disabled" );
				} else if ( typeof response.save_error != 'undefined' ) {
					$( "p#add_new_item_status" ).html( response.save_error ).addClass( "error" ).removeClass( "hidden" );
					$( "#save_ajax_item_loader" ).addClass( "hidden" );
					$( "#save_item" ).val( pb_thumbsup.add_new_item ).removeAttr( "disabled" );
				} else {
					//Total success - Update the interface
					$( "#add_voting_item" ).html( pb_thumbsup.add_voting_item );
					$( "#cancel_save_item" ).addClass( "hidden" );
					$( "#save_ajax_item_loader" ).addClass( "hidden" );
					$( "#save_item" ).val( pb_thumbsup.add_new_item ).removeAttr( "disabled" );
					$( "#item_title, #item_video_url, #item_description" ).val( '' );
					$( "#item_id, #attachment_id, #updating" ).val( "0" );
					
					//Update Media Interface (if applicable)
					if ( $( "#thumbnail_upload ").length > 0 ) {
						$( "#voting_group_item").fadeOut( "slow", function() {
							$( "#thumbnail_upload" ).fadeIn();		
							$( "#image_caption, #image_description" ).val( '' );
						} );
					}
					
					if ( response.updating ) {
						//Replace the HTML
						$( "#voting_item_" + response.post_id ).replaceWith( response.html );
						//Scroll uuuuuup
						$( "html, body" ).animate({ scrollTop: $("#voting_item_" + response.post_id).offset().top -40 });

						
					} else {
						//Append the HTML
						$( "#group_items" ).append( response.html );
					}
					
					//Update the menu_order
					$( "#menu_order" ).val( response.menu_order );
				}
				
			} //end ajax response
		 , 'json' ); //end ajax
		
		return false;
	}); //end form submission
	/******** END ADD NEW ITEM **********/
	
	/******** SET UP SORTING FOR ITEMS ********/
	// Sort Tracks
	$( "#group_items" ).sortable({
		update: function(event, ui) {
			var post_ids = $( this ).sortable( 'toArray' ).toString();
			//start ajax
			$.post( ajaxurl, { action: 'sort_voting_items', post_ids: post_ids },
			function( response ){
				$( "#menu_order" ).val( response.menu_order );
			}, 'json' );
			//end ajax
			
		} /* end update */
	}); //end sortable
	/******** END SORTING FOR ITEMS **********/
	
	/******** SET UP AJAX MEDIA UPLOAD ******/   
	jQuery( "#thumbnail_upload" ).submit( function() {
		var ajaxoptions = { 
			beforeSubmit:	function( formData, jqForm, options ) {
				$( "#submit_ajax" ).attr( "disabled", "disabled" ).val( pb_thumbsup.uploading );
			},     // pre-submit callback 
			success:	function( response, status, xhr, $form ) {
				$( "#submit_ajax" ).removeAttr( "disabled" ).val( pb_thumbsup.upload_image );
				if ( typeof response.error != 'undefined' ) {
					alert( response.error );
					return;
				}
				//Update and show form
				$( "#item_title" ).val( response.title );
				$( "#item_image_thumbnail" ).html( "<img src='" + response.image[0] + "' width='" + response.image[1] + "' height='" + response.image[2] + "' />" );
				$( "#item_id" ).val( response.item_id );
				$( "#attachment_id").val( response.attachment_id );
				
				$( "#thumbnail_upload" ).fadeOut( "slow", function() {
					$( "#voting_group_item" ).fadeIn();												   
				} );
			},
			dataType: 'json',
			resetForm: true
		}; 
		jQuery( this ).ajaxSubmit(ajaxoptions); 
		return false;
	} );
	/******** END AJAX MEDIA UPLOAD *********/
	
	$.pb_thumbsup = {
		cancel_edit: function() {
			$( "#add_voting_item" ).html( pb_thumbsup.add_voting_item );
			$( "#cancel_save_item" ).addClass( "hidden" );
			//Clear fields
			$( "#save_ajax_item_loader" ).addClass( "hidden" );
			$( "#save_item" ).val( pb_thumbsup.add_new_item ).removeAttr( "disabled" );
			$( "#item_title, #item_video_url, #item_description, #image_caption, #image_description" ).val( '' );
			$( "#item_id, #attachment_id, #updating" ).val( "0" );
			//Show media field
			if ( $( "#thumbnail_upload" ).length > 0 ) {
				$( "#voting_group_item" ).fadeOut( "slow" , function() {
					$( "#item_title, #item_video_url, #item_description, #image_caption, #image_description" ).val( '' );
					$( "#thumbnail_upload" ).fadeIn();
				} );
			}
			
		}, /* end cancel_edit */
		delete_item: function( post_id, nonce ) {
			//Start ajax
			$.post( ajaxurl, { action: 'delete_voting_item', post_id: post_id, _ajax_nonce: nonce },
			function( response ){
				if ( response.deletion_status == true ) {
					$( "li#voting_item_" + response.post_id ).fadeOut( "slow", function() { $( this ).remove(); } );
					
					//If deleting an item that is being edited, clear the ID
					if ( $( "#item_id" ).val() == post_id ) {
						$( "#item_id, #attachment_id, #updating" ).val( "0" );
						//Show media field
						if ( $( "#thumbnail_upload" ).length > 0 ) {
							$( "#voting_group_item" ).fadeOut( "slow" , function() {
								$( "#item_title, #item_video_url, #item_description, #image_caption, #image_description" ).val( '' );
								$( "#thumbnail_upload" ).fadeIn();
							} );
						} //end if media
					} //end if item_id.val == post_id
					
				} else {
					alert( pb_thumbsup.delete_item_error );	
				}
			}, 'json' ); //end ajax
			return false;
		} /* end delete_item */,
		approve_item: function( post_id, nonce ) {
			//Start ajax
			$.post( ajaxurl, { action: 'approve_voting_item', post_id: post_id, _ajax_nonce: nonce },
			function( response ){
				$( "span#thumbsup_approve_" + response.post_id ).fadeOut( "slow", function() {
					$( "li#voting_item_" + response.post_id ).removeClass( 'draft' );
				} );
			}, 'json' ); //end ajax
			return false;
		} /* end delete_item */,
		edit_item: function( post_id, nonce ) {
			//Start ajax
			$.post( ajaxurl, { action: 'edit_voting_item', post_id: post_id, _ajax_nonce: nonce },
			function( response ){
				//Update Add Voting Item interface to reflect editing
				$( "#add_voting_item" ).html( pb_thumbsup.edit_voting_item );
				$( "#cancel_save_item" ).removeClass( "hidden" );
				
				if ( typeof response.errors != 'undefined' ) { alert( pb_thumbsup.edit_item_error ); return; }
				var media_type = response.media_type;
				var item_id = response.item_id;
				
				//Global
				$( "#menu_order" ).val( response.menu_order );
				$( "#item_title" ).val( response.item_title );
				$( "#item_id" ).val( response.item_id );
				$( "#post_status" ).val( response.post_status );
				$( "#updating" ).val( "1" );
				$( "#save_item" ).val( pb_thumbsup.save );
				
				//Images
				if ( media_type == 'images' ) {
					$( "#thumbnail_upload" ).hide();
					$( "#item_image_thumbnail").html( response.voting_item_thumbnail );
					$( "#image_description" ).val( response.image_description );
					$( "#image_caption" ).val( response.image_caption );
					$( "#attachment_id" ).val( response.attachment_id );
					$( "#voting_group_item" ).show();
				} //end if media_type images
				
				//Videos
				if ( media_type == 'videos' ) {
					$( "#item_video_url" ).val( response.item_video_url );
				} //end if media_type videos
				
				//Topics
				if ( media_type == 'topics' ) {
					$( "#item_description" ).val( response.item_description );
				}
				
				//Scroll doooown
				$( "html, body" ).animate({ scrollTop: $("#voting_group_item").offset().top -40 });

			}, 'json' ); //end ajax
			return false;
		} /* end edit_item */
	};
	
});
