jQuery(document).ready(function() {
	var $ = jQuery;
	$.pb_thumbsup = {
		suggest: function( element ) {
			var form_data = $( element ).serializeArray();
			form_data = $.param(form_data);	
			
			var ajax_url = $( element ).attr( 'action' );
			var url_args = $.pb_thumbsup.unserialize( ajax_url );
			var widget_id = url_args.widget_id;
			
			//Hide form interface
			$( "#" + widget_id ).fadeOut( "slow", function() {
				$( this ).html( thumbsup.saving ).show();
			} );
			//Do ajax
			$.post( ajax_url, { action: url_args.action, ajax_form_data: form_data, _ajax_nonce: url_args._ajax_nonce },
				function( response ){
					$( "#" + widget_id ).fadeOut( "slow", function() {
						$( this ).html( thumbsup.suggest_thanks ).show();
					} );			
				} //end ajax response
			, 'json' ); //end ajax*/
		},
		vote: function( element, vote ) {
			var ajax_url = $( element ).attr( 'href' );
			var url_args = $.pb_thumbsup.unserialize( ajax_url );
			
			//Stop an Ajax request if the item is already selected
			if ( jQuery( element ).hasClass( "pb_thumbsup_selected" ) || jQuery( element).hasClass( "pb_thumbsdown_selected" ) ) {
				return false;
			}
			
			
			//Start ajax
			$.post( ajax_url, { action: 'pb_thumbs_up', item_id: url_args.item_id, thumbsup: vote },
			function( response ){
				//console.log( response );// return;
				//Output any errors
				if ( typeof response.error != 'undefined' ) {
					//alert( response.error );	
					return;
				}
				//Update thumb images
				if ( response.thumbsup == true ) {
					$( "a#pb_thumbsdown_icon_" + response.item.id ).removeClass( "pb_thumbsdown_selected" );
					$( "a#pb_thumbsup_icon_" + response.item.id ).addClass( "pb_thumbsup_selected" );
				} else {
					$( "a#pb_thumbsup_icon_" + response.item.id ).removeClass( "pb_thumbsup_selected" );
					$( "a#pb_thumbsdown_icon_" + response.item.id ).addClass( "pb_thumbsdown_selected" );
				}
				//Update thumb stats
				$( "div#pb_thumbsup_vote_stats_" + response.item.id + " .plus" ).html( response.up_count );
				$( "div#pb_thumbsup_vote_stats_" + response.item.id + " .minus" ).html( response.down_count );
				
				
				//Show stats
				$( "div#pb_thumbsup_vote_stats_" + response.item.id ).addClass( 'pb_thumbsup_display_stats' );	
				
				//Update post view if applicable
				if ( typeof thumbsup != 'undefined' ) {
					if ( thumbsup.post_display == 'both' || thumbsup.post_display == 'up' ) {
						if ( response.up_count == 1 ) {
							$( '#pb_thumbsup_like_' + response.item.id ).html( thumbsup.person_up );
						} else {
							$( '#pb_thumbsup_like_' + response.item.id ).html( thumbsup.people_up );
						}
					} else {
						if ( response.down_count == 1 ) {
							$( '#pb_thumbsup_like_' + response.item.id ).html( thumbsup.person_down );
						} else {
							$( '#pb_thumbsup_like_' + response.item.id ).html( thumbsup.people_down );
						}
					}
				}			
			}, 'json' ); //end ajax
			return false;
		},
		unserialize: function( s ) {
			var r = {}, q, pp, i, p;
			if ( !s ) { return r; }
			q = s.split('?'); if ( q[1] ) { s = q[1]; }
			pp = s.split('&');
			for ( i in pp ) {
				if ( jQuery.isFunction(pp.hasOwnProperty) && !pp.hasOwnProperty(i) ) { continue; }
				p = pp[i].split('=');
				r[p[0]] = p[1];
			}
			return r;
		}
	}; //end $.fn.pb_thumbsup
});
